<?php

/* 
 *	W-AGORA 3.0
 *	-----------
 *	$Id: create_forum.php3,v 1.4 2001/01/30 09:12:15 mdruilhe Exp $
 *	Usage:		Create a new forum
 *	Author:		Marc Druilhe <mdruilhe@w-agora.com>
 *
 */

if (empty($site)) {
	die ("site not specified");
}

$bn="admin_$site";
require ("init_admin.inc");

/* Load site administration configuration */
require ("$site_cfg_file");	
require ("$bn_dir/$bn_fields");
require ("$bn_dir/$bn_msgs");

/* If Creation form have been submitted */
if (isset($do_install)) {

	echo "<HEAD><TITLE>w-agora administration - new forum </TITLE></HEAD>\n<BODY>\n";
	$do_install=0;

	if (empty ($passwd1) || ($passwd1 != $passwd2)) {
		MsgForm ("password must be set and must be entered twice, please verify", "$WA_SELF?site=$site", "back");
		exit;
	}

	/* Check for required fields */
	while (list($field, $required) = each($bn_bind_var)) {
		if ($required && !$$field) {
			$mess = "$field : " . Msg(5);
			MsgForm ("$mess", "$WA_SELF", "back");
			exit;
		}
	}

	$bn_name = ereg_replace ("[^[:alnum:]]+", "", stripSlashes(strtolower($bn_name)));

	if (empty ($bn_dir_forums))
		$bn_dir_forums = "./forums"; // !!! path relative to w-agora directory !!!

	$bn = $site . "_". $bn_name;

	// Check max size
	if (strlen ($bn) > ( (int)$bn_var_size["bn_name"])) {
		MsgForm ("forum name is too long, please choose a shorter one", "$WA_SELF", "back");
		exit;
	}

	$cfg_file = "${cfg_dir}/${bn}.${ext}";

	/* Check if forum already exists */
	if (file_exists ("$cfg_file")) {
		MsgForm ("Configuration file ($cfg_file) already exists, you must delete it manually or choose another name", "$WA_SELF?site=$site", "back");
		echo "</BODY>\n</HTML>";
		exit;
	}

	/* initialize configuration values */
	$bn_title="$descr";
	$bn_dir="${bn_dir_forums}/${site}/${bn_name}";
	$bn_dir_notes="$bn_dir/notes";
	$bn_db=$bn;
	$bn_owner=$owner;
	$bn_admin_address=$owner_address;
	$bn_auto_url = 1;

	include ("$tmpl_dir/$theme/conf.php3");

	echo "<CENTER>";

	//  Create Configuration File
	echo ("<b>creating configuration file...</b><br><br>"); flush();
	$conf = new Config;
	$ret = $conf->open("$cfg_file");
	if (!$ret) {
		MsgForm ("Cannot create configuration file , check permissions", "$WA_SELF?site=$site", "back"); /* access problem */
		exit;
	}
	$conf->writeConfig(&$GLOBALS);
	$conf->close ();

	/* create directories */
	echo ("<b>creating directories...</b><br><br>"); flush();
	echo "<EM>";

	echo ("$bn_dir"); flush();
	if (is_dir ("$bn_dir")) {
		echo " -> already exists";
	} else {
		if (!MkDir ("$bn_dir", _DIRMODE) ) {
			unlink("$cfg_file");
			MsgForm ("unable to create directory: $bn_dir, check permissions", "$WA_SELF?site=$site", "back");
			exit;
		}
	}

	echo ("<br>$bn_dir_notes"); flush();
	if (is_dir ("$bn_dir_notes")) {
		echo " -> already exists<br>";
	} else {
		if (!MkDir ("$bn_dir_notes", _DIRMODE) ) {
			unlink("$cfg_file");
			MsgForm ("unable to create directory: $bn_dir_notes, check permissions", "$WA_SELF?site=$site", "back");
			exit;
		}
	}
	echo "<br>";

	/* Copy all files in new directory */
	$src_dir="$tmpl_dir/$theme";
	$dest_dir=$bn_dir;

	echo ("<b>creating files...</b><br><br>"); flush();
	if (!empty ($bn_header) ) {
		$file=$bn_header;
		echo ("$file<br>"); flush();
		$ret = Copy ("$src_dir/$file", "$dest_dir/$file");
		if (!$ret) {
			/* Unable to copy files */
			unlink("$cfg_file");
			MsgForm (Msg(7), "$WA_SELF?site=$site", "back");
			exit;
		}
	}

	if (!empty ($bn_footer) ) {
		$file=$bn_footer;
		echo ("$file<br>"); flush();
		$ret = Copy ("$src_dir/$file", "$dest_dir/$file");
		if (!$ret) {
			unlink("$cfg_file");
			/* Unable to copy files */
			MsgForm (Msg(7), "$WA_SELF?site=$site", "back");
			exit;
		}
	}

	if (!empty ($bn_msgs) ) {
		$file=$bn_msgs;
		echo ("$file<br>"); flush();
		$ret = Copy ("$src_dir/$file", "$dest_dir/$file");
		if (!$ret) {
			unlink("$cfg_file");
			/* Unable to copy files */
			MsgForm (Msg(7), "$WA_SELF?site=$site", "back");
			exit;
		}
	}
	
	if (!empty ($bn_form) ) {
		$file=$bn_form;
		echo ("$file<br>"); flush();
		$ret = Copy ("$src_dir/$file", "$dest_dir/$file");
		if (!$ret) {
			unlink("$cfg_file");
			/* Unable to copy files */
			MsgForm (Msg(7), "$WA_SELF?site=$site", "back");
			exit;
		}
	}

	if (empty ($bn_fields) ) {
		include "templates/default/fields.$ext";
	} else {
		$file=$bn_fields;
		include "$src_dir/$bn_fields";
		echo ("$file<br>"); flush();
		$ret = Copy ("$src_dir/$file", "$dest_dir/$file");
		if (!$ret) {
			unlink("$cfg_file");
			/* Unable to copy files */
			MsgForm (Msg(7), "$WA_SELF?site=$site", "back");
			exit;
		}
	}

	if (!empty ($bn_list_vars) ) {
		$file=$bn_list_vars;
		echo ("$file<br>"); flush();
		$ret = Copy ("$src_dir/$file", "$dest_dir/$file");
		if (!$ret) {
			unlink("$cfg_file");
			/* Unable to copy files */
			MsgForm (Msg(7), "$WA_SELF?site=$site", "back");
			exit;
		}
	}

	if (!empty ($bn_template) ) {
		$file=$bn_template;
		echo ("$file<br>"); flush();
		$ret = Copy ("$src_dir/$file", "$dest_dir/$file");
		if (!$ret) {
			unlink("$cfg_file");
			/* Unable to copy files */
			MsgForm (Msg(7), "$WA_SELF?site=$site", "back");
			exit;
		}
	}

	if (!empty ($bn_before_access) ) {
		$file=$bn_before_access;
		echo ("$file<br>"); flush();
		$ret = Copy ("$src_dir/$file", "$dest_dir/$file");
		if (!$ret) {
			unlink("$cfg_file");
			/* Unable to copy files */
			MsgForm (Msg(7), "$WA_SELF?site=$site", "back");
			exit;
		}
	}

	if (!empty ($bn_style) ) {
		$file=$bn_style;
		echo ("$file<br>"); flush();
		$ret = Copy ("$src_dir/$file", "$dest_dir/$file");
		if (!$ret) {
			unlink("$cfg_file");
			/* Unable to copy files */
			MsgForm (Msg(7), "$WA_SELF?site=$site", "back");
			exit;
		}
	}

	echo "</EM><BR><BR></CENTER>";

	/* create database */

	$ret = $db->CreateForum ($bn_db, $passwd1);
	if ($ret == -1) {
		if ($bn_access == "dbm")
			MsgForm ("Forum $bn_db already exists,<br> you must delete the DBM file: <em>dbm/$dbname/$bn_db</em><br> [and the lockfile .lck] manually or choose another name", "$WA_SELF?site=$site", "back");
		else
			MsgForm ("The forum's table ($bn_db) already exists in this database ($dbname), you must first drop this table manually or choose another name", "$WA_SELF?site=$site", "back");
		unlink("$cfg_file");
		exit;
	}
	elseif ($ret == -3) {
		if ($bn_access == "dbm")
			MsgForm ("Access problem, could not create DBM file (<em>dbm/$dbname/$bn_db</em>) check space and permissions in the file system", "$WA_SELF?site=$site", "back");
		else
			MsgForm ("Access problem, could not create table (<em>$bn_db</em>) make sure you have created a database named '$dbname' and check access rights", "$WA_SELF?site=$site", "back");
		unlink("$cfg_file");
		exit;
	}
		
	/* initialize search configuration file */
	if (!empty($bn_search_engine) && ($bn_search_engine != "none")) {
		include "$inc_dir/$bn_search_engine.$ext";
		$search->initSearchConf();
	}

	/* restore administration config */
	include ("$site_cfg_file");	
	require ("$bn_dir/$bn_fields");
	
	/* Now Insert entry for this forum in the main table */

	$unixdate = time();
	$fields["unixdate"] = $unixdate;
	$fields["password"] = $passwd1;
	$fields["site"] = $site;
	$fields["bn_name"] = $bn;
	$fields["descr"] = $descr;
	$fields["owner"] = $owner;
	$fields["owner_address"] = $owner_address;

	/* Insert into database */
	if ($key)
		$ret = $db->ThreadNote ($bn_db, $unixdate, $key, $fields);
	else
		$ret = $db->InsertNote ($bn_db, $unixdate, $fields);

	if ($ret < 0) {
		MsgForm (Msg(9), "$WA_SELF?site=$site&key=$key", "back");
		$db->deleteForum ($bn_db, $passwd1);
		unlink("$cfg_file");
		exit;
	}

	/* send mail to administrator */
	if ($bn_mail && !isset($winbox)) {
		$body = $bn_mail_text . "\n-------------------------\n" . $body;
		$rc = @mail ($bn_admin_address, $bn_title, $body,
		      "Reply-To: $username <$useraddress>\nX-Mailer: PHP " . phpversion() . " w-agora 3.0" );
	}

	MsgForm (Msg(39), "./admin.${ext}?site=$site", "", "_top");
	exit;
} // End $do_install

	// Initialize default values then display FORM
	$bn_name = (isset($bn_name)) ? $bn_name : "";
	$key = (isset($key)) ? $key : "";
	$descr = (isset($descr)) ? $descr : "";
	$theme = (isset($theme)) ? $theme : "default";
	$owner = (isset($owner)) ? $owner : $bn_owner;
	$owner_address = (isset($owner_address)) ? $owner_address : $bn_admin_address;

?>

<HEAD>
 <TITLE>w-agora administration - create forum </TITLE>
 <SCRIPT type="text/javascript" LANGUAGE="JavaScript">
<!-- // Hide for old browsers
  function CheckForm(form) {
<?php
	/* Check for required fields */
	while (list($field, $required) = each($bn_bind_var)) {
		if ($required) {
?>
    if (form.<?echo $field?>.value.length == 0) {
      alert ("<?DspMsg(56)?>");
      form.<?echo $field?>.focus();
      return false;
    }
<?
		}
	}
?>
    return true;
  }
// End of script -->
 </SCRIPT>
</HEAD>
<BODY>
<FORM NAME="form_post" METHOD="post" ACTION="<?echo $WA_SELF?>" onSubmit="return CheckForm(this);" >
 <INPUT TYPE="hidden" NAME="site" VALUE="<?echo $site?>">
 <INPUT TYPE="hidden" NAME="do_install" VALUE="1">
 <INPUT TYPE="hidden" NAME="key" VALUE="<?echo $key?>">

 <H2><CENTER>Install a new forum</CENTER></H2>

 <TABLE BORDER="0" WIDTH="100%" BCOLOR="WHITE">
  <CAPTION><B>Forum's informations</B></CAPTION>
  <TR>
   <TD WIDTH="30%" ALIGN="RIGHT" VALIGN="MIDDLE">Forum's name :</TD>
   <TD>
     <INPUT TYPE="text" NAME="bn_name" SIZE="30" VALUE="<?echo $bn_name;?>">
  </TR>
  <TR>
   <TD WIDTH="30%" ALIGN="RIGHT" VALIGN="MIDDLE">Topic (subject) :</TD>
   <TD><INPUT TYPE="text" NAME="descr" SIZE="50" VALUE="<?echo $descr;?>">
  </TR>
  <TR>
   <TD WIDTH="30%" ALIGN="RIGHT" VALIGN="MIDDLE">Choose a template (theme):</TD>
   <TD>
    <SELECT NAME="theme">
<?
	$dir = dir($tmpl_dir);
	while ($entry=$dir->read() ) {
		if ( is_dir("$tmpl_dir/$entry") && ($entry != ".") && ($entry != "..") && ($entry != "admin") ) {
			$desc="";
			if (file_exists ("$tmpl_dir/$entry/.toc"))
				include "$tmpl_dir/$entry/.toc";
			if (empty($desc))
				$desc=$entry;
			$selected = ($entry == $theme) ? "SELECTED" : "";
			printf ("<OPTION VALUE=\"%s\" %s> %s\n", $entry, $selected, $desc);
		}
	}
	$dir->close();
?>
    </SELECT>
   </TD>
  </TR>
 </TABLE>
 <BR><BR>
 <TABLE BORDER="0" CELLPADDING="2" WIDTH="100%">
  <CAPTION><B>Owner's Informations</B></CAPTION>
  <TR>
   <TD WIDTH="50%" ALIGN="RIGHT"><strong>owner's name (*)</strong> :</TD>
   <TD WIDTH="50%"><INPUT TYPE="TEXT" NAME="owner" SIZE="30" VALUE="<?echo $owner?>"></TD>
  </TR>
  <TR>
   <TD WIDTH="50%" ALIGN="RIGHT"><strong>owner's address (*)</strong>:</TD>
   <TD WIDTH="50%"><INPUT TYPE="TEXT" NAME="owner_address" VALUE="<?echo $owner_address ?>" SIZE="50"></TD>
  </TR>
  <TR>
   <TD WIDTH="50%" ALIGN="RIGHT"><strong>Give a password for this forum (*)</strong> :</TD>
   <TD><INPUT TYPE="PASSWORD" NAME="passwd1" SIZE="10"></TD>
  </TR>
  <TR>
   <TD WIDTH="50%" ALIGN="RIGHT"><strong>Please, reenter the password (*) </strong>:</TD>
   <TD><INPUT TYPE="PASSWORD" NAME="passwd2" SIZE="10"></TD>
  </TR>
 </TABLE>
 <CENTER>
  <INPUT TYPE="submit" VALUE="<? DspMsg(34)?>">
  <INPUT TYPE="reset"  VALUE="<? DspMsg(35)?>">
 </CENTER>
</FORM>
</BODY>
</HTML> 
