<?

/*
 *   W-AGORA 3.0
 *   -----------
 *   $Id: config.php3,v 1.4 2001/01/12 11:51:44 mdruilhe Exp $
 *   Usage:		include file - Configuration class
 *	 Author:	Marc Druilhe <mdruilhe@w-agora.com>
 */

class Config {

var $fd=0;

function open ($file) {

	global $ext;

	if ($this->fd > 0) {
		print ("$file already opened");
		return false;
	}
	
	if (file_exists ("$file"))
		Copy ("$file", "$file.bak.$ext");
	$this->fd = fopen ("$file", "w");
	if (!$this->fd)
		return false;
	fputs ($this->fd, "<?php\n");
	return true;
}

function restore ($file) {
	global $ext;

	if (file_exists ("$file.bak.$ext")) {
		return copy ("$file.bak.$ext", "$file");
	} else {
		return false;
	}
}

function close () {
	if ($this->fd == 0) {
		print ("no configuration file opened");
		return false;
	}
	fputs ($this->fd, "?".">\n");
	fclose ($this->fd);
	return true;
}

function writeString ($var, $val, $comment="") {
	if ($this->fd == 0) {
		print ("no configuration file opened");
		return false;
	}

	$value="";
	if (!empty($val)) {
		$value = ereg_replace (13, "", stripSlashes($val));
		$value = ereg_replace (10, "\\n", $value);
		$value = ereg_replace ('"', '\\"', $value);
		$value = ereg_replace ("\\$","\\$", $value);
	}
	
	if (!empty ($comment)) {
		$comment = "\t// $comment";
	}
	// Uncomment the lines bellow if magic_quotes_runtime=On
	//if (get_magic_quotes_runtime())
	//	$value = addSlashes($value);
	fputs ($this->fd, "\$$var = \"$value\";$comment\n");
}

function writeInt ($var, $val, $comment="") {
	setType ($value, "integer");
	if (empty ($val)) {
		$value=0;
	}
	else {
		$value=$val;
	}
	if (!empty ($comment)) {
		$comment = "\t// $comment";
	}
	fputs ($this->fd, "\$$var = $value;$comment\n");
}

function writeLn () {
	fputs ($this->fd, "\n");
}

function writeComment ($comment) {
	fputs ($this->fd, "# $comment\n");
}

function writeArrayConfig($conf) {
	if (!is_array($conf))
		return false;

	while ( list( $var, $val) = each($conf) ) {
		if (is_int($val))
			fputs ($fp, "\$$var=$val;\n");
		else
			fputs ($fp, "\$$var=\"$val\";\n");
	}
	fputs ($fp, "?".">\n");
	fclose ($fp);
	return 0;
}

	/***********************************/
	/*  Initialize Configuration File  */
	/***********************************/

function writeConfig($config) {

	$this->writeString("site", $config["site"]);
	$this->writeString("bn_owner", $config["bn_owner"]);
	$this->writeString("bn_dir", $config["bn_dir"]);
	$this->writeString("bn_dir_notes", $config["bn_dir_notes"]);
	$this->writeString("bn_dir_forums", $config["bn_dir_forums"]);

	$this->writeString("bn_access", $config["bn_access"]);
	$this->writeString("bn_db", $config["bn_db"]);
	$this->writeString("dbname", $config["dbname"]);
	$this->writeString("dbhost", $config["dbhost"]);
	$this->writeString("dbport", $config["dbport"]);
	$this->writeString("dbuser", $config["dbuser"]);
	$this->writeString("dbpassword", $config["dbpassword"]);

	$this->writeString("bn_title", $config["bn_title"]);
	$this->writeString("bn_body", $config["bn_body"]);
	$this->writeString("bn_date_format", $config["bn_date_format"]);
	$this->writeString("bn_font_face", $config["bn_font_face"]);

	$this->writeInt("bn_view_reply", $config["bn_view_reply"]);
	$this->writeInt("bn_no_toolbar", $config["bn_no_toolbar"]);
	$this->writeInt("bn_no_thread_list", $config["bn_no_thread_list"]);
	$this->writeInt("bn_list_post", $config["bn_list_post"]);

	$this->writeInt("bn_cookies", $config["bn_cookies"]);
	$this->writeInt("bn_popup", $config["bn_popup"]);
	$this->writeInt("bn_frames", $config["bn_frames"]);
	$this->writeString("bn_frameset", $config["bn_frameset"]);
	$this->writeString("bn_frame1", $config["bn_frame1"]);
	$this->writeString("bn_frame2", $config["bn_frame2"]);

	$this->writeString("bn_header", $config["bn_header"]);
	$this->writeString("bn_footer", $config["bn_footer"]);

	$this->writeString("bn_msgs", $config["bn_msgs"]);
	$this->writeString("bn_form", $config["bn_form"]);
	$this->writeString("bn_fields", $config["bn_fields"]);
	$this->writeString("bn_list_vars", $config["bn_list_vars"]);
	$this->writeString("bn_template", $config["bn_template"]);
	$this->writeString("bn_style", $config["bn_style"]);
	$this->writeString("bn_before_access", $config["bn_before_access"]);

	$this->writeInt("bn_search", $config["bn_search"]);
	$this->writeString("bn_search_engine", $config["bn_search_engine"]);
	$this->writeString("bn_search_path", $config["bn_search_path"]);

	$this->writeInt("bn_file_upload", $config["bn_file_upload"]);
	$this->writeString("MAX_FILE_SIZE", $config["MAX_FILE_SIZE"]);

	$this->writeInt("bn_browse_server", $config["bn_browse_server"]);
	$this->writeString("bn_browse_dir", $config["bn_browse_dir"]);

	$this->writeInt("bn_mail", $config["bn_mail"]);
	$this->writeString("bn_mail_text", $config["bn_mail_text"]);
	$this->writeString("bn_admin_address", $config["bn_admin_address"]);
	$this->writeInt("bn_user_mail", $config["bn_user_mail"]);

	$this->writeInt("bn_modify", $config["bn_modify"]);
	$this->writeInt("bn_delete", $config["bn_delete"]);
	$this->writeInt("bn_thread", $config["bn_thread"]);
	$this->writeInt("bn_allow_html", $config["bn_allow_html"]);
	$this->writeString ("bn_banned_tags", $config["bn_banned_tags"]);
	$this->writeInt("bn_use_smileys", $config["bn_use_smileys"]);
	$this->writeInt("bn_auto_url", $config["bn_auto_url"]);
}

} // end class
?>
