<? # $Workfile: cookies.php3$	$Revision: 1.2 $	$Date: 2000/11/21 18:18:50 $

/*
 *   W-AGORA
 *   -------
 *   File:		cookies.php3
 *   Usage:		include file - Cookies handling functions 
 *   date:		August 1999
 *   version:	3.0.0b5
 *   Authors:	Tom deLombarde <tomd@blackflute.com>
 *				Marc Druilhe <mdruilhe@araxe.fr>
 *		
 */

	// set persistent to expire in 30 days:
	$PExpires = mktime()+(30*(24*3600));
	$Pe_cookie="WAP_".$bn;	// persistent cookie
	$Se_cookie="WAS_".$bn;	// session cookie

class Cookies {

var $setp;
var $sets;

var $p_cookies = array();	// persistent cookie
var $s_cookies = array();	// session cookie

 // Get all cookies, initialize class
 function init () {
 	global $bn;
 	global $Pe_cookie, $Se_cookie;
 	
	$this->firstEntry=0;

	// Check if user has cookie:
	if (isSet ($GLOBALS[$Pe_cookie])) {
		// Get permanent values 
		$this->parse ($GLOBALS[$Pe_cookie], "p");

		if (isSet ($GLOBALS[$Se_cookie])) {
			// browser Session already set => get cookies
			$this->parse ($GLOBALS[$Se_cookie], "s");						
		} else {
			// first entry to site during this browser session
			
			// update last visit ...
			$this->s_cookies["ThisVisit"]=mktime();
			$this->s_cookies["LastVisit"]=$this->p_cookies["LastVisit"];
			// mark the session cookie to be sent:
			$this->sets = 1;

			// ... and set persistent values in array to match new
			$this->p_cookies["Visits"] = $this->p_cookies["Visits"]+1;
			$this->p_cookies["LastVisit"] = $this->s_cookies["ThisVisit"];
			// mark the persistent cookie to be sent:
			$this->setp = 1;
		}
	} else {
		// First entry to the site, set persistent & session values
		$this->s_cookies["ThisVisit"]=mktime();
		$this->s_cookies["LastVisit"]=0;
		$this->sets = 1;

		// ... and set persistent values 
		$this->p_cookies["Visits"] = 1;
		$this->p_cookies["LastVisit"] = $this->s_cookies["ThisVisit"];
		$this->setp = 1;
	}
	
 }

 // Parse Cookies into persistent and session cookies arrays
 function parse ($cookie, $stor) {

	$pairs = split ('&', $cookie);
	$i = 0;
	while ($i < count ($pairs)) {
		$pair = split ('=', $pairs [$i]);
		$c_key=$pair[0];
		$c_val=$pair[1];
# echo "cookie: $c_key = $c_val<br>";
		switch ($stor) {
		  case "p":
			$this->p_cookies[$c_key]=$c_val;
			break;
		  case "s":
			$this->s_cookies[$c_key]=$c_val;
			break;
		  case "b":
			$this->p_cookies[$c_key]=$c_val;
			$this->s_cookies[$c_key]=$c_val;
			break;
		}
		$i++;
	}
 }

 function set ($stor) {
	global $Pe_cookie, $Se_cookie, $PExpires;
	
	if ($stor == "s" || $stor == "b") {
		if (is_array($this->s_cookies) && $this->sets==1) {
			reset ($this->s_cookies);
			$se_string="";
			while ( list( $cookie, $val ) = each( $this->s_cookies) ) {
				if (is_string ($cookie)) {
					$se_string .= "$cookie=$val". "&";
				}
			}
			if (!empty ($se_string)) {
				$se_string = ereg_replace ("&$", "", $se_string);
				setCookie ($Se_cookie, $se_string);
			}
		}
	}
	
	if ($stor == "p" || $stor == "b") {
		if (is_array($this->p_cookies) && $this->setp==1) {
			reset ($this->p_cookies);
			$pe_string="";
			while ( list( $cookie, $val ) = each( $this->p_cookies)) {
				if (is_string ($cookie)) {
					$pe_string .= "$cookie=$val". "&";
				}
			}
			if (!empty ($pe_string)) {
				$pe_string = ereg_replace ("&$", "", $pe_string);
				setCookie ($Pe_cookie, $pe_string, $PExpires);
			}
		}
	}

 }

} // End Class

	$cookies = new Cookies;
	$cookies->init();

	if ($bn_action == "view") {
		if (isset($cookies->s_cookies["visited"])) {
			if ( ($key > $cookies->s_cookies["LastVisit"]) && !strstr($cookies->s_cookies["visited"], $key)) {
				$cookies->s_cookies["visited"] .= "+$key";
				$cookies->sets=1;
			}
		} else {
			if ($key > $cookies->s_cookies["LastVisit"]) {
				$cookies->s_cookies["visited"] .= "$key";
				$cookies->sets=1;
			}
		}
	}

	// If coming from post/edit => set username/address cookies
	if ($bn_action == "insert" || $bn_action == "update" && !isSet($preview) ) {
		if (isSet ($username) && ((!isSet($cookies->p_cookies["name"])) || ($cookies->p_cookies["name"] != $username))) {
			$cookies->p_cookies["name"] = $username;
			$cookies->setp=1;
		}
		
		if (isSet ($useraddress) && ((!isSet($cookies->p_cookies["address"])) || ($cookies->p_cookies["address"] != $useraddress))) {
			$cookies->p_cookies["address"] = $useraddress;
			$cookies->setp=1;
		}
	}

	// set the session and persistent cookies:
	$cookies->set ("b");
?>
