<?php
# $Workfile: dbaccess.php3$	$Revision: 1.2 $	$Date: 2000/11/21 18:18:50 $	

/*
 *   W-AGORA
 *   -------
 *   File:		dbaccess.php3
 *   Usage:		include file - Generic Database access functions 
 *	 date:		August 2000
 *	 version:	3.0.2
 *   Authors:	Marc Druilhe <mdruilhe@w-agora.com>
 *				Tom deLombarde <tomd@blackflute.com>
 *   History:	* (TED/MD) Added code to allow expand/contract thread
 *	              For this to work, the 'Line Contents' field of Notes List must
 *				  include the variable $expand_icon (see also $msg[74- 75] )
 *				* (TED/MD) Added code to allow the display of the date of the last message posted
 *				   in each thread.
 *				  For this to work, the 'Line Contents' field of Notes List must include:
 *				  the variable $newestPrmpt : prompt displayed (newest note), this message is
 *				  stored in the list of messages (msg[68])
 *				* (MD) Added code to allow display of the attachment
 *				  For this to work, the 'Line Contents' field of Notes List must include:
 *				  the variable $attach_icon
 */

// if (!defined("_DBACCESS")) {
if (!isset($DBACCESS)) {

 define("_DBACCESS", 1);
 $DBACCESS=1;

 class DBaccess {

	var $dblink;	// database link

	var $children = array();	// array of keys
	var $entries = array();		// array in which notes are stored

	var $debug = 0; 			// 0 = turns debug mode off

	function openDB () {
		// not currently implemented for DBM
		return 0;
	}

	function createForum ($forum, $password) {
		 echo "function <b>createForum()</b> not implemented<br>";
	}

	function deleteForum ($forum, $password) {
		 echo "function <b>deleteForum()</b> not implemented<br>";
	}

	function getPassword ($forum) {
		 echo "function <b>getPassword()</b> not implemented<br>";
	}

	function changePassword ($forum, $old_pass, $new_pass) {
		 echo "function <b>changePassword()</b> not implemented<br>";
	}

	function getChild ($key, $action) {
		global $ext, $site, $bn, $bn_db, $bn_action, $bn_pad;
		global $bn_cookies, $cookies;
		global $note, $lynx, $pattern, $main_page;

		global $bn_view_odd_first_line, $bn_view_even_first_line, $bn_view_end_thread;
		global $bn_view_begin_level, $bn_view_end_level;
		global $bn_view_odd_line, $bn_view_even_line;

		global $bn_list_odd_first_line, $bn_list_even_first_line, $bn_list_end_thread;
		global $bn_list_begin_level, $bn_list_end_level;
		global $bn_list_odd_line, $bn_list_even_line;
		
		global $bn_delete_odd_first_line, $bn_delete_even_first_line, $bn_delete_end_thread;
		global $bn_delete_begin_level, $bn_delete_end_level;
		global $bn_delete_odd_line, $bn_delete_even_line;

		global $bn_search_odd_first_line, $bn_search_even_first_line, $bn_search_end_thread;
		global $bn_search_begin_level, $bn_search_end_level;
		global $bn_search_odd_line, $bn_search_even_line;

		global $bn_date_format, $msg;
		global $expnd, $here, $first, $last, $where, $sort;

		static $lineNo = 0;
		static $threadNo = 0;
		static $level = 0;

		$hidden_note=FALSE;
		$top_level=0;

if ($this->debug) echo "getChild($key)";

		if (!is_array($this->entries)) return -1;
		
		reset($this->entries);
		
		$has_children=is_array($this->children[$key]);
		$is_expanded=1;

		// evaluate all variables
		if ($key>0) {
			reset($this->entries[$key]);
			while ( list( $var, $val ) = each( $this->entries[$key])) {
				if (is_string ($var)) $$var = $val;
				if ($var=="body") {
					$body=format_text($body);
				}
			}
		}

		// Cookie/new stuff
		if ($bn_cookies && isSet ($cookies)) {
			// Check if session cookie set
			if (isSet ($cookies->s_cookies["LastVisit"])) {
				$LVisit=$cookies->s_cookies["LastVisit"];
				if ( ($unixdate > $LVisit) && !ereg($key, $cookies->s_cookies["visited"]) ) {
					$is_new = TRUE;
					$new_icon=msg(82);
				}
			} else {
				// No cookie set, all messages new
				$LVisit=0;
				// $LVisit=mktime()+3600;
				$is_new = TRUE;
				$new_icon=msg(82);
			}
		}
		
		// we don't display key 0 (administrative note)
		// and don't display old notes (if list only new):
		if ( ($key == 0) || (($expnd == "new") && (!$is_new)) ) {
			$hidden_note = TRUE;
		} 
		
		if (!$hidden_note)  {
			$formated_date = date ($bn_date_format, $unixdate);
			$note = $key;
			if (isset($attachment) && $attachment == "none") {
				unset ($attachment);
			}

			// format date of last post if we are listing forums
			if (!empty($last_note) ) {
				$last_note = date ($bn_date_format, $last_note);
			}

			// determine if top level of thread (new thread)
			if ($parent==0) {
				$top_level=1;
				$threadNo++;
				$threadAnchor="<A NAME=\"A$thread\"></A>";
			}
			else {
				$top_level=0;
				$threadAnchor="";
			}

			// initialize "latest" pattern
			$newestNote = (empty($newest)) ? "" : date ($bn_date_format, $newest);
			$newestPrmpt="";

			// set the pointer to the current note 
			if (isset($here) && ($here == $key)) {
				$currPointer=msg(73);
			} else {
				$currPointer="";
			}

			// set the attachment icon 
			if (isset($attachment) && ($attachment != "none")) {
				$attach_icon = msg(74);
			} else {
				$attach_icon = "";
			}

			if ($top_level) {
				// is this entry at top of thread and has replies?
				if ($has_children) {
					// if newest note is since last visit, force thread to be expanded
					if ( ($expnd!="none") && $bn_cookies && isSet ($cookies) && ($newest > $LVisit) && !ereg($newest, $cookies->s_cookies["visited"]) ) {
						$is_expanded = 1;
					} else if ($expnd==$key || $expnd=="all") {
						$is_expanded = 1;
					} else {
						$is_expanded = 0;
					}

					// set expand_icon depending on collapsed or expanded:
					$expand_icon="<a href='list.$ext?bn=$bn";
					if ($first) $expand_icon .= "&first=$first";
					if ($last) $expand_icon .= "&last=$last";
					if (!empty($newest)) {
						$newestNote = date ($bn_date_format, $newest);
						$m=addSlashes(stripSlashes($msg[68]));
						eval ("\$newestPrmpt=stripSlashes(\"$m\");");
					}
					if ($is_expanded) {
						// currently expanded
						$expand_icon .= "#A$thread'>".msg(75)."</a>";
					} else {
						// currently collapsed
						$expand_icon .= "&expnd=$thread#A$thread'>" . msg(76) . "</a>";
					}
				} else {
					// set expand_icon to "single message"
					$expand_icon = msg(72);
				}
				$line = ($lineNo % 2) ? "bn_${action}_odd_first_line" : "bn_${action}_even_first_line";
			} else {
				$expand_icon = "";
				$replies=0;
				$n = $level;
				$pad = "";
				while ($n--) {
					$pad .= "$bn_pad";
				}
				$line = ($lineNo % 2) ? "bn_${action}_odd_line" : "bn_${action}_even_line";
			}
			// display line
			if (!empty($$line) ) {
				$lineNo++;
			}
			$l=addSlashes(stripSlashes($$line));
			eval ("echo stripSlashes(\"$l\n\");");
		}
	
		if ($has_children && $is_expanded) {
			// display begin level pattern
			if ($key>0) {
				$level++;
				$begin="bn_${action}_begin_level";
				$l=addSlashes(stripSlashes($$begin));
				eval ("echo stripSlashes(\"$l\n\");");
			}
			// display all replies to this thread
			reset ($this->children[$key]);
			while (list(,$child) = each($this->children[$key])) {
				$this->getChild ($child, $action);
			}

			// display end of level pattern
			if ($key>0) {
				$level--;
				$end="bn_${action}_end_level";
				$l=addSlashes(stripSlashes($$end));
				eval ("echo stripSlashes(\"$l\n\");");
			}
		}
		
		// display end of thread/level pattern
		if ($top_level) {
			$end="bn_${action}_end_thread";
			$l=addSlashes(stripSlashes($$end));
			eval ("echo stripSlashes(\"$l\n\");");
		}
	}

	function listThreads ($forum, $first=0, $last=0) {
		 echo "function <b>listThreads()</b> not implemented<br>";
	}

	function listNotes ($forum, $first=0, $last=0, $sort="", $where="") {
		 echo "function <b>listNotes()</b> not implemented<br>";
	}

	function getNote ($forum, $cle) {
		 echo "function <b>getNote()</b> not implemented<br>";
	}

 	function getThreadNewest ($forum, $thread) {
 	}

	function getThread ($forum, $key, $thread) {
		 echo "function <b>getThread()</b> not implemented<br>";
	}

	function insertNote ($forum, $key, $fields) {
		 echo "function <b>insertNote()</b> not implemented<br>";
	}

	function ThreadNote ($forum, $cle, $parent_key, $fields) {
		 echo "function <b>threadNote()</b> not implemented<br>";
	}

	function updateNote ($forum, $key, $passwd, $fields) {
		 echo "function <b>updateNote()</b> not implemented<br>";
	}

	function deleteNote ($forum, $note, $passwd, $bn_dir_notes) {
		 echo "function <b>deleteNote()</b> not implemented<br>";
	}

	function mDeleteNotes ($forum, $notes, $passwd, $bn_dir_notes) {
		$admin_password = $this->GetPassword($forum);
		if ($passwd != $admin_password)
			return (-2); /* invalid password */
	
		for (reset ($notes); $note=current($notes); next($notes)) {
			$ret = $this->deleteNote($forum, $note, $passwd, $bn_dir_notes);
			if ($ret < 0)
				return ($ret);
			else
				$i++;
		}
		return $i;
	}
	
	function mDeleteDate ($forum, $from, $to, $passwd, $bn_dir_notes) {
		 echo "function <b>mDeleteDate()</b> not implemented<br>";
	}

	function search ($forum, $pattern) {
		 echo "function <b>search()</b> not implemented<br>";
	}

	function setDebug ($flag) {
		 $this->debug=$flag;
	}

 }

}
?>
