<? # $Workfile: dbm.php3$	$Revision: 1.2 $	$Date: 2000/11/21 18:18:50 $

/*
 *   W-AGORA
 *   -------
 *   File:	dbm.php3
 *   Usage:	include file - Database access functions (DBM)
 *   date:	December 1998
 *   version:	3.0.1
 *   Author:	Marc Druilhe <mdruilhe@araxe.fr>
 */


/*
 *		File format:
 *	key		: time (seconds)
 *	parent		: link to parent (0 if no parent)
 *	<esc>field1<esc>field2<esc>... 	: fields defined in form.var file
 *      [~child1[~child2...]  : list of child's keys
 */

if (!defined("_DBACCESS")) {
	include ("$inc_dir/dbaccess.$ext");
}

class dbm_access extends DBaccess {

var $sep;
var $childsep;
var $dbm_dir;

function OpenDB () {
	global $site;

	$this->dbm_dir = "./dbm/$site";
	$this->sep=chr(27);
	$this->childsep="~";

if ($this->debug) echo "OpenDB(): dbm_dir: ./dbm/$dbname<br>";
	return 0;
}

function createForum ($forum, $password) {

	$dbmfile = $this->dbm_dir."/$forum";
	$lockfile = "$dbmfile.lck";
	if (file_exists ("$lockfile"))
		return (-1); /*  file already exist */

	$dbm_id = dbmopen($dbmfile, "n");
if ($this->debug) echo "createForum($forum, $password): open ($dbmfile) => $dbm_id<br>";
	if (!$dbm_id) {
		return (-3);   /* access PB  */
	}
	$ret = dbminsert ($dbm_id, 1, $password);
if ($this->debug) echo "createForum(dbminsert ($dbm_id, 1, $password) => $ret<br>";
	dbmclose ($dbm_id);
	return 0;
}

function deleteForum ($forum, $password) {

	$dbmfile = $this->dbm_dir."/$forum";
	$admin_password = $this->GetPassword ($forum);
	if ($password != $admin_password)
		return (-2); /* invalid password */
	@unlink ($dbmfile);
	@unlink ("$dbmfile.dir");
	@unlink ("$dbmfile.pag");
	@unlink ("$dbmfile.db");
	$ret = unlink ("$dbmfile.lck");
	if ( !$ret)
		return (-3);
	return (0);
}

function getPassword ($forum) {
	$dbmfile = $this->dbm_dir."/$forum";
	$dbm_id = dbmopen("$dbmfile","r");
if ($this->debug) echo "getPassword($forum): open ($dbmfile) => $dbm_id<br>";
	if (!$dbm_id) {
		return ("");
	}

	$entry = @dbmfetch ($dbm_id, 1);
if ($this->debug) echo "getPassword ($forum) => $entry<br>";
	dbmclose($dbm_id);
	if ($entry):
		return ($entry);
	else:
		return ("");
	endif;
}

function changePassword ($forum, $old_pass, $new_pass) {

	$pass = $this->getPassword($forum);
	if ($old_pass != $pass)
		return (-2); /* invalid password */

	$dbmfile = $this->dbm_dir."/$forum";
	$dbm_id = @dbmopen("$dbmfile","w");
	if (!$dbm_id) {
		return (-3); /* access problem */
	}

	$ret = @dbmreplace ($dbm_id, 1, $new_pass);
	dbmclose ($dbm_id);
	if ($ret != 0):
		return (-3); /* access problem */
	else:
		return (0);
	endif;
}

function listThreads ($forum, $first=0, $last=0) {
	global $db_var, $bn_var, $list_var;
	global $bn_maxthreads;

	$dbmfile = $this->dbm_dir."/$forum";
	$dbm_id = @dbmopen ("$dbmfile","r");
if ($this->debug) echo "listThreads($forum, $first, $last): open ($dbmfile) => $dbm_id<br>";
	if (!$dbm_id)
		return (-3); /* access problem */

	$key = (integer)dbmfirstkey($dbm_id);
if ($this->debug) echo "dbmfirstkey($dbm_id) => $key<br>";
	if (empty($key)) {
		dbmclose ($dbm_id);
		return (-4);  /* file empty (should not occur) */
	};

	$prev=0;
	$next=0;
	$count=0;
	$total=0;
	$tcount=0;

	if (!isset($last)) {
		$last=0;
	}
	
	if (!isset($first)) {
		$first=0;
	}
	$threads =array();
	while (!empty($key)) {
		if ($key > 1) {	// skip first record (password)
			$total++;
			if ($key < $last)	// skip old entries
				$next=1;
			else {
if ($this->debug) echo "read key: $key<br>";
				$entry = dbmfetch ($dbm_id, $key);
				$parent = (int) strtok ($entry, $this->sep);
				$this->entries[$key]["parent"] = $parent;
				for (reset ($bn_var); $var=current($bn_var); next($bn_var)) {
					if (isset($list_var[$var]))
						$this->entries[$key][$var] = strtok($this->sep);		
					else
						$tmp =  strtok($this->sep);
if ($this->debug) echo "$var : " . $this->entries[$key][$var] . " ";
				}
				for (reset ($db_var); $var=current($db_var); next($db_var)) {
					if (isset($list_var[$var]))
						$this->entries[$key][$var] = strtok($this->sep);		
					else
						$tmp =  strtok($this->sep);
if ($this->debug) echo "$var : " . $this->entries[$key][$var] . " ";
				}
				$tmp = substr (strchr ($entry, $this->childsep), 1);
				$count++;
				if ($parent==0) { // new thread
					if ($first && ($key > $first))
						$prev=1;
					else
						$threads[$tcount++]=$key;
				} else {
					$this->children[$parent][] = $key;
				}
			}
		}
		$key = (int)dbmnextkey($dbm_id,$key);
	}

	if ($count == 0) {
		dbmclose($dbm_id);
		$ret["total"]=$total;
		$ret["threads"]=0;
		return ($ret);
	}
	
	rsort ($threads);

	if (!isset($bn_maxthreads) || $bn_maxthreads == 0) {
		$bn_maxthreads = $tcount;
	}
		
	if ($tcount <= $bn_maxthreads) {
		$tfirst = 0;
		$tlast = $tcount;
	}
	elseif ($last) {
		$prev=1;
		$tfirst = $tcount - $bn_maxthreads;
		$tlast = $tcount;
	}
	else {
		$next=1;
		$tfirst = 0;
		$tlast = $bn_maxthreads;
	}
			
	for ($i = $tfirst; $i < $tlast; $i++) {
		$this->updateThread ($dbm_id, $threads[$i], $threads[$i]);
		$this->children[0][] = $threads[$i];
	}
	
	dbmclose($dbm_id);
	$ret["total"]=$total;
	$ret["threads"]=$tcount;
	$ret["next"]=$next;
	$ret["prev"]=$prev;
	$ret["first"]=$threads[$tfirst];
	$ret["last"]=$threads[$tlast-1];
	return ($ret);
}

function listNotes ($forum, $first=0, $last=0, $sort="", $where="") {
	$this->listThreads ($forum, $first, $last);
}

function updateThread ($dbm_id, $key, $thread) {
	global $db_var, $bn_var;

	if (!isset($this->entries[$thread]["replies"])) {
		$this->entries[$thread]["replies"]=0;
	}
	
	$this->entries[$key]["thread"] = $thread;
	if (!isset($this->entries[$thread]["newest"]) || ($key > $this->entries[$thread]["newest"]) ) {
		$this->entries[$thread]["newest"] = $key;
	}

	if (is_array ($this->children[$key])) {
		for (reset ($this->children[$key]); $child=current($this->children[$key]); next($this->children[$key])) {
			$this->entries[$thread]["replies"]++;
			$this->entries[$key]["thread"] = $thread;
			$this->entries[$key]["thread"] = $thread;
			$this->updateThread ($dbm_id, $child, $thread);
		}
	}
}

function getNote ($forum, $key) {
	global $db_var, $bn_var;

	$dbmfile = $this->dbm_dir."/$forum";
	$dbm_id = @dbmopen("$dbmfile","r");
	if (!$dbm_id)
		return (-3); /* access problem */

	$entry = dbmfetch ($dbm_id, $key);
	if (!$entry) {
		dbmclose ($dbm_id);
		return (-4);
	}

	/* Extraction des champs separes par ESC */
	$fields["parent"] = strtok($entry,$this->sep);
	for (reset ($bn_var); $var=current($bn_var); next($bn_var)) {
		$fields[$var] = strtok($this->sep);
		if ($fields[$var] == " ")
			$fields[$var] = "";
if($this->debug) echo "get $var:$fields[$var],<br>";
	}

	for (reset ($db_var); $var=current($db_var); next($db_var)) {
		$fields[$var] = strtok($this->sep);
		if ($fields[$var] == " ")
			$fields[$var] = "";
if($this->debug) echo "get $var:$fields[$var],<br>";
	}
	$fields["thread"] = $this->findRoot ($dbm_id, $key);
	dbmclose ($dbm_id);
	return ($fields);
}

function getThread ($forum, $key, $thread=0) {

	$dbmfile = $this->dbm_dir."/$forum";
	$dbm_id = dbmopen ("$dbmfile","r");
	if (!$dbm_id) return (-3); /* access problem */
	if (!$thread) 
		$thread = $this->findRoot($dbm_id, $key);
	$this->loadThread ($dbm_id, $thread);
	return;
}

function findRoot ($dbm_id, $key) {
	global $db_var, $bn_var;

	/* read entry in associative array */
	$entry = dbmfetch ($dbm_id, $key);
	$parent = (int) strtok ($entry, $this->sep);
	$this->entries[$key]["parent"] = $parent;
	for (reset ($bn_var); $var=current($bn_var); next($bn_var)) {
		$this->entries[$key][$var] = strtok($this->sep);		
	}
	for (reset ($db_var); $var=current($db_var); next($db_var)) {
		$this->entries[$key][$var] = strtok($this->sep);		
	}
	/* get childs */
	$tmp = substr (strchr ($entry, $this->childsep), 1);
	$this->children[$key] = explode ($this->childsep, $tmp);

	if ($parent) 
		return $this->findRoot ($dbm_id, $parent);
	else
		return $key;
}

function loadThread ($dbm_id, $key) {
	global $db_var, $bn_var;

	/* read entry in associative array */
	if (!$this->entries[$key]) {
		$entry = dbmfetch ($dbm_id, $key);
		$parent = (int) strtok ($entry, $this->sep);
		$this->entries[$key]["parent"] = $parent;
		for (reset ($bn_var); $var=current($bn_var); next($bn_var)) {
			$this->entries[$key][$var] = strtok($this->sep);		
		}
		for (reset ($db_var); $var=current($db_var); next($db_var)) {
			$this->entries[$key][$var] = strtok($this->sep);		
		}
		/* get childs */
		$tmp = substr (strchr ($entry, $this->childsep), 1);
		$this->children[$key] = explode ($this->childsep, $tmp);
	}
	reset($this->children[$key]);
	if (current($this->children[$key])) {
		for (reset ($this->children[$key]); $child=current($this->children[$key]); next($this->children[$key])) {
			$this->loadThread ($dbm_id, $child);
		}
	}
}

function insertNote ($forum, $key, $fields) {

	$dbmfile = $this->dbm_dir."/$forum";
	$dbm_id = dbmopen("$dbmfile","w");
if ($this->debug) echo "insertNote($forum, $key, $fields): open ($dbmfile) => $dbm_id<br>";
	if (!$dbm_id) {
		return (-3); /* access problem */
	}
	$record = "0";  /* parent's key */

	for (reset($fields); $var = key($fields); next($fields)) {
		$field = $fields[$var];
		if ($field == "")
			$field = " ";
		$record .= $this->sep . $field;
if($this->debug) echo "ins: $var: $field <br>";
	}

	$record .= $this->sep;
if($this->debug) echo "record: $record <br>";
	$ret = dbminsert($dbm_id, $key, $record);
	dbmclose ($dbm_id);
/* Warning!! according to doc : dbminsert should return true = 1 if OK !! */
 	if ($ret!=0) {
		return (-3); /* access problem */
	}
	else {
		return ($key);
	}
}

function threadNote ($forum, $key, $parent_key, $fields) {

	$dbmfile = $this->dbm_dir."/$forum";
	$dbm_id = @dbmopen("$dbmfile","w");
	if (!$dbm_id) return (-3); /* access problem */

	$parent = @dbmfetch ($dbm_id, $parent_key);
	if ($parent < 0):
		dbmclose($dbm_id);
		return (-4);  /* invalid key */
	endif;

	$record = "$parent_key";

	for (reset($fields); $k = key($fields); next($fields)) {
		$field = $fields[$k];
		if (!$field)
			$field = " ";
		$record .= $this->sep . $field;
if($this->debug) echo "ins: $k: $field <br>";
	}
	$record .= $this->sep;
	$err = @dbminsert($dbm_id, $key, $record);
	if ($err != 0):
		return (-3); /* access problem */ 
	endif;

	$parent = $parent . $this->childsep . $key;
	$err = @dbmreplace ($dbm_id, $parent_key, stripSlashes($parent));
	if ($err != 0):
		dbmdelete ($dbm_id, $key);
		dbmclose($dbm_id);
		return (-3); /* access problem */ 
	else:
		dbmclose($dbm_id);
		return ($key);
	endif;
}

function updateNote ($forum, $key, $passwd, $fields) {
	global $bn_var, $db_var;

	$adm_pass = $this->getPassword($forum);

	$dbmfile = $this->dbm_dir."/$forum";
	$dbm_id = dbmopen("$dbmfile","w");
	if (!$dbm_id) {
		return (-3); /* access problem */
	}

	// get old entry
	$old_entry = dbmfetch ($dbm_id, $key);
	if (!$old_entry)
		return (-4);

	// split old fields in old_fields array
	$parent = strtok($old_entry,$this->sep);
	for (reset ($bn_var); $var=current($bn_var); next($bn_var)) {
		$old_fields[$var] = strtok($this->sep);
		if ($old_fields[$var] == " ")
			$old_fields[$var] = "";
if($this->debug) echo "get: $var:$old_fields[$var],<br>";
	}
	for (reset ($db_var); $var=current($db_var); next($db_var)) {
		$old_fields[$var] = strtok($this->sep);
		if ($old_fields[$var] == " ")
			$old_fields[$var] = "";
if($this->debug) echo "get: $var:$old_fields[$var],<br>";
	}

	// check password
	if ($passwd != $old_fields[password] && $passwd != $adm_pass)
		return (-2); /* invalid password */ 

	// save childs
	$childs = strchr ($old_entry, $this->childsep);
if ($this->debug)echo "childs: $childs<br>";

	// build new entry
	$entry = $parent;
	while ( list( $var, $val ) = each( $old_fields)) {
		if (isSet($fields[$var]) && !empty($fields[$var])) 
			$field = $fields[$var];
		else
			$field = $val;
		if (empty ($field))
			$field = " ";
if ($this->debug)echo "upd: $var: $field <br>";
		$entry .= $this->sep . $field;
	}

	$entry .= $this->sep . $childs;
	
	$err = dbmreplace($dbm_id, $key, $entry);
	dbmclose($dbm_id);
	if ($err != 0):
		return (-3); /* access problem */
	endif;
	return (0);
}

function deleteNote ($forum, $note, $passwd, $bn_dir_notes) {
	global $bn_var;

	$admin_password = $this->GetPassword($forum);

	$dbmfile = $this->dbm_dir."/$forum";
	$dbm_id = dbmopen("$dbmfile","w");
	if (!$dbm_id) { return (-3); } /* access problem */

	$entry = dbmfetch ($dbm_id, $note);
	if (!$entry) { return (-4); } /* dbmfetch error */

	/* Extraction des champs separes par ESC */
	$parent = strtok($entry,$this->sep);
	$i=0;
	$count = Count($bn_var);
	while ($i < $count):
		$var = $bn_var[$i];
		$$var = strtok($this->sep);
		$i++;
	endwhile;
	if (($passwd != $password) && ($passwd != $admin_password)) {
		dbmclose($dbm_id);
		return (-2);
	}

	if (is_file ("$bn_dir_notes/$filename")) {
if ($this->debug) echo "suppression $bn_dir_notes/$filename";
		unlink ("$bn_dir_notes/$filename");
	}

	if ($attachment && ($attachment != "none") && is_file ("$bn_dir_notes/$note/$attachment") ) {
		@unlink ("$bn_dir_notes/$note/$attachment");
		@rmdir ("$bn_dir_notes/$note");
	}
	
	/* Suppression de la reference dans le pere */
	if ($parent) {
		$parent_entry = @dbmfetch ($dbm_id,$parent);
	        $parent_entry = ereg_replace(".$note", "", $parent_entry);
		$ret = @dbmreplace ($dbm_id, $parent, $parent_entry);
	}
	
	/* Chainage des fils vers le pere */
	$child = strtok($entry, $this->childsep);
	$child = strtok($this->childsep);
	while ($child):
		$child_entry = @dbmfetch ($dbm_id, $child);
		if ($child_entry):
			/* Rattachement du fils au grand-pere */
			$old_parent = strtok($child_entry,$this->sep);
			$child_entry = ereg_replace("$old_parent", "$parent", $child_entry);
			$ret = @dbmreplace ($dbm_id, $child, $child_entry);
			if ($parent) {
				/* Rajout dans le pere de la reference vers ce fils */
				$parent_entry = @dbmfetch ($dbm_id,$parent);
				$parent_entry = $parent_entry . $this->childsep . $child;
				$ret = @dbmreplace ($dbm_id, $parent, $parent_entry);
			}
		endif;
		$entry = ereg_replace("^.*$child", "$child", $entry);
		$child = strtok($entry, $this->childsep);
		$child = strtok($this->childsep);
	endwhile;
	if (dbmDelete ($dbm_id, $note))
		$ret = -3; /* dbmdelete error */
	else
		$ret = 0; /* OK */
	dbmclose($dbm_id);
	return ($ret);
}

function mDeleteDate ($forum, $from, $to, $passwd, $bn_dir_notes) {

	$dbmfile = $this->dbm_dir."/$forum";
	$dbm_id = dbmopen("$dbmfile","r");
	if (!$dbm_id)
		return (-3); /* access problem */

	/* parcours du fichier DBM */
	$getkey = (int)dbmfirstkey($dbm_id);
	if ($getkey < 0):
		dbmclose ($dbm_id);
		return (-4);  /* file empty  */
	endif;
	$nb=0;
	while (!empty($getkey)) {
		if (($getkey >= $from) && ($getkey <= $to)):
			$notes[$nb] = $getkey;
			$nb++;
		endif;
		$getkey = (int)dbmnextkey($dbm_id,$getkey);
	}
	$ret = 0;
	dbmclose ($dbm_id);
	if ($nb > 0):
		$ret = $this->mDeleteNotes ($forum, $notes, $passwd, $bn_dir_notes);
	endif;
	return ($ret);
}

function search ($forum, $pattern, $casesensitive) {
	global $db_var, $bn_var;

	$dbmfile = $this->dbm_dir."/$forum";
	$dbm_id = @dbmopen ("$dbmfile","r");
	if (!$dbm_id)
		return (-3); /* access problem */

	/* parcours du fichier DBM */
	$key = dbmfirstkey($dbm_id);
	if (!$key) {
		dbmclose ($dbm_id);
		return (-4);  /* file empty (should not occur) */
	};

	$key = dbmfirstkey($dbm_id);
	$num=0;
	while ($key) {
		if ($key > 1) {
			$entry = dbmfetch($dbm_id, $key);
			if ($casesensitive)
				$found = ereg ("$pattern", $entry);
			else
				$found = eregi ("$pattern", $entry);
				
			if ($found) {
				$parent = strtok($entry, $this->sep);
				for (reset ($bn_var); $var=current($bn_var); next($bn_var)) {
					$note[$var] = strtok($this->sep);
					if ($note[$var] == " ")
						$note[$var] = "";
				}
				for (reset ($db_var); $var=current($db_var); next($db_var)) {
					$note[$var] = strtok($this->sep);
					if ($note[$var] == " ")
						$note[$var] = "";
				}
				$keys[$num] = $key;
				$notes[$key] = $note;
				$num++;
			}
		}
    	$key = dbmnextkey($dbm_id, $key);
	}

	if ($num < 1 ) {
		return 0;
	}

	rsort ($keys);
	
	reset ($this->entries);
	reset ($this->children);
	
	for ($i=0; $i<$num; $i++) {
		$key= (int) $keys[$i];
		$this->entries[$key] = $notes[$key];
		$this->children[0][] = $key;
	}

	return $num;
}

}; // end class
?>
