<?php

/* 
 *	W-AGORA 3.0
 *	-----------
 *	$Id: misc_func.php3,v 1.6 2001/02/01 10:25:49 mdruilhe Exp $
 *	Usage:		Include file for common usage functions
 *	Author:		Marc Druilhe <mdruilhe@w-agora.com>
 */

function msg ($number, $default="") {
	global $site, $bn, $key, $note, $thread, $ext;
	global $pcfile_size, $pcfile_name;
	global $msg;

	if (isset($msg[$number])) {
		$mess=addSlashes(stripSlashes($msg[$number]));
	} else {
		$mess=$default;
	}
	eval ("\$m=stripSlashes(\"$mess\");");
	return $m;
};

function dspMsg ($number, $default="") {
	print msg($number, $default);
};

function msgWarning ($message) {
	$fontcolor="#FF2020";
	print ("<table border bgcolor=\"#eeeeee\" align=\"center\" cellspacing=0 cellpadding=5 width=400>");
	printf ("<tr><td align=center><font face=\"Arial, Verdana\" color=\"%s\">%s</td></tr></table>", $fontcolor, $message);
};

function msgForm ($message, $url, $action="", $target="", $method="get") {
	global $msg, $db_var;
	global $bn, $site;
	global $frameset, $bn_frames, $bn_popup;
	global $lynx, $back_form;
	global $HTTP_POST_VARS;

	$fontcolor = "#008000";

	if ($lynx==1) $bn_frames=0;

	$base_url=strtok($url,"?");
	$qs = strtok("?");
	echo "<FORM METHOD=\"$method\" ACTION=\"$base_url\" ";

	if (($action =="close") && $bn_popup) {
		if ($bn_frames) {
			echo " TARGET=\"main\">\n";
			$frame= "opener.parent.main";
		}
		else {
			echo " TARGET=\"_parent\">\n";
			$frame= "opener";
		}
	} elseif (!empty($target)) {
		echo " TARGET=\"$target\">\n";
	} else  {
		echo ">\n";
	}

# Propagate all posted vars from the FORM
# ---------------------------------------
	if ($method=="post" && is_array($db_var) ) {
		for (reset ($db_var); $field=current($db_var); next($db_var)) {
			if (is_string ($field)) {
				hiddenField($field, kill_quotes(stripslashes($GLOBALS[$field])) );
			}
		}
	}

# process Query string
# --------------------
	$a = split ('&', $qs);
	$i = 0;
	while ($i < count ($a)) {
		$b = split ('=', $a [$i]);
		$name=urldecode ($b[0]);
		$value = isset($b[1]) ? urldecode ($b[1]) : "";
		if ($name=="bn")
			$bn=$value;
		elseif ($name=="site")
			$site=$value;
		elseif ($name != "")
			hiddenField ($name, $value);
		$i++;
	}
	hiddenField ("bn", $bn);
	if (!empty($site)) {
		hiddenField ("site", $site);
	}
	if ($lynx==1) {
		hiddenField ("lynx", "1");
	}
	echo "<br><CENTER>\n<TABLE CELLPADDING=4 BORDER=1 width=400>\n<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
	printf ("<STRONG><font color=\"%s\">%s</font></STRONG><BR>\n", $fontcolor, $message);

	$exit=0;
	switch ($action):
		case "back":
			echo "<P><INPUT TYPE='submit' VALUE= ' OK ' onClick='history.back(); return false;'>\n";
		break;
		case "close":
			if ($bn_popup && ($back_form != "view") && ($back_form != "list") ) {
				echo "<P><INPUT TYPE='button' VALUE= ' OK ' ";
				echo "onClick='if ($frame!=null) {" . $frame . ".location=\"$base_url?bn=$bn&$qs";
				if ($lynx==1) echo "&lynx=1";
				echo "\";window.close()} else {window.close()};'>\n";
			}
			else {
				echo "<P><INPUT TYPE='submit' VALUE= ' OK '>\n";
			}
		break;
		case "exit":
			$exit=1;
		break;
		default:
			echo "<P><INPUT TYPE='submit' VALUE= ' OK '>\n";
		break;
	endswitch;
	?></TD></TR></TABLE></CENTER></FORM><?
	if ($frameset) {
		?></noframes></frameset><?
	}
}

function expandUrl ($url) {
	global $site, $bn, $lynx;

	$ret_url = strtok ($url, "#");
	$fragment = strtok ("#");

	$ret_url = ereg_replace ("[&?]+$", "", $ret_url);

	if (!empty($site) && !ereg ("[&?]site=", $ret_url) ) {
		$ret_url .= ( strpos($ret_url, "?") != false ?  "&" : "?" ). "site=$site";
	}
	if (!empty($bn) && !ereg ("[&?]bn=", $ret_url) ) {
		$ret_url .= ( strpos($ret_url, "?") != false ?  "&" : "?" ). "bn=$bn";
	}
	if (!empty($lynx) && !ereg ("[&?]lynx=1", $ret_url) ) {
		$ret_url .= ( strpos($ret_url, "?") != false ?  "&" : "?" ). "lynx=1";
	}

	if (!empty($fragment)) {
		$ret_url .= "#$fragment";
	}
	return ereg_replace(" ", "+", $ret_url);
}

function anchor ($url, $target="", $text="", $status="") {
	$target = (empty($target) ) ? "" : " TARGET='$target'";
	$text = empty($text) ? htmlSpecialChars($url) : $text;
	$jsstatus = empty($status) ? "" : " onMouseover=\"window.status='" . addSlashes($status) . "';return true\" onMouseout=\"window.status='';return true\"";
	return sprintf ("<A HREF=\"%s\" %s %s>%s</A>", expandUrl ($url), $target, $jsstatus, $text);
}

function displayUrl ($url, $target="", $text="", $status="") {
	print  anchor($url, $target, $text, $status);
}

function openWindow ($url, $text="", $status="", $width, $height) {
	global $site, $bn, $lynx, $bn_popup;

	$url = expandUrl($url);
	if ($bn_popup) {
		$frame = "${bn}_post";
		$target = " TARGET='$frame'";
		$jswindow = " onClick=\"OpenWindow('$url','$frame',$width,$height);\" ";
	} elseif ($bn_frames) {
		$target = " TARGET='main'";
		$jswindow = "";
	} else {
		$target ="";
		$jswindow = "";
	}

	$text = empty($text) ? htmlSpecialChars($url) : $text;
	$jsstatus = empty($status) ? "" : " onMouseover=\"window.status='" . addSlashes(strip_tags($status)) . "';return true\" onMouseout=\"window.status='';return true\"";
	printf ("<A HREF=\"%s\" %s %s %s>%s</A>", $url, $target, $jsstatus, $jswindow, $text);
}

function validate_email ($address) {
	return (ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'.
			'@'.
			'[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.'.
			'[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$',
			$address));
}

function checkURL($line) {
	if ($line != "") {
		$line = eregi_replace("([http|news|ftp|https]+://[^)<>,;\"[:space:][:cntrl:]]+)", 
			"<A  Href=\"\\1\" target=\"_blank\">\\1</A>", $line);
		$line = eregi_replace("(mailto:[^@\"]+@([a-zA-Z0-9\-]+\.)+[a-zA-Z0-9\-]{2,4})",
			"<A  Href=\"\\1\">\\1</A>", $line);
		$line = eregi_replace("([href|src] *= *.{0,1})<A  Href=[^>]+>([^<]+)</A>", "\\1\\2", $line);
	}
	return $line;
}

function strip_url ($line) {
	// remove only Href added in checkUrl()
	return ereg_replace ("<A  Href=[^>]+>([^<]+)</A>", "\\1", $line);
}

function quote_text ($text) {
	$text = my_br2nl ($text);
	$lines = split ("\n", $text);
	while ( list (,$line) = each($lines) ) {
		$quoted_text .= "> $line\n";
	}
	return $quoted_text;
}

function my_br2nl ($text) {
	$text=eregi_replace ("<br>\n", "\n", $text);
	return eregi_replace ("<br>", "\n", $text);
}


function my_nl2br ($text) {
	return ereg_replace (13, "", nl2br($text));
}

function emphasize ($text) {
	if (ereg ("^>(.*)", $text, $split) || eregi ("^&gt;(.*)", $text, $split) )
		$em_text = "<em>>". $split[1] . "</em>";
	else
		$em_text = $text;
	return $em_text;
}

function format_text ($text) {
	$text = ereg_replace (13, "", nl2br($text));
	$line = strtok ($text, "\n");
	while ($line) {
		$new_text .= emphasize($line) . "\n";
		$line = strtok ("\n");
	}
	return $new_text;
}

function strip_banned_tags ($text) {
	global $bn_banned_tags;
	if (!empty ($bn_banned_tags)) {
		$banned_tags = split(" ", $bn_banned_tags);
	}

	// strip PHP tags
	$text = ereg_replace ("<\\?", "&lt;?", $text);
	$text = ereg_replace ("\\?>", "?&gt;", $text);

	// kill javascript
	$text = eregi_replace ("javascript:", "sorry_but_javascript_is_not_allowed:", $text);

	// strip banned tags
	if (is_array($banned_tags)) {
		while ( list (,$badtag) = each($banned_tags) ) {
			$text = eregi_replace("<(/*${badtag}[^>]*)>", "<!--\\1-->", $text);
		}
	}
	return $text;
}

// Added by Trevor - trevor@unixforever.net - http://programmingphp.com/
// modified MD (08/2000)
function add_smileys ($text) {
	$text = eregi_replace("(:D)", "<img src=\"./icons/icon10.gif\" height=15 alt=\"\\1\" border=0 align=absmiddle>", $text);
	$text = eregi_replace("(:O)", "<img src=\"./icons/icon11.gif\" height=15 alt=\"\\1\" border=0 align=absmiddle>", $text);
	$text = eregi_replace("(:[-\^]{0,1}\)+)", "<img src=\"./icons/icon7.gif\" height=15 alt=\"\\1\" border=0 align=absmiddle>", $text);
	$text = eregi_replace("(;[-\^]{0,1}\)+)", "<img src=\"./icons/icon12.gif\" height=15 alt=\"\\1\" border=0 align=absmiddle>", $text);
	$text = eregi_replace("(X[-\^]{0,1}\(+)", "<img src=\"./icons/icon8.gif\" height=15 alt=\"\\1\" border=0 align=absmiddle>", $text);
	$text = eregi_replace("(:[-\^]{0,1}\(+)", "<img src=\"./icons/icon9.gif\" height=15 alt=\"\\1\" border=0 align=absmiddle>", $text);
	return $text;
}

function strip_smileys ($text) {
	$text = ereg_replace("<img src=\"\./icons/icon[[:digit:]]+\.gif\" height=15 alt=\"", "", $text);
	$text = ereg_replace("\" border=0 align=absmiddle>", "", $text);
	return $text;
}

function kill_html ($text) {
	$text = ereg_replace ("<", "&lt;", $text);
	$text = ereg_replace (">", "&gt;", $text);
	return $text;
}

function kill_quotes ($text) {
	$text = eregi_replace ('<br>', "\n", $text);
	$text = ereg_replace ('"', "&quot;", $text);
	$text = ereg_replace ("<", "&lt;", $text);
	$text = ereg_replace (">", "&gt;", $text);
	return $text;
}

function getAttachmentUrl ($key, $att_path, $att_type, $att_size) {
	global $ext, $site, $bn;

	$att_name = basename($att_path);
	switch ($att_type) {
		case "image/gif":
		case "image/jpeg":
		case "image/pjpeg":
			$ret = sprintf ("<CENTER><IMG SRC=\"%s\" ALT=\"%s\"></CENTER>\n", expandUrl("./getfile.$ext?key=$key"), $att_name);
			break;
		case "text/plain":
			$ret = "<PRE>";
			$file = file ("$att_path");
			$size = count($file);
			for ($i=0; $i < $size; $i++) {
				$ret .= HtmlSpecialChars($file[$i]);
			}
			$ret .= "</PRE>";
			break;
		case "text/html":
			$file = file ("$att_path");
			$size = count($file);
			for ($i=0; $i < $size; $i++) {
				$ret .= strip_banned_tags($file[$i]);
			}
			break;
 		default:
			$ret = "<CENTER><TABLE BORDER><TR><TD ROWSPAN='2'>";
			$ret .= msg(57, "<i>Attachment</i>: ") .  anchor ("getfile.$ext?key=$key", "", "<b>$att_name</b>", "");
			$ret .= "</TD><TD>Type : $att_type</TD></TR><TR><TD>";
			$ret .= msg(32, " Size") . ": $att_size</TR></TABLE></CENTER>\n";
			break;
	}
	return $ret;
}

/**
 *	Display the URL (link, image, ...) according to the mime-type
 *	Deprecated : use print getAttachmentUrl()
 */
function display_attachment ($key, $att_name, $att_type, $att_size) {
	global $bn_dir_notes;

	print getAttachmentUrl ($key, "$bn_dir_notes/$key/$att_name", $att_type, $att_size);
}

function table_header ($title, $width="95%") {
	echo "<center><TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\" WIDTH=\"$width\"><TR><TD BGCOLOR=\"#000000\">";
	echo "<TABLE BORDER=\"0\" CELLPADDING=\"4\" CELLSPACING=\"1\" width=\"100%\">";
	echo "<TR><TH BGCOLOR=\"#D0D0FF\" align=\"center\"><b>$title</b></TH></TR>\n<TR><TD BGCOLOR=\"#DEDFDF\">\n";
}

function table_footer () {
	echo "</TD></TR></TABLE></TD></TR></TABLE></center>\n";
}


# Form elements
# -------------

function beginForm ($action="", $method="post") {
	global $site, $bn, $WA_SELF;

	$action = (empty ($action)) ? $WA_SELF : $action;
	printf ("<FORM method=\"%s\" action=\"%s\">\n", $method, $action);
	if (!empty($site))	hiddenField ("site", $site);
	if (!empty($bn))	hiddenField ("bn", $bn);
}

function endForm() {
	echo "</form>";
}

function textField ($name, $value="", $size=0, $maxlength=0) {
	printf ("<input type=\"text\" NAME=\"%s\"%s%s%s>\n",
			$name,
			($value == "") ? "" : " value=\"$value\"",
			($size==0) ? "": " size=$size",
			($maxlength==0) ? "": " maxlength=$maxlength"
			);
}

function hiddenField ($name, $value) {
	printf ("<input type=\"hidden\" NAME=\"%s\" VALUE=\"%s\">\n", $name, $value);
}

function passwordField ($name, $value="", $size=0, $maxlength=0) {
	printf ("<input type=\"password\" NAME=\"%s\"%s%s%s>\n",
			$name,
			($value == "") ? "" : " value=\"$value\"",
			($size==0) ? "": " size=$size",
			($maxlength==0) ? "": " maxlength=$maxlength"
			);
}

function textArea ($name, $value="", $rows=2, $cols=40, $wrap="logical") {
	printf ("<textarea name=\"%s\" rows=\"%s\" cols=\"%s\" wrap=\"%s\">%s</textarea>\n",
			$name, $rows, $cols, $wrap, $value);
}

function listBox ($name, $values, $selected="", $multiple=0) {

	printf ("<select name=\"%s%s\"%s>\n", $name, ($multiple == 1)?"[]":"",
					($multiple == 1)?" MULTIPLE":"");
	while (list($k, $v) = each($values)) {
		printf(" <option value=\"%s\"%s>%s\n", $k, strcmp($selected,$k)?"":" selected", $v);
	}
    echo "</select>\n";
}

function checkBox ($name, $value=1, $current, $text="") {
	printf ("<input type=\"checkbox\" name=\"%s\" value=\"%s\"%s>%s\n",
			$name,
			$value, ($current==$value)? " checked" : "",
			(empty ($text)) ? "" : " $text" );
}

function radioButton ($name, $value=1, $current, $text="") {
	printf ("<input type=\"radio\" name=\"%s\" value=\"%s\"%s>%s\n",
			$name,
			$value, ($current==$value)? " checked" : "",
			(empty ($text)) ? "" : " $text" );
}

function caption ($text, $tag="") {
	$bt = empty($tag) ? "" : "<$tag>";
	$et = empty($tag) ? "" : "</$tag>";
	printf ("<caption>%s%s%s</caption>\n", $bt, $text, $et);
}

function submitButton ($name="", $value="Save") {
	printf ("<input type=\"submit\" %s VALUE=\"%s\">\n", empty($name) ? "" : "name=\"$name\"", $value);
}

function backButton ($name="", $value=" << ") {
?>
  <SCRIPT type="text/javascript" language="JavaScript">
	<!-- // Hide for old browsers
<?
	printf ("document.write ('<input type=\"button\" %s VALUE=\"%s\" onClick=\"history.back()\">');\n", empty($name) ? "" : "name=\"$name\"", $value);
?>
  // End of script -->
	</script>
<?
}

function resetButton ($name="", $value="Reset") {
	printf ("<input type=\"reset\" %s VALUE=\"%s\">\n", empty($name) ? "" : "name=\"$name\"", $value);
}

function br () {
	print "<BR>\n";
}

function hr ($width="", $size=0) {
	printf ("<HR%s%s>\n", (empty($width)) ? "" : " width=\"$width\"", ($size==0) ? "" : " size=\"$size\"");
}

function comment ($text) {
	printf ("<!-- %s -->\n", $text);
}

function wa_version () {
	return "w-agora version 3.0.4";
}

function wa_info() {
	global $bn_access;
	printf ("<P> This is %s using %s as database backend <P>", wa_version(), $bn_access );
	phpinfo();
}

?>
