<?php
# $Workfile: msql.php3$	$Revision: 1.2 $	$Date: 2000/11/21 18:18:50 $

/*
 *   W-AGORA
 *   -------
 *   File:		msql.php3
 *   Usage:		include file - Database access functions (mSQL)
 *   date:		August 1999
 *   version:	3.0.0b5
 *   Author:	Marc Druilhe <mdruilhe@araxe.fr>
 */

if (!defined("_DBACCESS")) {
	include ("$inc_dir/dbaccess.$ext");
}

class msql_access extends DBaccess {

var $dbname;

function OpenDB () {
	global $dbhost, $dbname;

	if (empty($dbhost))
		$this->dblink = msql_connect ();
	else
		$this->dblink = msql_connect ($dbhost);
	if (!$this->dblink) {
		echo "mSQL error: ".msql_error()."<BR>";
		return -3;
	}
	if (!msql_select_db ("$dbname")) {
		echo "mSQL error: ".msql_error()."<BR>";
		return -3;
	}
	$this->dbname = $dbname;
	return 0;
}

function deleteForum ($forum, $password) {

	$forum_passwd = $this->GetPassword($forum);
	if ($password != $forum_passwd) return (-2); /* invalid password */

	$query = "DROP TABLE $forum";
	$result = msql_query ($query, $this->dblink);
	if (!$result) return (-3); /* access problem */

	return (0);

}

function getPassword ($forum) {

	$query = "SELECT password FROM $forum WHERE cle=0";
	$result = msql_query ($query, $this->dblink);
	$num = msql_numrows($result);
	if ($num > 0) {
		$password = msql_result ($result, 0, "password");
		return ("$password");
	}
	return "";
}

function changePassword ($forum, $old_pass, $new_pass) {

	$forum_passwd = $this->GetPassword($forum);
	if ($old_pass != $forum_passwd) return (-2); /* invalid password */

	$query = "UPDATE $forum SET password='$new_pass' WHERE cle=0";
	$result = msql_query ($query, $this->dblink);
	if (!$result) return (-3); /* access problem */

	return (0);
}

function listThreads ($forum, $first=0, $last=0) {
	global $bn_maxthreads, $list_var;

	if (!$bn_maxthreads) $bn_maxthreads = 0;
	// 1) gets total count # of notes
	$result = msql_query ("SELECT cle FROM $forum WHERE cle<>0", $this->dblink);
	if (!$result) {
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3); 
	}
	$ret["total"] =  msql_numrows($result);
	if ($ret["total"] == 0) return ($ret);

	// 2) Find the first thread to be displayed in the page starting from 
	// the end (last_thread - bn_max_threads)
	if (($bn_maxthreads>0) && $last && !$first) {
		$query = "SELECT thread FROM $forum WHERE thread >=$last ORDER BY thread";
		$result = msql_query ("$query", $this->dblink);
		if ($result) {
			$i=0;
			while ($row = msql_fetch_row($result)) {
				if ($first != $row[0]) {
					$first = $row[0];
					$i++;
				}
				if (($bn_maxthreads > 0) && ($i >= $bn_maxthreads))
					break;
			}
		}
	}

	// 3) gets all threads
	$where="cle<>0";
	if ($first) $where .= " AND thread<=$first";
	if ($last) $where .= " AND thread>=$last";
	$cols = "cle,parent,childs,thread,newest";
	while (list($var,$val) = each($list_var)) {
		if ($val==1) $cols.=",$var";
	}
	$result = msql_query ("SELECT $cols FROM $forum WHERE $where ORDER BY thread DESC,cle ASC", $this->dblink);
	if (!$result) {
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3); 
	}

	$tlast=time(); $tfirst=0; $tcount = 0;
	
	while ($row = msql_fetch_array($result)) {
		$key = $row["cle"];
		$parent = $row["parent"];
		if (!$parent) { // new thread
			if (($tcount < $bn_maxthreads) || ($bn_maxthreads==0)) {
				$this->entries[$key] = $row;
				$this->children[$parent][] = $key;
				if ($key < $tlast) $tlast = $key;
				if ($key > $tfirst) $tfirst = $key;
				$tcount++;
			}
			else
				$next=1;
		}
		else {
			$this->entries[$key] = $row;
			$this->children[$parent][] = $key;
		}
	}

	if (!isSet ($prev)) {
		$result = msql_query ("SELECT cle FROM $forum WHERE thread>$tfirst AND cle<>0", $this->dblink);
		if (!$result) {
			echo "mSQL error: ".msql_error()."<BR>";
			return (-3); 
		}
		$prev = msql_numrows($result);
	}

	if (!isSet ($next)) {
		$result = msql_query ("SELECT cle FROM $forum WHERE thread<$tlast AND cle<>0", $this->dblink);
		if (!$result) {
			echo "mSQL error: ".msql_error()."<BR>";
			return (-3); 
		}
		$next = msql_numrows($result);
	}
	
	msql_FreeResult($result);

	$ret["threads"]=$tcount;
	$ret["next"]=$next;
	$ret["prev"]=$prev;
	$ret["first"]=$tfirst;
	$ret["last"]=$tlast;
	return ($ret);
}

function listNotes ($forum, $first=0, $last=0, $sort="", $where="") {
	$this->listThreads($forum, $first, $last);
}

function getNote ($forum, $key) {

	$result = msql_query ("SELECT * FROM $forum WHERE cle=$key", $this->dblink);
	if (!$result) {
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3); 
	}
	$num = msql_numrows($result);
	if ($num < 1) return (-4);

	$note = msql_fetch_array($result);
	msql_FreeResult($result);

	$whereclause = "thread > " . $note["thread"];
	$result = msql_query ("SELECT thread FROM $forum WHERE $whereclause ORDER BY thread", $this->dblink);
	if ($result) {
		$prev = msql_fetch_row($result);
		$note["tprev"]= $prev[0];
		msql_FreeResult($result);
	}
	
	$whereclause = "thread < " . $note["thread"];
	$result = msql_query ("SELECT thread FROM $forum WHERE $whereclause ORDER BY thread DESC", $this->dblink);
	if ($result) {
		$next = msql_fetch_row($result);
		$note["tnext"]= $next[0];
		msql_FreeResult($result);
	}

	return ($note);
}

function getThreadNewest ($forum, $thread) {
 
 	$where="thread=$thread AND cle<>0";
	$result = msql_query ("SELECT MAX(unixdate) FROM $forum WHERE $where", $this->dblink);
 	if (!$result) {
		echo "mSQL error: ".msql_error()."<BR>";
 		return (-3);
 	}
 	$row = msql_fetch_row($result);
	$newest = $row[0];
	msql_FreeResult($result);
	return $newest;
}

function getThread ($forum, $key, $thread) {
	global $list_var;

	$where="thread=$thread AND cle<>0";

	$result = msql_query ("SELECT * FROM $forum WHERE $where ORDER BY cle", $this->dblink);
	if (!$result) {
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3); 
	}

	while ($row = msql_fetch_array($result)) {
		$key = $row["cle"];
		$parent = $row["parent"];
		$this->entries[$key] = $row;
		$this->children[$parent][] = $key;
	}

	msql_FreeResult($result);

}

function insertNote ($forum, $key, $fields) {

	$ret = $this->insert ($forum, $key, 0, $key, $fields);
	return $ret;
}

function threadNote ($forum, $key, $parent_key, $fields) {
	
	$result = msql_query ("SELECT * FROM $forum WHERE cle=$parent_key", $this->dblink);
	if (!$result) {
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3); 
	}

	$num = msql_numrows($result);
	if ($num  < 1)
		return -4;
	$thread = msql_result ($result, 0, "thread");
	$childs = msql_result ($result, 0, "childs");
	$childs++;
	$values = "childs=$childs, thread=$thread";

	$result = msql_query ( "UPDATE $forum SET $values WHERE cle=$parent_key", $this->dblink);
	if (!$result) {
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3); 
	}

	$newest = $fields["unixdate"];
	$result = msql_query ( "UPDATE $forum SET newest=$newest WHERE thread=$thread", $this->dblink);
	if (!$result) {
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3);
	}

	$ret = $this->insert ($forum, $key, $parent_key, $thread, $fields);
	return $ret;
}

function insert ($forum, $key, $parent, $thread, &$note) {

	// Get fields defined in table
	$result = msql_List_fields("$this->dbname", $forum);
	if (!$result) { /* access problem */
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3); 
	}

	$note["parent"] = $parent;
	$note["childs"] = 0;
	$note["thread"] = $thread;
	$note["newest"] = $note["unixdate"];
	$cols = "cle";
	$values = "$key";
	msql_field_seek($result, 1); // skip field "key"

	// gets fields name and type
	while ($db_field = msql_fetch_field($result)) {
		$colname = $db_field->name;
		$coltype = $db_field->type;
		$val = addSlashes($note[$colname]);
		if (!empty ($val)) {
			$cols .= ", " . $colname;
			if ($coltype == "int")
				$values .= ", " . IntVal($val);
			else
				$values .= ", '$val'";
		}
if ($this->debug) echo "insert() - name : $colname, value: $val, type: $coltype <br>";
	}

if ($this->debug) echo "INSERT INTO $forum ($cols) VALUES($values)";
	$result = msql_query("INSERT INTO $forum ($cols) VALUES($values)", $this->dblink);
	if (!$result) { /* insert problem */
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3); 
	}

	return ($key);
}

function updateNote ($forum, $key, $passwd, &$fields) {

	$result = msql_query ("SELECT * FROM $forum WHERE cle=$key", $this->dblink);
	if ($result < 0) return (-3);  /* access error */
	
	$num = msql_numrows($result);
	if ($num < 1) return (-4); /* no row selected */

	$admin_password = $this->GetPassword($forum);
	$password = msql_result ($result, 0, "password");
	if (($passwd != $password) && ($passwd != $admin_password)) {
		return (-2); /* invalid password */
	}

	$fields["parent"] = msql_result ($result, 0, "parent");
	$fields["childs"] = msql_result ($result, 0, "childs");
	$fields["thread"] = msql_result ($result, 0, "thread");
	$fields["newest"] = msql_result ($result, 0, "newest");

	$values = "cle=$key";

	$result = msql_List_fields("$this->dbname", $forum);
	if (!$result) { /* access problem */
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3); 
	}

	msql_field_seek($result, 1);

	// gets fields name and type
	while ($db_field = msql_fetch_field($result)) {
		$colname = $db_field->name;
		$coltype = $db_field->type;
		$val = addSlashes($fields[$colname]);
		if (!empty($val)) {
			if ($coltype == "int")
				$values .= ", $colname= " . intVal($val);
			else
				$values .= ", $colname= '$val'";
		}
	}

	$result = msql_query ("UPDATE $forum SET $values WHERE cle=$key", $this->dblink);
	if (!$result) {
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3); 
	}

	return (0);
}

function updateThread($forum, $parent, $newthread) {

	$result = msql_query ("UPDATE $forum SET thread=$newthread WHERE parent=$parent", $this->dblink);
	if (!$result) {
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3); 
	}

	$result = msql_query ("SELECT cle, childs FROM $forum WHERE parent=$parent", $this->dblink);
	if (!$result) {
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3); 
	}
	
	while ($row = msql_fetch_row($result)) {
		$key=$row[0];
		$childs=$row[1];
		if ($childs > 0) {
			$this->updateThread ($forum, $key, $newthread);
		}
	}
	msql_FreeResult($result);
}

function deleteNote ($forum, $key, $pass, $bn_dir_notes) {

	$result = msql_query ( "SELECT * FROM $forum WHERE cle=$key", $this->dblink);
	if (!$result) {
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3); 
	}
	
	$num = msql_numrows($result);
	if ($num < 1):
		return (-4); /* no row selected */
	endif;

	$admin_password = $this->GetPassword($forum);
	$password = msql_result ($result, 0, "password");
	if (($pass != $password) && ($pass != $admin_password)):
		return (-2); /* invalid password */
	endif;

 	$filename = @msql_result ($result, 0, "filename");
 	$attachment = @msql_result ($result, 0, "attachment");
 	$parent = msql_result ($result, 0, "parent");
 	$childs = msql_result ($result, 0, "childs");
 	$thread = msql_result ($result, 0, "thread");

	// delete note
	$result = msql_query ("DELETE FROM $forum WHERE cle=$key", $this->dblink);
	if (!$result) {
		echo "mSQL error: ".msql_error()."<BR>";
		return (-3);
	}

	if ($parent > 0) {
		// decrement childs count in parent
		$result = msql_query ("UPDATE $forum SET childs=childs-1 WHERE cle=$parent", $this->dblink);
		if (!$result) {
			echo "mSQL error: ".msql_error()."<BR>";
			return (-3);
		}
	}
	else {
		// update thread value
		$result = msql_query ("SELECT cle, childs FROM $forum WHERE parent=$key", $this->dblink);
		if (!$result) {
			echo "mSQL error: ".msql_error()."<BR>";
			return (-3); 
		}
		while ($row = msql_fetch_row($result)) {
			$childkey=$row[0];
			$upd = msql_query ("UPDATE $forum SET thread=$childkey WHERE cle=$childkey", $this->dblink);
			if (!$upd) {
				echo "mSQL error: ".msql_error()."<BR>";
				return (-3); 
			}
			if ($row[1] > 0) {
				$this->updateThread ($forum, $childkey, $childkey);
			}
		}
	}
	
	// Link children to parent
	if ($childs > 0) {
		$result = msql_query ("UPDATE $forum SET parent=$parent WHERE parent=$key", $this->dblink);
		if (!$result) {
			echo "mSQL error: ".msql_error()."<BR>";
			return (-3);
		}
	}

	// update newest in thread
	if ($key != $thread) {
		$newest = $this->getThreadNewest ($forum, $thread);
		$result = msql_query ("UPDATE $forum SET newest=$newest WHERE thread=$thread", $this->dblink);
		if (!$result) {
			echo "mSQL error: ".msql_error()."<BR>";
			return (-3);
		}
	}
	
	if (($filename != "none") && is_file("$bn_dir_notes/$filename")) {
 		@unlink ("$bn_dir_notes/$filename");
	}

	if ($attachment && ($attachment != "none") && is_file ("$bn_dir_notes/$key/$attachment") ) {
		@unlink ("$bn_dir_notes/$key/$attachment");
		@rmdir ("$bn_dir_notes/$key");
	}
	return (0);
}

function mDeleteDate ($forum, $from, $to, $passwd, $bn_dir_notes) {

	$admin_password	= $this->getPassword($forum);
	if ($passwd != $admin_password):
		return	(-2); /* invalid password */
	endif;

	$result = msql_query ("SELECT cle FROM $forum WHERE cle>=$from AND cle <= $to", $this->dblink);
	$num = msql_numrows($result);
	$i=0;
	while ($i < $num):
		$note = msql_result ($result, $i, "cle");
		$ret = $this->deleteNote($forum, $note, $passwd, $bn_dir_notes);
		if ($ret < 0):
			return ($ret);
		else:
			$i++;
		endif;
	endwhile;

	msql_FreeResult($result);
	return (0);
}

}; // end class
?>
