<?php

/*
 *	W-AGORA 3.0
 *	-----------
 *	$Id: mssql7.php3,v 1.2 2001/01/30 09:10:39 mdruilhe Exp $
 *	Usage:		include file - Database access functions (msSQL)
 *	Author:		Jimmy Daresta <jimmy@sitedevelopment.com
 *	Based and adapted from the MySQL version (mysql.php3) by Marc Druilhe <mdruilhe@w-agora.com>
 */

/* 

README

Version History:

01/16/01 Beta 1 - Initial conversion of the mysql version to a MSSQL 7 version. Also 
		  modified the setup.php3 for to create forums with the new include
		  file

01/17/01 Beta 2 - Modified the betaMSSQL7.php3 file for the search feature to work.

01/21/01 Beta 3 - Fixed a bug in the posting due to the usage of the addslashes function.
		  All single quotes (') are replaced with double single quotes ('') to
		  escape out he single quotes the MSSQL 7 default.

01/26/01 Beta 4 - Integration in 3.0.4 (Marc)
          renamed file to mssql7
		  included README file from Jimmy

01/28/01 Beta 5 - Discovered a 255 character limit on text fields with the default mssql dll.
		  See the notes below. 
		  changed connection to persistent

Requirements:
W-agora 3.02 or greater
PHP3 or greater with MSSQL7 support. Tested fully with PHP4. PHP4 now comes with the .dll 
for windows.

Known Items/Bugs:
-On occasions error messages are seen when deleting notes, but the notes are still deleted.
-There is no error checking. MSSQL functions lack the error checking that MySQL functions
 have

Disclaimer:
This file is provided with no responsibility on the authors part.
Feel free to send questions via e-mail to jimmy@sitedevelopment.com, but 
there is no guarantee all questions can be answered.


****************IMPORTANT NOTE!********************************
*																
*There is no error checking here. All lines referring to it 
*are commented out. This is due to the fact that the MSSQL does
*not have built in functions for returning whether a query was 
*successful or not. The only option is to disabled PHP errors all
*together and then get the last message from the MSSQL server.
*
*By default the mssql dll has a 255 character limit return on fields. To over come this 
*you need add the following lines in the php.ini file in the MSSQL section.
*
*mssql.textsize = 100000000
*mssql.textlimit = 100000000
*
*All queries have been modifed to work with MSSQL7. This has not 
*been tested with MSSQL 6.5 or 2000.
*
*/

if (!defined("_DBACCESS")) {
	include ("$inc_dir/dbaccess.$ext");
}

class mssql7_access extends DBaccess {

var $dbname;
var $dblink;
var $site;

function OpenDB () {
	global $site, $dbhost, $dbport, $dbuser, $dbpassword, $dbname, $session_id;

	if (!empty ($dbhost)) {
		$host = $dbhost;
		if (!empty ($dbport)) {
			$host .= ":$dbport";
		}
	}

	$this->dblink = mssql_pconnect ($host, $dbuser, $dbpassword);
	if (empty($this->dblink)) {
		return -3;
	}

	if (empty ($dbname)) {
		$dbname ="agora";
	}

	if (!mssql_select_db ("$dbname", $this->dblink)) {
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
		return -3;
	}
	$this->dbname = $dbname;
	if (!empty ($site)) {
		$this->site = $site;
	}

	return 0;
}

function createForum ($forum, $password) {
	global $bn_var, $db_var, $session_id;
	global $bn_var_size;

	/* Check if table exists */
	$row_query = "Exec sp_tables";
	
	$result = mssql_query($row_query);

	//$result = @mssql_List_Tables ("$this->dbname");
//	if (!$result) {
//		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}
	$count = mssql_Num_Rows ($result);
	$i=0; $found=0;
	while ($i < $count):
		if ($forum == mssql_result ($result, $i, "TABLE_NAME")):
			$found=1; $i=$count;
		else:
			$i++;
		endif;
	endwhile;
	if ($found):
		return (-1); /*  table already exist */
	endif;

	/* Create Table */
	$desc = "cle INTEGER NOT NULL PRIMARY KEY";
	$desc .= ", parent INTEGER NOT NULL DEFAULT 0";
	$desc .= ", childs INTEGER NOT NULL DEFAULT 0";
	$desc .= ", thread INTEGER NOT NULL DEFAULT 0";
	$desc .= ", newest INTEGER NOT NULL DEFAULT 0";
	$values = "0, 0, 0, 0, 0";
	$unixdate = time();
	$count = Count ($bn_var);
	$i=0;
	while ($i < $count):
		$col = $bn_var[$i];
		$val = $$col;
		$size = $bn_var_size[$col];

		if (ereg ("^[0-9+]+$", $size) ) {
			if ($size>255) {
				$desc .= ", $col TEXT";
			} else {
				$desc .= ", $col VARCHAR($size) NOT NULL DEFAULT ''";
			}
			$values .= ", '$val'";
		} else {
			$type = strtoupper($size);
			switch ($type) {
				case "INT":
					$desc .= ", $col INTEGER NOT NULL DEFAULT 0";
					$values .= ", " . IntVal($val);
					break;
				case "AUTO":
					$desc .= ", $col INTEGER IDENTITY(1,1)";
					$values .= ", " . IntVal($val);
					break;
				default:
					$desc .= ", $col $type";
					$values .= ", '$val'";
					break;
			}
		}
		$i++;
	endwhile;
	$count = Count ($db_var);
	$i=0;
	while ($i < $count):
		$col = $db_var[$i];
		$val = $$col;
		$size = $bn_var_size[$col];
		if (ereg ("^[0-9+]+$", $size) ) {
			if ($size>255) {
				$desc .= ", $col TEXT";
			} else {
				$desc .= ", $col VARCHAR($size) NOT NULL DEFAULT ''";
			}
			$values .= ", '$val'";
		} else {
			$type = strtoupper($size);
			switch ($type) {
				case "INT":
					$desc .= ", $col INTEGER NOT NULL DEFAULT 0";
					$values .= ", " . IntVal($val);
					break;
				case "AUTO":
					$desc .= ", $col INTEGER IDENTITY(1,1)";
					$values .= ", " . IntVal($val);
					break;
				default:
					$desc .= ", $col $type";
					$values .= ", '$val'";
					break;
			}
		}
		$i++;
	endwhile;
	
	$result = mssql_query ("CREATE TABLE $forum ($desc)");
	
	//if (!$result) {  /* access PB  */
	//	//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
	//	return (-3);
	//}

	$result = mssql_query("INSERT INTO $forum VALUES($values)");
	//echo mssql_get_last_message ();

	//if (!$result) {  /* access PB  */
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
	//	return (-3);
	//}
	return (0);
}

function deleteForum ($forum, $password) {
	$forum_passwd = $this->getPassword($forum);
	if ($password != $forum_passwd) return (-2); /* invalid password */

	$query = "DROP TABLE $forum";
	$result = mssql_query ($query, $this->dblink);
	if (!$result) return (-3); /* access problem */
	return (0);
}

function getPassword ($forum) {
	$query = "SELECT password FROM $forum WHERE cle=0";
	$result = mssql_query ($query);
	if (!$result) {  /* access PB  */
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
		return "";
	}
	$num = mssql_num_rows($result);
	if ($num > 0) {
		$password = mssql_result ($result, 0, "password");
		return ("$password");
	}
	return "";
}

function changePassword ($forum, $old_pass, $new_pass) {

	$forum_passwd = $this->getPassword($forum);
	if ($old_pass != $forum_passwd) return (-2); /* invalid password */

	$query = "UPDATE $forum SET password='$new_pass' WHERE cle=0";
	$result = mssql_query ($query, $this->dblink);
	if (!$result) return (-3); /* access problem */

	return (0);
}

function listThreads ($forum, $first=0, $last=0) {
	global $bn_maxthreads, $list_var, $session_id;

	$bn_maxthreads = (isSet($bn_maxthreads) ) ? $bn_maxthreads : 0;
	settype ($bn_maxthreads, "integer");
	settype ($first, "integer");
	settype ($last, "integer");

#	1) gets total count # of notes
#	------------------------------
	$result = mssql_query ("SELECT count(*) as total FROM $forum WHERE cle<>0");
//	if (!$result) {
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}

	$ret["total"] = @mssql_result ($result, 0, "total");
	if ($ret["total"] == 0) {
		return ($ret);
	}
	mssql_free_result($result);

#	2) Find the first (and last) thread to be displayed in the page
#	and gets number of notes per thread
#	----------------------------------------------------------------
	if (!$last) {
		$order="DESC";
		$last=1;
	} else {
		$order="ASC";
	}

	$where = "newest>=$last"; // $last default to 1: don't display key 0
	if ($first>0) {
		$where .= " AND newest<=$first";
	}

	$limit = (empty($bn_maxthreads)) ? "" : "TOP $bn_maxthreads";

	$query = "SELECT  $limit thread, newest, count(*)  FROM $forum WHERE $where GROUP BY newest,thread ORDER BY newest $order";
	$result = mssql_query ("$query", $this->dblink);
	$tcount = @mssql_num_rows ($result);

	if ($tcount > 0) {
		if ($order=="DESC") {
			$tfirst  = @mssql_result ($result, 0, "newest");
			$tlast = @mssql_result ($result, $tcount-1, "newest");
		} else {
			$tlast  = @mssql_result ($result, 0, "newest");
			$tfirst = @mssql_result ($result, $tcount-1, "newest");
		}

		mssql_data_seek($result, 0);
		while ($row = mssql_fetch_row($result)) {
			$t = $row[0];
			$replies[$t] = $row[2] - 1;
		}
	}
	mssql_free_result($result);

	$ret["threads"]=$tcount; // number of threads displayed
	$ret["first"]=$tfirst;
	$ret["last"]=$tlast;
	$ret["session_id"]=$session_id;

	if ($tcount < 1) {
		$ret["next"] = 0;
		$ret["prev"] = 0;
		return $ret;
	}
	
#	3) gets all threads
#	-------------------

	$where = "newest<=$tfirst AND newest>=$tlast";

	$cols = "cle,parent,childs,thread,newest";
	while (list($var,$val) = each($list_var)) {
		if ($val==1) $cols.=",$var";
	}

	$result = mssql_query ("SELECT $cols FROM $forum WHERE $where ORDER BY newest DESC,cle ASC", $this->dblink);
//	if (!$result) {
//		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}

	reset ($this->entries);
	reset ($this->children);
	$ncount=0;
	while ($row = mssql_fetch_array($result)) {
		$key = (int) $row["cle"];
		$parent = (int) $row["parent"];
		if ($parent==0) {
			$row["replies"] = $replies[$key];
		}
		if (!empty($row["bn_name"])) {
			$table = $row["bn_name"];
			$r2 = @mssql_query ("select count(*) as notes_count, max(unixdate) as last_note from $table");
			if ($r2) {
				$row["notes_count"]  = @mssql_result ($r2, 0, "notes_count");
				$row["last_note"]  = @mssql_result ($r2, 0, "last_note");
				mssql_free_result($r2);
			}
		}
			
if ($this->debug) echo "listThread() key: $key, parent: $parent , session_id: $session_id , replies: " . $replies[$key] . "<br>";
		$this->entries[$key] = $row;
		$this->children[$parent][] = $key;
		$ncount++;
	}

	$ret["notes"]=$ncount;	// number of notes displayed
	mssql_free_result($result);
	
#	4) gets next/previous count
#	---------------------------
	$result = mssql_query ("SELECT count(*) AS prev FROM $forum WHERE newest>$tfirst", $this->dblink);
//	if (!$result) {
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
	//	return (-3);
//	}
	$ret["prev"]  = @mssql_result ($result, 0, "prev");

	mssql_free_result($result);

	$result = mssql_query ("SELECT count(*) AS next FROM $forum WHERE cle<> 0 AND newest<$tlast", $this->dblink);
//	if (!$result) {
//		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}
	$ret["next"]  = @mssql_result ($result, 0, "next");

	mssql_free_result($result);
		
	return $ret;
}

function listNotes ($forum, $first=0, $last=0, $sort="", $where="") {
	global $bn_maxthreads, $list_var, $session_id;
	$bn_maxthreads = (isSet($bn_maxthreads) ) ? $bn_maxthreads : 0;
	settype ($bn_maxthreads, "integer");
	settype ($first, "integer");
	settype ($last, "integer");

#	1) gets total count # of notes
#	------------------------------
	$result = mssql_query ("SELECT count(*) as total FROM $forum WHERE cle<>0", $this->dblink);
//	if (!$result) {
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}

	$ret["total"] = @mssql_result ($result, 0, "total");
	if ($ret["total"] == 0) {
		return $ret;
	}
	mssql_free_result($result);

#	2) gets all notes sorted by $sort
#	---------------------------------
	$whereClause = "WHERE cle>0"; // skip administrative record
	
	if (!empty($where)) {
		$whereClause .= " AND $where";
		$result = mssql_query ("SELECT count(*) as nquery FROM $forum $whereClause", $this->dblink);
		$ret["nquery"] = @mssql_result ($result, 0, "nquery");
	} else {
		$ret["nquery"] = $ret["total"];
	}
	
	$orderClause = (empty ($sort)) ? "" : " ORDER BY $sort";
	$limit="";
	
	if ($bn_maxthreads>0) {
		if ($last > 0) {
			$start = ($last-$bn_maxthreads)+1;
			$start = ($start<0) ? 0 : $start;
		} else {
			$start=$first;
		}
		$limit = "TOP $bn_maxthreads";
	} else {
		$start=0;
	}
	
	$cols = "cle,parent,childs,thread,newest";
	while (list($var,$val) = each($list_var)) {
		if ($val==1) $cols.=",$var";
	}

	$query = "SELECT  $limit $cols FROM $forum $whereClause $orderClause";
if ($debug) echo "query: $query<br>";
	$result = mssql_query ("$query", $this->dblink);
//	if (!$result) {
//		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}

	reset ($this->entries);
	reset ($this->children);
	$tcount=0;
	while ($row = mssql_fetch_array($result)) {
		$key = $row["cle"];
		$row["parent"]=0;
		if (!empty($row["bn_name"])) {
			$table = $row["bn_name"];
			$r2 = @mssql_query ("select count(*) as notes_count, max(unixdate) as last_note from $table");
			if ($r2) {
				$row["notes_count"]  = @mysql_result ($r2, 0, "notes_count");
				$row["last_note"]  = @mysql_result ($r2, 0, "last_note");
				mssql_free_result($r2);
			}
		}
		$this->entries[$key] = $row;
		$this->children[0][] = $key;
		$tcount++;
	}

	$ret["threads"]=$tcount;	// number of threads displayed
	$ret["notes"]=$tcount;	// number of notes displayed
	mssql_free_result($result);

#	3) gets next/previous (1 if TRUE)
#	---------------------------------
	$ret["first"] = $start;
	$ret["last"] = $start + $tcount - 1;
	$ret["next"] = ($ret["nquery"] > $ret["last"]+1) ? 1 : 0;
	$ret["prev"] = ($ret["first"] > 1) ? 1 : 0;
	$ret["session_id"] = $session_id;	
	return $ret;
}

function getNote ($forum, $key, $where="") {
	$result = mssql_query ("SELECT * FROM $forum WHERE cle=$key", $this->dblink);
//	if (!$result) {
//		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}
	$num = mssql_num_rows($result);
	if ($num < 1) return (-4);

	$note = mssql_fetch_array($result);

	mssql_free_result($result);

# get key of previous thread
# --------------------------
	$whereclause = "newest > " . $note["newest"];
	if (!empty($where)) {
		$whereClause .= " AND $where";
	}
	$result = @mssql_query ("SELECT TOP 1 thread FROM $forum WHERE $whereclause ORDER BY newest", $this->dblink);
	if ($result) {
		$prev = mssql_fetch_row($result);
		$note["tprev"]= $prev[0];
		mssql_free_result($result);
	}

# get key of next thread
# --------------------------
	$whereclause = "newest < " . $note["newest"];
	if (!empty($where)) {
		$whereClause .= " AND $where";
	}
	$result = @mssql_query ("SELECT TOP 1 thread FROM $forum WHERE $whereclause ORDER BY newest DESC", $this->dblink);
	if ($result) {
		$next = mssql_fetch_row($result);
		$note["tnext"]= $next[0];
	}
	mssql_free_result($result);

	return ($note);
}

function getThreadNewest ($forum, $thread) {
 	$where="thread=$thread AND cle<>0";
	$result = mssql_query ("SELECT MAX(unixdate) FROM $forum WHERE $where", $this->dblink);
 //	if (!$result) {
 		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
 	//	return (-3);
 //	}
 	$row = mssql_fetch_row($result);
	$newest = $row[0];
	mssql_free_result($result);
	return $newest;
}


function getThread ($forum, $key, $thread) {
	global $session_id;
	reset ($this->entries);
	reset ($this->children);
	
	$where="thread=$thread AND cle<>0";

	$cols = "cle,parent,childs,thread,newest";
	while (list($var,$val) = each($GLOBALS["list_var"])) {
		if ($val==1) $cols.=",$var";
	}

	$result = mssql_query ("SELECT $cols FROM $forum WHERE $where ORDER BY cle", $this->dblink);
	if (!$result) {
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
		return (-3);
	}

	while ($row = mssql_fetch_array($result)) {
		$key = $row["cle"];
		$parent = $row["parent"];
		$this->entries[$key] = $row;
		$this->children[$parent][] = $key;
	}

	mssql_free_result($result);
	return 0;
}

function insertNote ($forum, $key, $fields) {
	$ret = $this->insert ($forum, $key, 0, $key, $fields);
	return $ret;
}

function threadNote ($forum, $key, $parent_key, $fields) {
	$result = mssql_query ("SELECT * FROM $forum WHERE cle=$parent_key", $this->dblink);
//	if (!$result) {
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}

	$num = mssql_num_rows($result);
	if ($num  < 1)
		return -4;
	$thread = mssql_result ($result, 0, "thread");
	$childs = mssql_result ($result, 0, "childs");
	$childs++;
	$values = "childs=$childs, thread=$thread";

	$result = mssql_query ( "UPDATE $forum SET $values WHERE cle=$parent_key", $this->dblink);
//	if (!$result) {
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
	//	return (-3);
//	}

	$newest = $fields["unixdate"];
	$result = mssql_query ( "UPDATE $forum SET newest=$newest WHERE thread=$thread", $this->dblink);
//	if (!$result) {
//		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}

	$ret = $this->insert ($forum, $key, $parent_key, $thread, $fields);
	return $ret;
}

function insert ($forum, $key, $parent, $thread, &$note) {
	// Get fields defined in table
	$row_query = "SELECT TOP 1 * FROM ".$forum;
	
	$query_result = mssql_query($row_query);
	
	for ($field_number = 0 ; $field_number <= $number_fields - 1 ; $field_number++ ) { 
		$result[$field_number] = mssql_field_name($query_result, $field_number) ;
	}
	
//	if (!$result) { /* access problem */
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}

	$note["parent"] = $parent;
	$note["childs"] = 0;
	$note["thread"] = $thread;
	$note["newest"] = $note["unixdate"];
	$cols = "cle";
	$values = "$key";
	mssql_field_seek($query_result, 1); // skip field "key"

	// gets fields name and type
	while ($db_field = mssql_fetch_field($query_result)) {
		$colname = $db_field->name;
		$coltype = $db_field->type;
		$val = eregi_replace("'", "''", $note[$colname]);
		if (!empty($val)) {
			$cols .= ", $colname";
			if ($coltype == "int")
				$values .= ", " . IntVal($val);
			else
				$values .= ", '$val'";
		}
if ($this->debug) echo "insert() name : $colname, value: $val, type: $coltype <br>";
	}

if ($this->debug) echo "INSERT INTO $forum ($cols) VALUES($values)";
	$result = mssql_query("INSERT INTO $forum ($cols) VALUES($values)");
//	if (!$result) { /* insert problem */
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}

	return ($key);
}

function updateNote ($forum, $key, $passwd, &$fields) {

	$result = mssql_query ("SELECT * FROM $forum WHERE cle=$key", $this->dblink);
	if ($result < 0) return (-3);  /* access error */
	
	$num = mssql_num_rows($result);
	if ($num < 1) return (-4); /* no row selected */

	$admin_password = $this->GetPassword($forum);
	$password = mssql_result ($result, 0, "password");
	if (($passwd != $password) && ($passwd != $admin_password)):
		return (-2); /* invalid password */
	endif;

	$fields["parent"] = mssql_result ($result, 0, "parent");
	$fields["childs"] = mssql_result ($result, 0, "childs");
	$fields["thread"] = mssql_result ($result, 0, "thread");
	$fields["newest"] = mssql_result ($result, 0, "newest");

	$values = "cle=$key";
	$row_query = "SELECT TOP 1 * FROM ".$forum;
	

	$query_result = mssql_query ($row_query);
	
	for ($field_number = 0 ; $field_number <= $number_fields - 1 ; $field_number++ ) { 
		$result[$field_number] = mssql_field_name($query_result, $field_number) ;
	}


	//$result = mssql_List_fields("$this->dbname", $forum);
//	if (!$result) { /* access problem */
//		echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}

	mssql_field_seek($result, 1);

	// gets fields name and type
	while ($db_field = mssql_fetch_field($result)) {
		$colname = $db_field->name;
		$coltype = $db_field->type;
		$val = eregi_replace("'", "''", $fields[$colname]);
		if (!empty($val)) {
			if ($coltype == "int")
				$values .= ", $colname= " . intVal($val);
			else
				$values .= ", $colname= '$val'";
		}
if ($this->debug) echo "update() - name : $colname, value: $val, type: $coltype <br>";
	}

	$result = mssql_query ("UPDATE $forum SET $values WHERE cle=$key", $this->dblink);
//	if (!$result) {
//		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}

	return (0);
}

function updateThread($forum, $parent, $newthread) {

	$result = mssql_query ("UPDATE $forum SET thread=$newthread WHERE parent=$parent", $this->dblink);
	if (!$result) {
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
		return (-3); 
	}

	$result = mssql_query ("SELECT cle, childs FROM $forum WHERE parent=$parent", $this->dblink);
//	if (!$result) {
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3); 
//	}
	
	while ($row = mssql_fetch_row($result)) {
		$key=$row[0];
		$childs=$row[1];
		if ($childs > 0) {
			$this->updateThread ($forum, $key, $newthread);
		}
	}
	mssql_free_result($result);
}

function deleteNote ($forum, $key, $passwd, $bn_dir_notes) {

	$result = mssql_query ( "SELECT * FROM $forum WHERE cle=$key", $this->dblink);
//	if (!$result) {
		//echo "msSQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}
 	
	$num = mssql_num_rows($result);
	if ($num < 1):
		return (-4); /* no row selected */
	endif;

	$admin_password = $this->GetPassword($forum);
	$password = mssql_result ($result, 0, "password");
	if (($passwd != $password) && ($passwd != $admin_password)):
		return (-2); /* invalid password */
	endif;

 	$filename = @mssql_result ($result, 0, "filename");
 	$attachment = @mssql_result ($result, 0, "attachment");
 	$parent = mssql_result ($result, 0, "parent");
 	$childs = mssql_result ($result, 0, "childs");
 	$thread = mssql_result ($result, 0, "thread");

	// delete note
	$result = mssql_query ("DELETE FROM $forum WHERE cle=$key", $this->dblink);
	if (!$result) {
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
		return (-3);
	}

	if ($parent > 0) {
		// decrement childs count in parent
		$result = mssql_query ("UPDATE $forum SET childs=childs-1 WHERE cle=$parent", $this->dblink);
		if (!$result) {
			//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
			return (-3);
		}
	}
	else {
		// update thread value
		$result = mssql_query ("SELECT cle, childs FROM $forum WHERE parent=$key", $this->dblink);
		if (!$result) {
			//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
			return (-3); 
		}
		while ($row = mssql_fetch_row($result)) {
			$childkey=$row[0];
			$upd = mssql_query ("UPDATE $forum SET thread=$childkey WHERE cle=$childkey", $this->dblink);
			if (!$upd) {
				//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
				return (-3); 
			}
			if ($row[1] > 0) {
				$this->updateThread ($forum, $childkey, $childkey);
			}
		}
	}
	
	// Link children to parent
	if ($childs > 0) {
		$result = mssql_query ("UPDATE $forum SET parent=$parent WHERE parent=$key", $this->dblink);
		if (!$result) {
			//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
			return (-3);
		}
	}


	// update newest in thread
	if ($key != $thread) {
		$newest = $this->getThreadNewest ($forum, $thread);
		$result = mssql_query ("UPDATE $forum SET newest=$newest WHERE thread=$thread", $this->dblink);
		if (!$result) {
			//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
			return (-3);
		}
	}
	
	if (!empty($filename) && ($filename != "none") && is_file("$bn_dir_notes/$filename")) {
 		@unlink ("$bn_dir_notes/$filename");
	}

	if (!empty($attachment) && ($attachment != "none") && is_file ("$bn_dir_notes/$key/$attachment") ) {
		@unlink ("$bn_dir_notes/$key/$attachment");
		@rmdir ("$bn_dir_notes/$key");
	}
	return (0);
}

function mDeleteDate ($forum, $from, $to, $passwd, $bn_dir_notes) {

	$admin_password	= $this->getPassword($forum);
	if ($passwd != $admin_password):
		return	(-2); /* invalid password */
	endif;

	$result = mssql_query ("SELECT cle FROM $forum WHERE cle>=$from AND cle <= $to", $this->dblink);
	if (!$result) return 0;
	$num = mssql_num_rows($result);
	$i=0;
	while ($i < $num):
		$note = mssql_result ($result, $i, "cle");
		$ret = $this->deleteNote($forum, $note, $passwd, $bn_dir_notes);
		if ($ret < 0):
			return ($ret);
		else:
			$i++;
		endif;
	endwhile;

	mssql_free_result($result);
	return (0);
}

function search ($forum, $pattern, $casesensitive) {
	global $list_var, $session_id;

	if(empty($pattern)) { return 0; }

	$pattern = ereg_replace ("[[:space:]]+", " ", trim($pattern));
	if(!ereg(" ",$pattern)) {
		// Only 1 keyword
		$KeyWords[0] = "$pattern";
		$count=1;
	} else {
		$KeyWords = explode(" ",$pattern);
		$count = count($KeyWords);
	}

	if ($casesensitive) {
		$searcher= "HAVING";
		$expr="REGEXP '.*". $KeyWords[0] . ".*'";
		$query = "SELECT DISTINCT * FROM $forum $searcher body $expr";
	} else {
		$searcher= "WHERE";
		$expr="LIKE '%". $KeyWords[0] . "%'";
		// set selected columns
		$cols = "cle,parent,childs,thread,newest";
		while (list($var,$val) = each($list_var)) {
			if (($val==1) && ($var != "body")) $cols.=",$var";
		}
		$query = "SELECT DISTINCT $cols FROM $forum $searcher body $expr";
	}

	$keyword=1;
	while ($keyword < $count) {
		if ($casesensitive) {
			$query .= " OR body REGEXP '.*". $KeyWords[$keyword] . ".*'";
		} else {
			$query .= " OR body LIKE '%". $KeyWords[$keyword] . "%'";
		}
		$keyword++;
	}

	// Get fields defined in table
	$row_query = "SELECT TOP 1 * FROM ".$forum;
	

	$result = mssql_query($row_query, $this->dblink);
	
	//$results = mssql_fetch_row($row_result);
	
	//for ($field_number = 0 ; $field_number <= $number_fields - 1 ; $field_number++ ) { 
	//	$result[$field_number] = mssql_field_name($query_result, $field_number) ;
	////}


	//$result = mssql_List_fields("$this->dbname", $forum);
//	if (!$result) { /* access problem */
//		echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
//		return (-3);
//	}
	//mssql_field_seek($result, 1);

	while ($db_field = mssql_fetch_field($result)) {
		$colname = $db_field->name;
		$coltype = $db_field->type;
		if (($coltype != "int") && ($colname != "password") && ($colname != "body")) {
			$keyword=0;
			while ($keyword < $count) {
				if ($casesensitive) {
					$expr="REGEXP '.*". $KeyWords[$keyword] . ".*'";
				} else {
					$expr="LIKE '%". $KeyWords[$keyword] . "%'";
				}
				$query .= " OR $colname $expr";
				$keyword++;
			}
		}
	}

	if (!$casesensitive) {
		$query .= " ORDER by thread DESC, cle ASC";
	}
	

	
	$result = mssql_query ($query, $this->dblink);
	//if (!$result) {
		//echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
	//	return (-3);
	//}

	$num = mssql_num_rows($result);
	if ($num < 1 ) {
		return 0;
	}

	reset ($this->entries);
	reset ($this->children);
	while ($row = mssql_fetch_array($result)) {
		$key = $row["cle"];
		$row["parent"]=0;
		$this->entries[$key] = $row;
		$this->children[0][] = $key;
	}

	return $num;
}

}; // end class

?>
