<?php # $Workfile: oci8.php3$	$Revision: 1.1 $	$Date: 2000/11/21 18:20:02 $
##########################WORKFILE OCI8.PHP3#####################
#ORACLE CALL INTERFACE 8 SUPPORT FOR W-AGORA
#AUTHOR:MOO NEE CHOONG <tcmnc@hotmail.com>
#REVISION: 1
#DATE: 8/24/2000
#TESTED WITH OCI8, PHP4 ON APACHE 1.3.12 - LINUX
#################################################################

if (!defined("_DBACCESS")) {
	include ("$inc_dir/dbaccess.$ext");
}

class oci8_access extends DBaccess {

var $dbname;
var $dblink;
var $site;

function OpenDB () {
	global $site, $dbhost, $dbport, $dbuser, $dbpassword, $dbname;

	if (!empty ($dbhost)) {
		$host = $dbhost;
		if (!empty ($dbport)) {
			$host .= ":$dbport";
		}
	}

	$this->dblink = OCIPLogon ($dbuser, $dbpassword, $dbhost);
	if (empty($this->dblink)) {
		return -3;
	}

	if (empty ($dbname)) {
		$dbname ="agora";
	}

	$this->dbname = $dbname;
	if (!empty ($site)) {
		$this->site = $site;
	}

	return 0;
}

##THIS FUNCTION IS TO RETURN AN EXACT ASSOCIATIVE ARRAY BUT WITH##
##LOWER CASE KEY NAMES-THIS IS DUE TO ORACLE'S BEHAVIOUR OF#######
##RETURNING FIELD NAMES IN UPPERCASE ONLY#########################
function SetAssocToLower($inarr){
	for(reset($inarr);$key=key($inarr);next($inarr)){
		$execstr="\$retarr[".strtolower($key)."]='".$inarr[$key]."';";
		eval($execstr);	
	}
	return $retarr;
}

function SHowOCIError($var){
	$ervar=OCIError($var);
	if (is_arrray($ervar))
		echo "<br>OCI Error:".$ervar['code']."-".$ervar['message'];
}

function createForum ($forum, $password) {
	global $bn_var, $db_var;
	global $bn_var_size;

	/* Create Table */
	$desc = "cle INT NOT NULL PRIMARY KEY";
	$desc .= ", parent INT";
	$desc .= ", childs INT";
	$desc .= ", thread INT";
	$desc .= ", newest INT";
	$values = "0, 0, 0, 0, 0";
	$unixdate = time();
	$count = Count ($bn_var);
	$i=0;
	while ($i < $count):
		$col = $bn_var[$i];
		$val = $$col;
		$sz = $bn_var_size[$col];
		if ($sz == "INT") {
			$desc .= ", $col INT";
			$values .= ", " . IntVal($val);
		}
		elseif ($sz == "AUTO" || $sz=="ROWID") {
			$desc .= ", $col ROWID, KEY $col ($col)";
			$values .= ", " . IntVal($val);
		}
		elseif ($sz == "BLOB" || $sz=="VARCHAR2") {
			$desc .= ", $col VARCHAR2(2000)";
			$values .= ", '$val'";
		}
		else {
			$desc .= ", $col VARCHAR2($sz)";
			$values .= ", '$val'";
		}
		$i++;
	endwhile;
	$count = Count ($db_var);
	$i=0;
	while ($i < $count):
		$col = $db_var[$i];
		$val = $$col;
		$sz = $bn_var_size[$col];
		if ($sz == "INT") {
			$desc .= ", $col INT";
			$values .= ", " . IntVal($val);
		}
		elseif ($sz == "AUTO" || $sz=="ROWID") {
			$desc .= ", $col ROWID, KEY $col ($col)";
			$values .= ", " . IntVal($val);
		}
		elseif ($sz == "BLOB" || $sz=="VARCHAR2") {
			$desc .= ", $col VARCHAR2(2000)";
			$values .= ", '$val'";
		}
		else {
			$desc .= ", $col VARCHAR2($sz)";
			$values .= ", '$val'";
		}
		$i++;
	endwhile;
	$stmt=OCIParse($this->dblink,"CREATE TABLE $forum ($desc)");
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}
	OCIFreeStatement($stmt);

	$stmt=OCIParse($this->dblink, "INSERT INTO $forum VALUES($values)");
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}
	OCIFreeStatement($stmt);
	return (0);
}

function deleteForum ($forum, $password) {

	$forum_passwd = $this->getPassword($forum);
	if ($password != $forum_passwd) return (-2); /* invalid password */

	$query = "DROP TABLE $forum";
	$stmt=OCIParse($this->dblink, $query);
	OCIExecute($stmt, OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}
	OCIFreeStatement($stmt);
	return (0);
}

function getPassword ($forum) {
	$query = "SELECT password FROM $forum WHERE cle=0";
        $stmt=OCIParse($this->dblink,$query);
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}

        if(OCIFetch($stmt)){
		 $mypasswd=OCIResult($stmt,"PASSWORD");
		OCIFreeStatement($stmt);
		return $mypasswd;
	}	
	OCIFreeStatement($stmt);
	return "";	
}

function changePassword ($forum, $old_pass, $new_pass) {
	$forum_passwd = $this->getPassword($forum);
	if ($old_pass != $forum_passwd) return (-2); /* invalid password */

	$query = "UPDATE $forum SET password='$new_pass' WHERE cle=0";
	$stmt=OCIParse($this->dblink, $query);
	OCIExecute($stmt, OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt) || OCIRowCount($stmt)<=0){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}
	OCIFreeStatement($stmt);
	return (0);
}

function listThreads ($forum, $first=0, $last=0) {
	global $bn_maxthreads, $list_var;

	$bn_maxthreads = (isSet($bn_maxthreads) ) ? $bn_maxthreads : 0;
	settype ($bn_maxthreads, "integer");
	settype ($first, "integer");
	settype ($last, "integer");

#	1) gets total count # of notes
#	------------------------------
        $stmt=OCIParse($this->dblink,"SELECT COUNT(*) AS TOTAL FROM $forum WHERE CLE<>0");
 	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}

        OCIFetch($stmt);

        $ret["total"]=OCIResult($stmt, "TOTAL");

        OCIFreeStatement($stmt);
	if ($ret["total"] == 0) {
		return ($ret);
	}
#	2) Find the first (and last) thread to be displayed in the page
#	and gets number of notes per thread
#	----------------------------------------------------------------
	if (!$last) {
		$order="DESC";
		$last=1;
	} else {
		$order="ASC";
	}

	$where = "thread>=$last"; // $last default to 1: don't display key 0
	if ($first>0) {
		$where .= " AND thread<=$first";
	}

	#$limit = (empty($bn_maxthreads)) ? "" : "LIMIT $bn_maxthreads";

	$query = "SELECT thread, count(*) FROM $forum WHERE $where GROUP BY thread ORDER BY thread $order";

        $stmt=OCIParse($this->dblink,"SELECT COUNT(*) AS TCOUNT FROM
($query)");         
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS); 	
	if (OCIError($stmt)){ 		
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}

	OCIFetch($stmt);

        $tcount=OCIResult($stmt,'TCOUNT');
	##DO NOT CONSIDER MAXIMUM NUMBER OF RECORDS IF IT IS AN ADMIN SITE##
	if((!eregi("admin",$GLOBALS[bn])) && ($tcount > $bn_maxthreads))
		$tcount=$bn_maxthreads;
	OCIFreeStatement($stmt);

	if($tcount > 0) {
		$stmt=OCIParse($this->dblink,$query);
		OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
		if (OCIError($stmt)){
			$this->ShowOCIError($stmt);
			OCIFreeStatement($stmt);
			return (-3); /* access problem */
		}
	
		OCIFetch($stmt);
		$head=OCIResult($stmt,'THREAD');	
		if($tcount==1)
			$tail=$head;
		else{
			#traverse to the last record to get tail
			for($i=1;$i<$tcount;$i++){
				OCIFetch($stmt);
			}
			$tail=OCIResult($stmt,'THREAD');
		}
		OCIFreeStatement($stmt);

		if ($order=="DESC") {
			$tfirst=$head;
			$tlast=$tail;
		} else {
			$tfirst=$tail;
			$tlast=$head;
		}

		$stmt=OCIParse($this->dblink,$query);
		OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
		if (OCIError($stmt)){
			$this->ShowOCIError($stmt);
			OCIFreeStatement($stmt);
			return (-3); /* access problem */
		}
		
		$rowcount=1;
		while(OCIFetch($stmt) && ($rowcount<$tcount)){
			$t=OCIResult($stmt,'THREAD');
			$replies[$t]=(OCIResult($stmt,2)-1);
			$rowcount++;
	}
		OCIFreeStatement($stmt);
	}

	$ret["threads"]=$tcount; // number of threads displayed
	$ret["first"]=$tfirst;
	$ret["last"]=$tlast;

	if ($tcount < 1) {
		$ret["next"] = 0;
		$ret["prev"] = 0;
		return $ret;
	}
	
#	3) gets all threads
#	-------------------

	$where = "thread<=$tfirst AND thread>=$tlast";

	$cols = "cle,parent,childs,thread,newest";
	while (list($var,$val) = each($list_var)) {
		if ($val==1) $cols.=",$var";
	}

	$query="SELECT $cols FROM $forum WHERE $where ORDER BY thread DESC,cle ASC";
	$stmt=OCIParse($this->dblink, $query);
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}

	reset ($this->entries);
	reset ($this->children);
	$ncount=0;
	while (OCIFetchInto($stmt,$upperrow,OCI_ASSOC)) {
		$row=$this->SetAssocToLower($upperrow);
		$key = (int) $row["cle"];
		$parent = (int) $row["parent"];
		if ($parent==0) {
			$row["replies"] = $replies[$key];
		}
		if (!empty($row["bn_name"])) {
			$table = $row["bn_name"];
			$stmt2=OCIParse($this->dblink,"select count(*) as notes_count, max(unixdate) as last_note from $table");
			OCIExecute($stmt2, OCI_COMMIT_ON_SUCCESS);
			if (OCIError($stmt)){
				$this->ShowOCIError($stmt);
				OCIFreeStatement($stmt);
				return (-3); /* access problem */
			}

			if (OCIFetch($stmt2)) {
				$row["notes_count"]  = OCIResult($stmt2,'NOTES_COUNT');
				$row["last_note"]  = OCIResult($stmt2, "LAST_NOTE");
				OCIFreeStatement($stmt2);
			}
		}
			
if ($this->debug) echo "listThread() key: $key, parent: $parent, replies: " . $replies[$key] . "<br>";
		$this->entries[$key] = $row;
		$this->children[$parent][] = $key;
		$ncount++;
	}

	$ret["notes"]=$ncount;	// number of notes displayed
	OCIFreeStatement($stmt);	

#	4) gets next/previous count
#	---------------------------
	$query="SELECT count(*) AS prev FROM $forum WHERE thread
>$tfirst";
	$stmt=OCIParse($this->dblink,$query);
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}

	OCIFetch($stmt);
	$ret["prev"]  = OCIResult($stmt, "PREV");

	OCIFreeStatement($stmt);

	$query="SELECT count(*) AS next FROM $forum WHERE cle<>
0 AND thread<$tlast";
	$stmt=OCIParse($this->dblink,$query);
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}

	OCIFetch($stmt);
	$ret["next"]  = OCIResult($stmt,"NEXT");

	OCIFreeStatement($stmt);		
	return $ret;
}

function listNotes ($forum, $first=0, $last=0, $sort="", $where="") {
	global $bn_maxthreads, $list_var;

	$bn_maxthreads = (isSet($bn_maxthreads) ) ? $bn_maxthreads : 0;
	settype ($bn_maxthreads, "integer");
	settype ($first, "integer");
	settype ($last, "integer");

#	1) gets total count # of notes
#	------------------------------
	$sql="SELECT count(*) as total FROM $forum WHERE cle<> 0";
	$stmt=OCIParse($this->dblink, $sql);
	OCIExecute($stmt,OCI_DEFUALT);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}

	OCIFetch($stmt);
	$ret["total"] = OCIResult($stmt, 'TOTAL');
	OCIFreeStatement($stmt);
	if ($ret["total"] == 0) {
		return $ret;
	}

#	2) gets all notes sorted by $sort
#	---------------------------------
	$whereClause = "WHERE cle>0"; // skip administrative record
	
	if (!empty($where)) {
		$whereClause .= " AND $where";
		$sql="SELECT count(*) as nquery FROM $forum $whereClause";
		$stmt=OCIParse($this->dblink, $sql);
		OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
		##F
		if (OCIError($stmt)){
			$this->ShowOCIError($stmt);
			OCIFreeStatement($stmt);
			return (-3); /* access problem */
		}
		OCIFetch($stmt);
		$ret["nquery"] = OCIResult($stmt, 'NQUERY');
		OCIFreeStatement($stmt);
	} else {
		$ret["nquery"] = $ret["total"];
	}
	
	$orderClause = (empty ($sort)) ? "" : " ORDER BY $sort";
	$limit="";
	
	if ($bn_maxthreads>0) {
		if ($last > 0) {
			$start = ($last-$bn_maxthreads)+1;
			$start = ($start<0) ? 0 : $start;
		} else {
			$start=$first;
		}
		$limit = "limit $start, $bn_maxthreads";
	} else {
		$start=0;
	}
	
	$cols = "cle,parent,childs,thread,newest";
	while (list($var,$val) = each($list_var)) {
		if ($val==1) $cols.=",$var";
	}

	$query = "SELECT $cols FROM $forum $whereClause $orderClause $limit";
	$stmt=OCIParse($this->dblink, $query);
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}

	reset ($this->entries);
	reset ($this->children);
	$tcount=0;
	while (OCIFetchInto($stmt, &$upperrow, OCI_ASSOC)) {
		$row=$this->SetAssocToLower($upperrow);
		$key = $row["cle"];
		$row["parent"]=0;
		if (!empty($row["bn_name"])) {
			$table = $row["bn_name"];
			$sql2="select count(*) as notes_count, max(unixdate) as last_note from $table";
			$stmt2=OCIParse($this->dblink, $sql2);
			OCIExecute($stmt2,OCI_COMMIT_ON_SUCCESS);
			if (OCIError($stmt2)){
				$this->ShowOCIError($stmt2);
				OCIFreeStatement($stmt2);
				return (-3); /* access problem */
			}
			if (OCIFetch($stmt2)) {
				$row["notes_count"]  = OCIResult($stmt2,'NOTES_COUNT');
				$row["last_note"]  = OCIResult($stmt2,'LAST_NOTE');
				OCIFreeStatement($stmt2);
			}
		}
		$this->entries[$key] = $row;
		$this->children[0][] = $key;
		$tcount++;
	}

	$ret["threads"]=$tcount;	// number of threads displayed
	$ret["notes"]=$tcount;	// number of notes displayed

#	3) gets next/previous (1 if TRUE)
#	---------------------------------
	$ret["first"] = $start;
	$ret["last"] = $start + $tcount - 1;
	$ret["next"] = ($ret["nquery"] > $ret["last"]+1) ? 1 : 0;
	$ret["prev"] = ($ret["first"] > 1) ? 1 : 0;
	
	return $ret;
}

function getNote ($forum, $key) {

	$query="SELECT * FROM $forum WHERE cle=$key";
	$stmt=OCIParse($this->dblink,$query);
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}
	
	$cnt_query="SELECT COUNT(*) AS NUMROWS FROM ($query)";
	$cntstmt=OCIParse($this->dblink,$cnt_query);
	OCIExecute($cntstmt,OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}

	OCIFetch($cntstmt);

	$num = OCIResult($cntstmt, 'NUMROWS');
	OCIFreeStatement($cntstmt);
	if ($num < 1) return (-4);

	OCIFetchInto($stmt, $note, OCI_ASSOC);
	OCIFreeStatement($stmt);
	$whereclause = "thread > " . $note["THREAD"];

	$query="SELECT min(thread) FROM $forum WHERE $whereclause";	
	$stmt=OCIParse($this->dblink, $query);
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	if (!OCIError($stmt)) {
		OCIFetchInto($stmt, $prev, OCI_NUM);
		$note["TPREV"]= $prev[1];
	}
	
	$whereclause = "thread < " . $note["THREAD"];
	$query="SELECT max(thread) FROM $forum WHERE $whereclause";
	$stmt2=OCIParse($this->dblink,$query);
	OCIExecute($stmt2,OCI_EXECUTE_ON_COMMIT);
	if (!OCIError($stmt)) {
		OCIFetchInto($stmt2,$next,OCI_NUM);
		$note["TNEXT"]= $next[1];
	}
	$retarr=$this->SetAssocToLower($note);
	return ($retarr);
}

function getThreadNewest ($forum, $thread) {
 	$where="thread=$thread AND cle<>0";
	$query="SELECT MAX(unixdate) AS MAXDATE FROM $forum WHERE $where";
	$stmt=OCIParse($this->dblink, $query);
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}
	OCIFetch($stmt);
	$newest = OCIResult($stmt, 'MAXDATE');
	
	OCIFreeStatement($stmt);
	return $newest;
}


function getThread ($forum, $key, $thread) {

	reset ($this->entries);
	reset ($this->children);
	
	$where="thread=$thread AND cle<>0";

	$query="SELECT * FROM $forum WHERE $where ORDER BY cle";
	$stmt=OCIParse($this->dblink,$query);
	OCIExecute($stmt,OCI_COMMIT_ON_EXECUTE);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}

	while (OCIFetchInto($stmt,&$upperrow,OCI_ASSOC)) {
		$row=$this->SetAssocToLower($upperrow);		
		$key = $row["cle"];
		$parent = $row["parent"];
		$this->entries[$key] = $row;
		$this->children[$parent][] = $key;
	}

	OCIFreeStatement($stmt);
	return 0;
}

function insertNote ($forum, $key, $fields) {
	$ret = $this->insert ($forum, $key, 0, $key, $fields);
	return $ret;
}

function threadNote ($forum, $key, $parent_key, $fields) {
	$query="SELECT * FROM $forum WHERE cle=$parent_key";
	$stmt=OCIParse($this->dblink,$query);
	OCIExecute($stmt);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}

	$querycnt="SELECT COUNT(*) AS NUMROWS FROM ($query)";
	$cntstmt=OCIParse($this->dblink,$querycnt);
	OCIExecute($cntstmt,OCI_COMMIT_ON_SUCCESS);
	OCIFetch($cntstmt);
	$num = OCIResult($cntstmt, 'NUMROWS');
	OCIFreeStatement($cntstmt);
	if ($num  < 1)
		return -4;
	OCIFetch($stmt);
	$thread = OCIResult($stmt, "THREAD");
	$childs = OCIResult($stmt, "CHILDS");
	$childs++;
	$values = "childs=$childs, thread=$thread";
	OCIFreeStatement($stmt);

	$query="UPDATE $forum SET $values WHERE cle=$parent_key";
	$stmt=OCIParse($this->dblink, $query);
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}
	OCIFreeStatement($stmt);

	$newest = $fields["unixdate"];

	$query="UPDATE $forum SET newest=$newest WHERE thread=$thread";
	$stmt=OCIParse($this->dblink, $query);
	OCIExecute($stmt);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}
	OCIFreeStatement($stmt);

	$ret = $this->insert ($forum, $key, $parent_key, $thread, $fields);
	return $ret;
}

function insert ($forum, $key, $parent, $thread, &$note) {
	// Get fields defined in table
 	$sql="SELECT * FROM $forum";
        $stmt=OCIParse($this->dblink,$sql);
      	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
        if (OCIError($stmt)) { /* retrieve problem */
               	$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-6);
        } 
	
	$note["parent"] = $parent;
	$note["childs"]=0;
	$note["thread"] = $thread;
	$note["newest"] = $note["unixdate"];
	$cols = "cle";
	$values = "$key";

	// gets fields name and type
	$ncols=OCINumCols($stmt);
   	for($colcnt=2;$colcnt<=$ncols;$colcnt++){  // skip field "key"
		$colname=strtolower(OCIColumnName($stmt,$colcnt));
		$coltype=OCIColumnType($stmt,$colcnt);
		$val = addSlashes($note[$colname]);
		if (!empty($val)) {
			$cols .= ", $colname";
			if (eregi("number",$coltype))
				$values .= ", " . IntVal($val);
			else
				$values .= ", '$val'";
		}
if ($this->debug) echo "insert() name : $colname, value: $val, type: $coltype <br>";
	}
     	OCIFreeStatement($stmt);

 	if ($this->debug) echo "INSERT INTO $forum ($cols) VALUES($values)";
        $stmt=OCIParse($this->dblink, "INSERT INTO $forum ($cols) VALUES($values)");
	OCIExecute($stmt);
        if (OCIRowCount($stmt)<=0 || OCIError($stmt)) { /* insert problem */
               	$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
               	return (-3);
        } 
        OCIFreeStatement($stmt);
	return ($key);
}

function updateNote ($forum, $key, $passwd, &$fields) {

	$query="SELECT * FROM $forum WHERE cle=$key";
	$stmt=OCIParse($this->dblink, $query);
	OCIExecute($stmt);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt); /* access error */
		OCIFreeStatement($stmt);
               	return (-3);
        } 
	
	$cntquery="SELECT COUNT(*) AS NUMROWS FROM ($query)";
	$cntstmt=OCIParse($this->dblink,$cntquery);
	OCIExecute($cntstmt);
	OCIFetch($cntstmt);
	$num = OCIResult($cntstmt, 'NUMROWS');
	OCIFreeStatement($cntstmt);
	if ($num < 1) return (-4); /* no row selected */

	$admin_password = $this->GetPassword($forum);
	OCIFetch($stmt);
	$password = OCIResult($stmt, 'PASSWORD');
	if (($passwd != $password) && ($passwd != $admin_password)):
		return (-2); /* invalid password */
	endif;

	$fields["parent"] = OCIResult($stmt,'PARENT');
	$fields["childs"] = OCIResult($stmt,'CHILDS');
	$fields["thread"] = OCIResult($stmt,'THREAD');
	$fields["newest"] = OCIResult($stmt,'NEWEST');

	$values = "cle=$key";

	$ncols=OCINumCols($stmt);
	for($colscnt=1;$colscnt<=$ncols;$colscnt++)
	{
		$colname=OCIColumnName($stmt,$colscnt);
		$coltype=OCIColumnType($stmt,$colscnt);
		$val= addSlashes($fields[strtolower($colname)]);
		if (!empty($val)) {
                        if (eregi("NUMBER", $coltype))
                                $values .= ", $colname= " . intVal($val);
                        else
                                $values .= ", $colname= '$val'";
                } 
if ($this->debug) echo "update() - name : $colname, value: $val, type: $coltype <br>";
	}
	OCIFreeStatement($stmt);

	$query="UPDATE $forum SET $values WHERE cle=$key";
	$stmt=OCIParse($this->dblink,$query);
	OCIExecute($stmt);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt);
		OCIFreeStatement($stmt);
		return (-3); /* access problem */
	}

	OCIFreeStatement($stmt);
	return (0);
}

function updateThread($forum, $parent, $newthread) {

	$udpqry="UPDATE $forum SET thread=$newthread WHERE parent=$parent";
	$stmt=OCIParse($this->dblink,$udpqry);
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt); /* access error */
		OCIFreeStatement($stmt);
               	return (-3);
        } 
	OCIFreeStatement($stmt);

	$query="SELECT cle, childs FROM $forum WHERE parent=$parent";
	$stmt=OCIParse($this->dblink, $query);
	OCIExecute($stmt);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt); /* access error */
		OCIFreeStatement($stmt);
               	return (-3);
        } 

	
	while (OCIFetchInto($stmt,&$row,OCI_NUM)) {
		$key=$row[1];
		$childs=$row[2];
		if ($childs > 0) {
			$this->updateThread ($forum, $key, $newthread);
		}
	}
	OCIFreeStatement($stmt);
}

function deleteNote ($forum, $key, $passwd, $bn_dir_notes) {

	$query="SELECT * FROM $forum WHERE cle=$key";
	$stmt=OCIParse($this->dblink, $query);
	OCIExecute($stmt);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt); /* access error */
		OCIFreeStatement($stmt);
               	return (-3);
        } 
 	
	$cntquery="SELECT COUNT(*) AS NUMROWS FROM ($query)";
	$cntstmt=OCIParse($this->dblink,$cntquery);
	OCIExecute($cntstmt,OCI_COMMIT_ON_SUCCESS);
	OCIFetch($cntstmt);
	$num = OCIResult($cntstmt, 'NUMROWS');
	if ($num < 1):
		return (-4); /* no row selected */
	endif;

	$admin_password = $this->GetPassword($forum);
	OCIFetch($stmt);
	$password = OCIResult($stmt, 'PASSWORD');
	if (($passwd != $password) && ($passwd != $admin_password)):
		return (-2); /* invalid password */
	endif;

 	$filename = OCIResult($stmt, 'FILENAME'); 
 	$attachment = OCIResult($stmt, 'ATTACHMENT');
 	$parent = OCIResult($stmt, 'PARENT');
 	$childs = OCIResult($stmt, 'CHILDS');
 	$thread = OCIResult($stmt, 'THREAD');
	OCIFreeStatement($stmt);

	// delete note
	$query="DELETE FROM $forum WHERE cle=$key";
	$stmt=OCIParse($this->dblink,$query);

	OCIExecute($stmt, OCI_COMMIT_ON_SUCCESS);	
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt); /* access error */
		OCIFreeStatement($stmt);
               	return (-3);
        } 
	OCIFreeStatement($stmt);

	if ($parent > 0) {
		// decrement childs count in parent
		$query="UPDATE $forum SET childs=childs-1 WHERE cle=$parent";
		$stmt=OCIParse($this->dblink, $query);
		OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
		if (OCIError($stmt)){
			$this->ShowOCIError($stmt); /* access error */
			OCIFreeStatement($stmt);
    	           	return (-3);
        	} 
		OCIFreeStatement($stmt);
	}
	else {
		// update thread value
		$query="SELECT cle, childs FROM $forum WHERE parent=$key";
		$stmt=OCIParse($this->dblink, $query);
		OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
		if (OCIError($stmt)){
			$this->ShowOCIError($stmt); /* access error */
			OCIFreeStatement($stmt);
    	           	return (-3);
        	}
		while (OCIFetchInto($stmt,$row,OCI_NUM)) {
			$childkey=$row[1];
			$updatequery="UPDATE $forum SET thread=$childkey WHERE cle=$childkey";
		 	$udpstmt=OCIParse($this->dblink,$updatequery);
			OCIExecute($udpstmt,OCI_COMMIT_ON_SUCCESS);
			if (OCIError($udpstmt)){
				$this->ShowOCIError($udpstmt); /* access error
*/ 				OCIFreeStatement($udpstmt);
    	    	       		return (-3);
        		}
			OCIFreeStatement($udpstmt);
			if ($row[2] > 0) {
				$this->updateThread ($forum, $childkey, $childkey);
			}
		}
		OCIFreeStatement($stmt);
	}
	
	// Link children to parent
	if ($childs > 0) {
		$updatequery="UPDATE $forum SET parent=$parent WHERE parent=$key";
		$stmt=OCIParse($this->dblink, $updatequery);
		OCIExecute($stmt, OCI_COMMIT_ON_SUCCESS);
		if (OCIError($stmt)){
			$this->ShowOCIError($stmt); /* access error */
			OCIFreeStatement($stmt);
    	           	return (-3);
        	}
		OCIFreeStatement($stmt);
	}

	// update newest in thread
	if ($key != $thread) {
		$newest = $this->getThreadNewest ($forum, $thread);
		$updatequery="UPDATE $forum SET newest=$newest WHERE thread=$thread";
		$stmt=OCIParse($this->dblink, $updatequery);
		OCIExecute($stmt);
		if (OCIError($stmt)){
			$this->ShowOCIError($stmt); /* access error */
			OCIFreeStatement($stmt);
    	           	return (-3);
        	}
		OCIFreeStatement($stmt);
	}
	
	if (!empty($filename) && ($filename != "none") && is_file("$bn_dir_notes/$filename")) {
 		@unlink ("$bn_dir_notes/$filename");
	}

	if (!empty($attachment) && ($attachment != "none") && is_file ("$bn_dir_notes/$key/$attachment") ) {
		@unlink ("$bn_dir_notes/$key/$attachment");
		@rmdir ("$bn_dir_notes/$key");
	}
	return (0);
}

function mDeleteDate ($forum, $from, $to, $passwd, $bn_dir_notes) {

	$admin_password	= $this->getPassword($forum);
	if ($passwd != $admin_password):
		return	(-2); /* invalid password */
	endif;

	$query="SELECT cle FROM $forum WHERE cle>=$from AND cle <= $to";
	$stmt=OCIParse($this->dblink, $query);
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	if (OCIError($stmt)) return 0;
	
	$cntstmt=OCIParse($this->dblink, "SELECT COUNT(*) FROM ($query)");
	OCIExecute($cntstmt,OCI_COMMIT_ON_EXECUTE);
	if (OCIError($stmt)) return 0;
	OCIFetch($cntstmt);
	$num = OCIResult($cntstmt,1);
	OCIFreeStatement($cntstmt);
	$i=0;
	while ($i < $num):
		OCIFetch($stmt);
		$note = OCIResult($stmt,"CLE");
		$ret = $this->deleteNote($forum, $note, $passwd, $bn_dir_notes);
		if ($ret < 0):
			return ($ret);
		else:
			$i++;
		endif;
	endwhile;

	OCIFreeStatement($stmt);
	return (0);
}

function search ($forum, $pattern, $casesensitive) {
	global $list_var;

	if ($casesensitive) {
		$searcher= "WHERE";
		$expr="LIKE '%$pattern%'";
		// set selected columns
		$cols = "cle,parent,childs,thread,newest";
		while (list($var,$val) = each($list_var)) {
			if ($val==1) $cols.=",$var";
		}
		$query = "SELECT DISTINCT $cols FROM $forum $searcher body $expr";
	}
	else {
		$searcher= "WHERE";
                $expr="LIKE '%".strtoupper($pattern)."%'";
                // set selected columns
                $cols = "cle,parent,childs,thread,newest";
                while (list($var,$val) = each($list_var)) {
                        if ($val==1) $cols.=",$var";
                }  
		$query = "SELECT DISTINCT $cols FROM $forum $searcher UPPER(body) $expr ";            
	}
	$stmt=OCIParse($this->dblink,$query);
	OCIExecute($stmt,OCI_COMMIT_ON_SUCCESS);
	
	// Get fields defined in table
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt); /* access error */
		OCIFreeStatement($stmt);
               	return (-3);
        } 
	$ncols=OCINumCols($stmt);
	for($i=1;$i<=$ncols;$i++){
		$colname = strtolower(OCIColumnName($stmt,$i));
                $coltype = OCIColumnType($stmt,$i);
		if ((!eregi("number",$coltype)) && (!eregi("password",$colname)) && (!eregi("body",$colname))) {
                        $query .= " OR $colname $expr";
                } 
	}
	OCIFreeStatement($stmt);

	if (!$casesensitive) {
		$query .= " ORDER by thread DESC, cle ASC";
	}

	$stmt = OCIParse($this->dblink, $query);
	OCIExecute($stmt);
	if (OCIError($stmt)){
		$this->ShowOCIError($stmt); /* access error */
		OCIFreeStatement($stmt);
               	return (-3);
        } 

	$cntquery="SELECT COUNT(*) FROM ($query)";
	$cntstmt=OCIParse($this->dblink, $cntquery);
	OCIExecute($cntstmt);
	OCIFetch($cntstmt);
	$num = OCIResult($cntstmt, 1);
	OCIFreeStatement($cntstmt);
	if ($num < 1 ) {
		return 0;
	}

	reset ($this->entries);
	reset ($this->children);
	while (OCIFetchInto($stmt, &$upperrow, OCI_ASSOC)) {
		$row=$this->SetAssocToLower($upperrow);
		$key = $row["cle"];
		$row["parent"]=0;
		$this->entries[$key] = $row;
		$this->children[0][] = $key;
	}

	return $num;
}

}; // end class

?>
