<?

/*
 *   W-AGORA
 *   -------
 *   File:	odbc.php3
 *   Usage:	include file - Database access functions (ODBC)
 *   date:	March 1999
 *   version:	3.0.0b4
 *   Author:	Marc Druilhe <mdruilhe@araxe.fr>
 */

if (!$dbaccess) include ("$inc_dir/dbaccess.php3");

function odbc_fetch_array ($result, $row) {
	$n = odbc_fetch_into ($result, $row, &$array);

	for ($i=0; $i<$n; $i++) {
		$f = odbc_field_name ($result, $i+1);
		$arr[$f] = $array[$i];
echo "$f = ". $array[$i]. "<br>";
	}
	return $arr;
}

class odbc_access extends DBaccess {

function OpenDB () {
	$this->dblink = @odbc_connect ("$this->dbname", $this->dbUser, $this->dbPassword);
	return $this->dblink;
}

function createForum ($forum, $password) {
	global $bn_var, $db_var;
	global $bn_var_size;

	/* Create Table */
	$desc = "cle INT NOT NULL";
	$desc .= ", parent INT";
	$desc .= ", childs INT";
	$desc .= ", thread INT";
	$desc .= ", newest INT";
	$values = "0, 0, 0, 0, 0";
	$unixdate = time();
	$count = Count ($bn_var);
	$i=0;
	while ($i < $count):
		$col = $bn_var[$i];
		$val = $$col;
		$sz = $bn_var_size[$col];
		if ($sz == "INT") {
			$desc .= ", $col INT";
			$values .= ", " . IntVal($val);
		}
		elseif ($sz == "BLOB") {
			$desc .= ", $col TEXT";
			$values .= ", '$val'";
		}
		else {
			$desc .= ", $col CHAR($sz)";
			$values .= ", '$val'";
		}
		$i++;
	endwhile;
	$count = Count ($db_var);
	$i=0;
	while ($i < $count):
		$col = $db_var[$i];
		$val = $$col;
		$sz = $bn_var_size[$col];
		if ($sz == "INT") {
			$desc .= ", $col INT";
			$values .= ", " . IntVal($val);
		}
		elseif ($sz == "BLOB") {
			$desc .= ", $col TEXT";
			$values .= ", '$val'";
		}
		else {
			$desc .= ", $col CHAR($sz)";
			$values .= ", '$val'";
		}
		$i++;
	endwhile;
	$result = odbc_exec ($this->dblink, "CREATE TABLE $forum ($desc)");
	if (!$result) {  /* access PB  */
		return (-3);
	}

	$result = odbc_exec($this->dblink, "INSERT INTO $forum VALUES($values)");
	if (!$result) {  /* access PB  */
		return (-3);
	}
	return (0);
}

function deleteForum ($forum, $password) {

	$forum_passwd = $this->getPassword();
	if ($password != $forum_passwd) return (-2); /* invalid password */

	$query = "DROP TABLE $forum";
	$result = odbc_exec ($this->dblink, $query);
	if (!$result) return (-3); /* access problem */
	return (0);
}

function getPassword () {
	global $bn_db;

	$query = "SELECT password FROM $bn_db WHERE cle=0";
	$result = odbc_exec ($this->dblink, $query);
	if (!odbc_fetch_row ($result))
		return "";
	return odbc_result ($result, 1);
}

function changePassword ($old_pass, $new_pass) {
	global $bn_db;

	$forum_passwd = $this->getPassword();
	if ($old_pass != $forum_passwd) return (-2); /* invalid password */

	$query = "UPDATE $bn_db SET password='$new_pass' WHERE cle=0";
	$result = odbc_exec ($this->dblink, $query);
	if (!$result) return (-3); /* access problem */

	return (0);
}

function listNotes ($action, $first=0, $last=0) {
	global $bn_view_header, $bn_view_footer;
	global $bn_delete_header, $bn_delete_footer;
	global $bn_db, $bn_maxthreads, $list_var;

	if (!$bn_maxthreads) $bn_maxthreads = 0;

	// 1) gets total count # of notes
	$result = odbc_exec ($this->dblink, "SELECT count(*) FROM $bn_db WHERE cle<>0");
	if (!$result) {
		return (-3);
	}
	$row = odbc_fetch_row($result);
	$ret[total] = odbc_result($result, 1);
	if ($ret[total] == 0) return ($ret);

	// 2) Find the first thread to be displayed in the page starting from
	// the end (last_thread - bn_max_threads)
	if (($bn_maxthreads>0) && $last && !$first) {
		$query = "SELECT thread FROM $bn_db WHERE thread >=$last ORDER BY thread";
		$result = odbc_exec ($this->dblink, $query);
		if ($result) {
			$i=0;
			while ($row = odbc_fetch_row($result)) {
				$thread = odbc_result ($result, 1);
				if ($first != $thread) {
					$first = $thread;
					$i++;
				}
				if (($bn_maxthreads > 0) && ($i >= $bn_maxthreads))
					break;
			}
		}
	}

	// 3) gets all threads
	$where="cle<>0";
	if ($first) $where .= " AND thread<=$first";
	if ($last) $where .= " AND thread>=$last";

	$cols = "cle,parent,childs,thread,newest";
	while (list($var,$val) = each($list_var)) {
		if ($val==1) $cols.=",$var";
	}
	$result = odbc_exec ($this->dblink, "SELECT $cols FROM $bn_db WHERE $where ORDER BY thread DESC, cle ASC");
	if (!$result) {
		return (-3); 
	}

	$tlast=time(); $tfirst=0; $tcount = 0;

	$i=0;
	while ($row = odbc_fetch_array($result, $i)) {
		$i++;
		$key = $row["cle"];
		$parent = $row["parent"];
		if (!$parent) { // new thread
			if (($tcount < $bn_maxthreads) || ($bn_maxthreads==0)) {
				$this->entries[$key] = $row;
				$this->children[$parent][] = $key;
				if ($key < $tlast) $tlast = $key;
				if ($key > $tfirst) $tfirst = $key;
				$tcount++;
			}
			else
				$next=1;
		}
		else {
			$this->entries[$key] = $row;
			$this->children[$parent][] = $key;
		}
	}

	if (!isSet ($prev)) {
		$result = odbc_exec ($this->dblink, "SELECT cle FROM $bn_db WHERE thread>$tfirst AND cle<>0");
		if (!$result) {
			return (-3); 
		}
		$row = odbc_fetch_row($result);
		$prev = odbc_result($result, 1);
	}

	if (!isSet ($next)) {
		$result = odbc_exec ($this->dblink, "SELECT cle FROM $bn_db WHERE thread<$tlast AND cle<>0");
		if (!$result) {
			return (-3); 
		}
		$row = odbc_fetch_row($result);
		$next = odbc_result($result, 1);
	}
	
	odbc_Free_Result($result);

	$header="bn_${action}_header";
	$l=addSlashes(stripSlashes($$header));
	eval ("echo stripSlashes(\"$l\");");

	$this->getChild (0, $action);

	$footer="bn_${action}_footer";
	$l=addSlashes(stripSlashes($$footer));
	eval ("echo stripSlashes(\"$l\");");

	$ret["threads"]=$tcount;
	$ret["next"]=$next;
	$ret["prev"]=$prev;
	$ret["first"]=$tfirst;
	$ret["last"]=$tlast;
	return ($ret);
}

function getNote ($key) {
	global $bn_db;

	$result = odbc_exec ($this->dblink, "SELECT * FROM $bn_db WHERE cle=$key");
	if (!$result) {
		return (-3); 
	}
	return odbc_fetch_array($result, 1);
}


function getThread ($key, $thread) {
	global $bn_db, $bn_view_header, $bn_view_footer;

	$where="thread=$thread AND cle<>0";

	$result = odbc_exec ($this->dblink, "SELECT * FROM $bn_db WHERE $where");
	if (!$result) {
		return (-3); 
	}

	while ($row = odbc_fetch_array($result)) {
		$key = $row["cle"];
		$parent = $row["parent"];
		$this->entries[$key] = $row;
		$this->children[$parent][] = $key;
	}

	odbc_FreeResult($result);

	// display header
	$l=addSlashes(stripSlashes($bn_view_header));
	eval ("echo stripSlashes(\"$l\");");

	$ret = $this->getChild (0, "view");

	// display footer
	$l=addSlashes(stripSlashes($bn_view_footer));
	eval ("echo stripSlashes(\"$l\");");

}

function insert ($key, $parent, $thread, $note) {
	global $bn_db;

	$result = odbc_exec ($this->dblink, "SELECT * FROM $bn_db WHERE cle=0");
	if (!$result) return -3;
	$n = odbc_num_fields($result);
	if ($n < 4) return -3;

	$cols = "cle, parent, childs, thread";
	$values = "$key, $parent, 0, $thread";

	// gets fields name and type
	for ($i=5; $i <= $n; $i++) {
		$colname = odbc_field_name ($result, $i);
		$coltype = odbc_field_type ($result, $i);
		$val = addSlashes($note[$colname]);
		if (!empty ($val)) {
			$cols .= ", " . $colname;
			if ($coltype == "int")
				$values .= ", " . IntVal($val);
			else
				$values .= ", '$val'";
		}
if ($this->debug) echo "insert() - name : $colname, value: $val, type: $coltype <br>";
	}

if ($this->debug) echo "INSERT INTO $bn_db ($cols) VALUES($values)";
	$result = odbc_exec($this->dblink, "INSERT INTO $bn_db ($cols) VALUES($values)");
	if (!$result) { /* insert problem */
		return (-3); 
	}

	return ($key);
}

function insertNote ($key, $fields) {
	global $bn_db;

	$ret = $this->insert ($key, 0, $key, $fields);
	return $ret;
}

function threadNote ($key, $parent_key, $fields) {
	global $bn_db;
	
	$result = odbc_exec ($this->dblink, "SELECT thread, childs FROM $bn_db WHERE cle=$parent_key");
	if (!$result) return (-3); 
	$row = odbc_fetch_row($result);
	if (!$row) return (-3);
	$thread = odbc_result($result, 1);
	$childs = odbc_result($result, 1);
	$childs++;

	$values = "childs=$childs, thread=$thread";
	$result = odbc_exec ($this->dblink, "UPDATE $bn_db SET $values WHERE cle=$parent_key");
	if (!$result) return (-3);
	$ret = $this->insert ($key, $parent_key, $thread, $fields);
	return $ret;
}

function updateNote ($cle, $pass, $fields) {
	global $bn_db;
	global $bn_var, $db_var;

	$result = odbc_exec ($this->dblink, "SELECT * FROM $bn_db WHERE cle=$cle");
	if ($result < 0) return (-3);  /* access error */
	
	$num = odbc_numrows($result);
	if ($num < 1) return (-4); /* no row selected */

	$admin_password = $this->GetPassword();

	$row = odbc_fetch_array($result, 1);
	$password = $row["password"];
	if (($pass != $password) && ($pass != $admin_password)):
		return (-2); /* invalid password */
	endif;
	
	$parent = $row["parent"];
	$childs = $row["childs"];
	$thread = $row["thread"];

	$values = "cle=$cle, parent=$parent, childs=$childs, thread=$thread";

	// gets fields name and type
	for ($i=5; $i <= $n; $i++) {
		$colname = odbc_field_name($result, $i);
		$coltype = odbc_field_type($result, $i);
		$val = addSlashes($fields[$colname]);
		if (!empty($val)) {
			if ($coltype == "int")
				$values .= ", $colname= " . intVal($val);
			else
				$values .= ", $colname= '$val'";
		}
if ($this->debug) echo "update() - name : $colname, value: $val, type: $coltype <br>";
	}

	$result = odbc_exec ($this->dblink, "UPDATE $bn_db SET $values WHERE cle =$cle");
	if (!$result) {
		return (-3); 
	}

	return (0);
}

function deleteNote ($key, $pass) {
	global $bn, $bn_db;
	global $bn_dir_notes;

	$result = odbc_exec ($this->dblink, "SELECT * FROM $bn_db WHERE cle=$key");
	if (!$result) {
		echo "odbc error: ".odbc_error()."<BR>";
		return (-3); 
	}
	
	$num = odbc_numrows($result);
	if ($num < 1):
		return (-4); /* no row selected */
	endif;

	$admin_password = $this->GetPassword();
	$password = odbc_result ($result, 0, "password");
	if (($pass != $password) && ($pass != $admin_password)):
		return (-2); /* invalid password */
	endif;

 	$filename = odbc_result ($result, 0, "filename");
 	$attachment = odbc_result ($result, 0, "attachment");
 	$parent = odbc_result ($result, 0, "parent");
 	$childs = odbc_result ($result, 0, "childs");

	if ($childs > 0) {
		$result = odbc_exec ($this->dblink, "UPDATE $bn_db SET parent=$parent WHERE parent=$key");
		if (!$result) {
			echo "odbc error: ".odbc_error()."<BR>";
			return (-3); 
		}
	}

	if ($parent > 0) {
		$childs-=1;
		$result = odbc_exec ($this->dblink, "UPDATE $bn_db SET childs=$childs WHERE cle=$parent");
		if (!$result) {
			echo "odbc error: ".odbc_error()."<BR>";
			return (-3); 
		}
	}

	$result = odbc_exec ($this->dblink, "DELETE FROM $bn_db WHERE cle=$key");
	if (!$result) {
		echo "odbc error: ".odbc_error()."<BR>";
		return (-3); 
	}

	if (($filename != "none") && is_file("$bn_dir_notes/$filename")) {
		@unlink ("$bn_dir_notes/$filename");
	}

	if ($attachment && ($attachment != "none") && is_file ("$bn_dir_notes/$key/$attachment") ) {
		unlink ("$bn_dir_notes/$key/$attachment");
		rmdir ("$bn_dir_notes/$key");
	}
	return (0);
}

function mDeleteDate ($forum, $from, $to, $passwd, $bn_dir_notes) {

	$admin_password	= $this->getPassword();
	if ($passwd != $admin_password):
		return	(-2); /* invalid password */
	endif;

	$result = odbc_exec ($this->dblink, "SELECT cle FROM $forum WHERE cle>=$from AND cle <= $to");
	$num = odbc_numrows($result);
	$i=0;
	while ($i < $num):
		$note = odbc_result ($result, $i, "cle");
		$ret = $this->deleteNote($note, $passwd);
		if ($ret < 0):
			return ($ret);
		else:
			$i++;
		endif;
	endwhile;

	odbc_FreeResult($result);
	return (0);
}

function search ($pattern) {
	global $bn, $bn_db;
	global $bn_dir_notes;
	global $bn_date_format, $msg;

	// Get fields defined in table
	$result = odbc_List_fields("$this->dbname", $bn_db);
	if (!$result) { /* access problem */
		echo "odbc error: ".odbc_error()."<BR>";
		return (-3); 
	}

	// $pattern = ereg_replace ("\*", "%", $pattern);
	$pattern = "%$pattern%";
	$where .= "body LIKE '$pattern'";
	// gets fields name and type
	while ($db_field = odbc_fetch_field($result)) {
		$colname = $db_field->name;
		$coltype = $db_field->type;
		if (($coltype != "int") && ($colname != "body"))
			$where .= " OR $colname LIKE '$pattern'";
	}
	$result = odbc_exec ($this->dblink, "SELECT * FROM $bn_db WHERE $where");
	if (!$result) {
		echo "odbc error: ".odbc_error()."<BR>";
		return (-3); 
	}

	$num = odbc_numrows($result);
	if ($num == 0) {
	    echo "<p><center><h2>"; DspMsg(30);echo "</center></h2>";
		return (0);
	}

	echo "<p><h2>$num" . Msg(29) . "</h2><p>";
	echo "<center><table border=2 width=80%><tr><th width=20%>date</th><th>$msg[31]</th></tr>";

	while ($num > 0) {
		$num--;
		$row = odbc_fetch_array($result);
		$formated_date = date ($bn_date_format, $row[unixdate]);
		$url="view.php3?bn=$bn&key=$row[cle]";
		echo "<tr><td>$formated_date</td><td><a href=\"$url\"> $row[subject] </a></td></tr>";
	}
	echo "</table></center><HR>";
	return (0);

}

}; // end class

	$db = new odbc_access;
	$ret = $db->openDB();
	if ($ret < 0) {
		echo "<CENTER><strong>"; DspMsg (6); echo "</STRONG></CENTER>";
		exit;
	}
?>
