<? # $Workfile: oracle7.php3$	$Revision: 1.1 $	$Date: 2000/11/21 18:20:02 $

/*
 *   W-AGORA
 *   -------
 *   File:		oracle.php3
 *   Usage:		include file - Database access functions (ORACLE 7)
 *   date:		May 2000
 *   version:	4.0.0
 *   Author:	Marc Druilhe <mdruilhe@w-agora.com>
 */

if (!defined("_DBACCESS")) {
	include ("$inc_dir/dbaccess.$ext");
}

putenv ("ORACLE_HOME=/oracle/app/oracle/product/7.3.2");

class oracle_access extends DBaccess {

/* public: result array and current row number */
var $Record   = array();
var $Row;

/* public: current error number and error text */
var $Errno    = 0;
var $Error    = "";

/* private: link and query handles */
var $site;
var $dbname;
var $dblink;
var $Query_ID;

var $Auto_Free     = 0;     ## Set to 1 for automatic mysql_free_result()

function query ($query ) {

	if ($this->debug) {
		echo "Query: <tt>$query</tt><br>";
	}

	$cursor=Ora_Open($this->dblink);
	if (!$cursor) {
		return -3;
	}
	if (!Ora_Parse ($cursor, $query) ) {
		return -3;
	}
	
	if (!Ora_Exec($cursor) ) {
		return -3;
	}
	return $cursor;
}

function fetch_array ($cursor) {

	if (!Ora_Fetch($cursor)) {
		return FALSE;
	}

	$i=0;
       	while ($col = @Ora_ColumnName ($cursor,$i) ) {
               	$colname = strtolower($col);
		$row[$colname] = chop(Ora_GetColumn ($cursor, $i));
		$i++;
	}

	if (is_array ($row)) {
		return $row;
	} else {
		return FALSE;
	}
}

function error ($err, $text="") {
	if (!empty($text)) {
		echo $text;
	}
	echo "ORACLE error: ".Ora_ErrorCode($this-dblink).": ".Ora_Error($this-dblink)."<BR>";
	Ora_Logoff($this->dblink);
	return $err;
}

function openDB ($dbhost="", $dbport="", $dbuser="", $dbpassword="", $dbname="agora", $site="") {

	if (!empty ($dbhost)) {
		$dbuser = $dbuser . "@" . $dbhost;
	}

	putenv ("ORACLE_SID=$dbname");
	putenv ("ORACLE_HOME=/oracle/app/oracle/product/7.3.2");
	putenv ("NLS_LANG=french_france.WE8ISO8859P1");

	$this->dblink = Ora_Logon ($dbuser, $dbpassword);
	if (!$this->dblink)
		return -3;

	$this->dbname = $dbname;

	if (!empty ($site)) {
		$this->site = $site;
	}

	Ora_CommitOff ($this->dblink);
	return 0;
}

function createTable ($table, $field_defs) {

# Check if table exists
# ---------------------
	$cursor=Ora_Open($this->dblink);
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}
	$table=strtoupper($table);

	if (!Ora_Parse ($cursor,"select table_name from user_tables where table_name like '$table'") ) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	$ret = Ora_Exec($cursor);
	if (Ora_Fetch($cursor)) {
		Ora_Logoff($this->dblink);
		return -1; /*  table already exists */
	}

# Create Table
# ------------
	if (!is_array ($field_defs)) {
		return -4;
	}

	while (list($col, $size) = each($field_defs)) {
		switch ($size) {
			case "INT":
				$desc .= ", $col INTEGER";
				break;
			case "AUTO":
				$desc .= ", $col INT";
				break;
			case "BLOB":
				$desc .= ", $col VARCHAR2(2000)";
				break;
			default:
				$desc .= ", $col VARCHAR2($size)";
				break;
		}
	}

	$desc = ereg_replace ("^, ", "", $desc);

	if (!Ora_Parse ($cursor, "CREATE TABLE $table ($desc)") ) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}
	if (!Ora_Exec($cursor) ) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	Ora_Close ($cursor);
	Ora_Commit ($this->dblink);
	return 0;
}


#	------------------------------------------------------------------
#				Forum management functions
#	------------------------------------------------------------------

# gets info about forum $name in site $site 
# -----------------------------------------
function getForum ($site, $name) {

	$query = "SELECT $site.*, ${site}_users.username as ownername, ${site}_users.useraddress as owneraddress
			FROM ${site}, ${site}_users
			WHERE bn_name='$name' AND ${site}_users.userid = $site.owner";
	$result = mysql_db_query($this->dbname, "$query", $this->dblink);
	if ($result) {
		$forum = mysql_fetch_array ($result);
	} else {
		return -3;
	}

	mysql_FreeResult($result);
	return $forum;
}

function deleteForum ($forum, $password) {

	$forum_passwd = $this->getPassword($forum);
	if ($password != $forum_passwd) return (-2); /* invalid password */

	$cursor = $this->query ("DROP TABLE $forum");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}
	Ora_Close ($cursor);
	Ora_Commit ($this->dblink);
	return 0;
}

function getPassword ($forum) {
	$cursor = $this->query ("SELECT password FROM $forum WHERE cle=0");
	if (!Ora_Fetch($cursor)) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	$password = Ora_GetColumn ($cursor, 0);
	Ora_Close ($cursor);
	return $password;
}

function changePassword ($forum, $old_pass, $new_pass) {

	$forum_passwd = $this->getPassword($forum);
	if ($old_pass != $forum_passwd) return (-2); /* invalid password */

	$cursor = $this->query ("UPDATE $forum SET password='$new_pass' WHERE cle=0");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}
	Ora_Close ($cursor);
	Ora_Commit ($this->dblink);
	return 0;
}

function listNotes ($forum, $action, $first=0, $last=0) {
	global $bn_view_header, $bn_view_footer;
	global $bn_list_header, $bn_list_footer;
	global $bn_delete_header, $bn_delete_footer;
	global $bn_maxthreads, $list_var;

	if (!$bn_maxthreads) $bn_maxthreads = 0;

	// 1) gets total count # of notes
	$cursor = $this->query ("SELECT count(*) FROM $forum WHERE cle<>0");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}
	if (!Ora_Fetch($cursor)) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}
	$ret["total"] = Ora_GetColumn ($cursor, 0);
	if ($ret[total] == 0) return ($ret);

        // 2) Find the first thread to be displayed in the page starting from
        //    the end (last_thread - bn_max_threads)
	if (($bn_maxthreads>0) && $last && !$first) {
		$query = "SELECT DISTINCT thread FROM $forum WHERE thread >=$last GROUP BY thread ORDER BY thread LIMIT $bn_maxthreads";
		$cursor = $this->query ("$query");
		if ($cursor) {
			while ($row = Ora_Fetch($cursor)) {
				$first = Ora_GetColumn ($cursor, 0);
			}
		}
	}

	// 3) gets all threads
	$where="cle<>0";
	if ($first) $where .= " AND thread<=$first";
	if ($last) $where .= " AND thread>=$last";
	$cols = "cle,parent,childs,thread,newest";
	while (list($var,$val) = each($list_var)) {
		if ($val==1) $cols.=",$var";
	}
	$cursor = $this->query ("SELECT $cols FROM $forum WHERE $where ORDER BY thread DESC,cle ASC");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	$tlast=time(); $tfirst=0; $tcount = 0;
	
	while ($row = $this->fetch_array($cursor)) {
		$key = $row["cle"];
		$parent = $row["parent"];
		if (!$parent) { // new thread
			if (($tcount < $bn_maxthreads) || ($bn_maxthreads == 0)) {
				$this->entries[$key] = $row;
				$this->children[$parent][] = $key;
				if ($key < $tlast) $tlast = $key;
				if ($key > $tfirst) $tfirst = $key;
				$tcount++;
			}
			else
				$next=1;
		}
		else {
			$this->entries[$key] = $row;
			$this->children[$parent][] = $key;
		}
	}

	if (!isSet ($prev)) {
		$cursor = $this->query ("SELECT count(*) FROM $forum WHERE thread>$tfirst AND cle<>0");
		if (!$cursor) {
			echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
			Ora_Logoff($this->dblink);
			return -3;
		}
		$row = $this->fetch_array($cursor);
		if (is_array ($row)) $prev=$row[0];
	}

	if (!isSet ($next)) {
		$cursor = $this->query ("SELECT count(*) FROM $forum WHERE thread<$tlast AND cle<>0");
		if (!$cursor) {
			echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
			Ora_Logoff($this->dblink);
			return -3;
		}
		$row = $this->fetch_array($cursor);
		if (is_array ($row)) $next=$row[0];
	}
	
	Ora_Close ($cursor);

	$header="bn_${action}_header";
	$l=addSlashes(stripSlashes($$header));
	eval ("echo stripSlashes(\"$l\");");

	$this->getChild (0, $action);

	$footer="bn_${action}_footer";
	$l=addSlashes(stripSlashes($$footer));
	eval ("echo stripSlashes(\"$l\");");

	$ret["threads"]=$tcount;
	$ret["next"]=$next;
	$ret["prev"]=$prev;
	$ret["first"]=$tfirst;
	$ret["last"]=$tlast;
	return ($ret);
}

function getNote ($forum, $key) {

	$cursor = $this->query ("SELECT * FROM $forum WHERE cle=$key");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	$note = $this->fetch_array($cursor);
	if (!$note) {
		return -4;
	}

	$whereclause = "thread > " . $note[thread];
	$cursor = $this->query ("SELECT min(thread) FROM $forum WHERE $whereclause");
	if (Ora_Fetch($cursor)) {
		$note["tprev"] = Ora_GetColumn ($cursor, 0);
	}
	
	$whereclause = "thread < " . $note[thread];
	$cursor = $this->query ("SELECT max(thread) FROM $forum WHERE $whereclause");
	if (Ora_Fetch($cursor)) {
		$note[tnext] = Ora_GetColumn ($cursor, 0);
	}

	Ora_Close ($cursor);

	return ($note);
}

function getThreadNewest ($forum, $thread) {
 	$where="thread=$thread AND cle<>0";
	$cursor = $this->query ("SELECT MAX(unixdate) FROM $forum WHERE $where");

	if (!Ora_Fetch($cursor)) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
        }

	$newest = Ora_GetColumn ($cursor, 0);

	Ora_Close ($cursor);
	return $newest;
}


function getThread ($forum, $key, $thread) {
	global $bn_view_header, $bn_view_footer;

	reset ($this->entries);
	reset ($this->children);
	
	$where="thread=$thread AND cle<>0";

	$cursor = $this->query ("SELECT * FROM $forum WHERE $where ORDER BY cle");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	while ($row = $this->fetch_array($cursor)) {
		$key = $row["cle"];
		$parent = $row["parent"];
		$this->entries[$key] = $row;
		$this->children[$parent][] = $key;
	}

	Ora_Close ($cursor);

	// display header
	$l=addSlashes(stripSlashes($bn_view_header));
	eval ("echo stripSlashes(\"$l\");");

	$ret = $this->getChild (0, "view");

	// display footer
	$l=addSlashes(stripSlashes($bn_view_footer));
	eval ("echo stripSlashes(\"$l\");");

}

function insertNote ($forum, $key, $fields) {
	$ret = $this->insert ($forum, $key, 0, $key, $fields);
	return $ret;
}

function threadNote ($forum, $key, $parent_key, $fields) {

	$cursor = $this->query ("SELECT * FROM $forum WHERE cle=$parent_key");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	$row = $this->fetch_array($cursor);
	if (!$row) return -4;

	$thread = $row[thread];
	$childs = $row[childs];
	$childs++;

	$values = "childs=$childs, thread=$thread";

	$cursor = $this->query ( "UPDATE $forum SET $values WHERE cle=$parent_key");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	$newest = $fields[unixdate];
	$cursor = $this->query ( "UPDATE $forum SET newest=$newest WHERE thread=$thread");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	Ora_Close ($cursor);

	$ret = $this->insert ($forum, $key, $parent_key, $thread, $fields);
	return $ret;
}

function insert ($forum, $key, $parent, $thread, &$note) {

	// Get fields defined in table
echo "SELECT * FROM $forum WHERE cle=0";
	$cursor = $this->query ("SELECT * FROM $forum WHERE cle=0");
	if (!Ora_Fetch($cursor)) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	$note["parent"] = $parent;
	$note["childs"] = 0;
	$note["thread"] = $thread;
	$note["newest"] = $note["unixdate"];

	$cols = "cle";
	$values = "$key";

	// gets all fields name and type
	$i=0;
        while ($col = @Ora_ColumnName ($cursor,$i) ) {
		$colname = strtolower($col);
                $coltype = Ora_ColumnType ($cursor,$i);
		$val = ereg_replace("'","''", $note[$colname]);
		if (!empty($val)) {
			$cols .= ", $colname";
			if ($coltype == "NUMBER")
				$values .= ", " . IntVal($val);
			else
				$values .= ", '$val'";
		}
if ($this->debug) echo "insert() name : $colname, value: $val, type: $coltype <br>";
                $i++;
	}

if ($this->debug) echo "INSERT INTO $forum ($cols) VALUES($values)";
	$cursor = $this->query("INSERT INTO $forum ($cols) VALUES($values)");
	if (!$cursor) { /* insert problem */
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return (-3);
	}

	Ora_Close ($cursor);
	Ora_Commit ($this->dblink);

	return ($key);
}

function updateNote ($forum, $key, $passwd, &$fields) {
	global $bn_var, $db_var;

	$cursor = $this->query ("SELECT * FROM $forum WHERE cle=$key");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	$row = $this->fetch_array($cursor);

	if (!$row) return (-4); /* no row selected */

	$admin_password = $this->GetPassword($forum);
	if (($passwd != $row[password]) && ($passwd != $admin_password)) {
		return -2; /* invalid password */
	}

	$fields["parent"] = $row ["parent"];
	$fields["childs"] = $row ["childs"];
	$fields["thread"] = $row ["thread"];
	$fields["newest"] = $row ["newest"];

	$values = "cle=$key";

	// gets fields name and type
	$i=0;
        while ($col = @Ora_ColumnName ($cursor,$i) ) {
		$colname = strtolower($col);
                $coltype = Ora_ColumnType ($cursor,$i);
		$val = ereg_replace("'","''", $note[$colname]);
		if (!empty($val)) {
			if ($coltype == "int")
				$values .= ", $colname= " . intVal($val);
			else
				$values .= ", $colname= '$val'";
		}
if ($this->debug) echo "update() - name : $colname, value: $val, type: $coltype <br>";
		$i++;
	}

	$cursor = $this->query ("UPDATE $forum SET $values WHERE cle=$key");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	Ora_Close ($cursor);
	Ora_Commit ($this->dblink);
	return (0);
}

function updateThread($forum, $parent, $newthread) {

	$cursor = $this->query ("UPDATE $forum SET thread=$newthread WHERE parent=$parent");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	$cursor = $this->query ("SELECT cle, childs FROM $forum WHERE parent=$parent");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}
	
	while ($row = $this->fetch_array($cursor)) {
		if ($row[childs] > 0) {
			$this->updateThread ($forum, $row[cle], $newthread);
		}
	}
	Ora_Close ($cursor);
}

function deleteNote ($forum, $key, $passwd) {
	global $bn, $bn_dir_notes;

	$cursor = $this->query ( "SELECT * FROM $forum WHERE cle=$key");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}
 	
	$row = $this->fetch_array($cursor);

	if (!$row) return (-4); /* no row selected */

	$admin_password = $this->GetPassword($forum);
	if (($passwd != $row[password]) && ($passwd != $admin_password)) {
		return -2; /* invalid password */
	}

 	$filename = $row["filename"];
 	$attachment = $row["attachment"];
 	$parent = $row["parent"];
 	$childs = $row["childs"];
 	$thread = $row["thread"];

	Ora_Close ($cursor);

	// delete note
	$cursor = $this->query ("DELETE FROM $forum WHERE cle=$key");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}
	Ora_Close ($cursor);

	if ($parent > 0) {
		// decrement childs count in parent
		$cursor = $this->query ("UPDATE $forum SET childs=childs-1 WHERE cle=$parent");
		if (!$cursor) {
			echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
			Ora_Logoff($this->dblink);
			return -3;
		}
	}
	else {
		// update thread value
		$cursor = $this->query ("SELECT cle, childs FROM $forum WHERE parent=$key");
		if (!$cursor) {
			echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
			Ora_Logoff($this->dblink);
			return -3;
		}
		while ($row = $this->fetch_array($cursor)) {
			$childkey=$row["cle"];
			$rc = $this->query ("UPDATE $forum SET thread=$childkey WHERE cle=$childkey");
			if (!$rc) {
				echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
				Ora_Logoff($this->dblink);
				return -3;
			}
			if ($row["childs"] > 0) {
				$this->updateThread ($forum, $childkey, $childkey);
			}
		}
	}

	// Link children to parent
	if ($childs > 0) {
		$cursor = $this->query ("UPDATE $forum SET parent=$parent WHERE parent=$key");
		if (!$cursor) {
			echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
			Ora_Logoff($this->dblink);
			return -3;
		}
		Ora_Close ($cursor);
	}


	// update newest in thread
	if ($key != $thread) {
		$newest = $this->getThreadNewest ($forum, $thread);
		if ($newest >= 0) {
			$cursor = $this->query ("UPDATE $forum SET newest=$newest WHERE thread=$thread");
			if (!$cursor) {
				echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
				Ora_Logoff($this->dblink);
				return -3;
			}
			Ora_Close ($cursor);
		}
	}
	
	if (($filename != "none") && is_file("$bn_dir_notes/$filename")) {
 		@unlink ("$bn_dir_notes/$filename");
	}

	if ($attachment && ($attachment != "none") && is_file ("$bn_dir_notes/$key/$attachment") ) {
		@unlink ("$bn_dir_notes/$key/$attachment");
		@rmdir ("$bn_dir_notes/$key");
	}

	Ora_Commit ($this->dblink);
	return 0;
}

function mDeleteDate ($forum, $from, $to, $passwd) {

	$admin_password	= $this->getPassword($forum);
	if ($passwd != $admin_password) {
		return -2; /* invalid password */
	}

	$cursor = $this->query ("SELECT cle FROM $forum WHERE cle>=$from AND cle <= $to");
	if (!$cursor) return 0;

	while ($row = $this->fetch_array($cursor)) {
		$ret = $this->deleteNote($forum, $row["cle"], $passwd);
		if ($ret < 0) {
			return $ret;
		}
	}

	Ora_Close ($cursor);
	return 0;
}

function search ($forum, $pattern, $casesensitive) {
	global $bn, $bn_dir;
	global $bn_dir_notes;
	global $bn_maxthreads;
	global $bn_list_header, $bn_list_footer;
	global $msg;
	global $bn_date_format;

	// Get fields defined in table
	$cursor = $this->query ("SELECT * FROM $forum WHERE cle=0");
	if (!Ora_Fetch($cursor)) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	if ($casesensitive) {
		$where = "WHERE body LIKE '%$pattern%'";
	}
	else {
		$where = "WHERE lower(body) LIKE lower('%$pattern%')";
	}

	$i=0;
        while ($col = @Ora_ColumnName ($cursor,$i) ) {
		$colname = strtolower($col);
                $coltype = Ora_ColumnType ($cursor,$i);
		if (($coltype != "int") && ($colname != "body")) {
			if ($casesensitive)
				$where .= " OR $colname LIKE '%$pattern%'";
			else
				$where .= " OR lower($colname) LIKE lower('%$pattern%')";
		}
		$i++;
	}

	$cursor = $this->query ( "SELECT DISTINCT * FROM $forum $where");
	if (!$cursor) {
		echo "ORACLE error: ".Ora_ErrorCode($cursor).": ".Ora_Error($cursor)."<BR>";
		Ora_Logoff($this->dblink);
		return -3;
	}

	$i=0;
	$tlast=time(); $tfirst=0; $tcount = 0;
	while ($row = $this->fetch_array($cursor)) {
		$i++;
		$key = $row["cle"];
		if (($tcount < $bn_maxthreads) || ($bn_maxthreads == 0)) {
			$this->entries[$key] = $row;
			$this->children[0][] = $key;
			if ($key < $tlast) $tlast = $key;
			if ($key > $tfirst) $tfirst = $key;
			$tcount++;
		}
		else
			$next=1;
	}

	// If no message found
	if ($i==0) {
		echo "<p><center><h2>"; DspMsg(30);echo "</center></h2>";
		return 0;
	}

	// display header
	$l=addSlashes(stripSlashes($bn_list_header));
	eval ("echo stripSlashes(\"$l\");");

	$ret = $this->getChild (0, "list");

	// display footer
	$l=addSlashes(stripSlashes($bn_list_footer));
	eval ("echo stripSlashes(\"$l\");");

	Ora_Close ($cursor);
	return 0;

}

}; // end class

?>
