<?

/*
 *	W-AGORA 3.0
 *	-----------
 *	$Id: postgres.php3,v 1.4 2001/01/15 12:31:25 mdruilhe Exp $
 *	Usage:		include file - Database access functions (Postgres version 6.4  or older)
 *	Authors:	Ron Friedman <friedman@filmmaker.com>
 *				Marc Druilhe <mdruilhe@araxe.fr>
 */

if (!defined("_DBACCESS")) {
	include ("$inc_dir/dbaccess.$ext");
}

#   Postgres-specifics notes:

#      This is essentially a modified version of the mSQL and mySQL /include
#      files.  I am *NOT* a programmer (read;  I suck!) so these are probably
#      all kludgy and messy and it would be nice if a real smart person were to
#      clean it all up.  Basically though, it SEEMS to work for me!  I don't
#      know how or why, but it does.
#
#      To get this working:
#
#        *  This is a php 3.x file, so PHP 2.x people are out of luck.
#
#        *  PHP v3.0 -> 3.02 doesn't include the function pg_fetch_array(), so
#           after reading the PHP dox, I wrote my own version.
#           If you have PHP < 3.03 which doesn't include pg_fetch_array(), you can
#           probably add the function back in.  Then cross your fingers.
#
#        *  If you used postgres.php3 earlier than b12, make sure you add a column
#           "newest" (type int4) to your message bases and also update your forum.var
#           files.
#
#      That's all I can think of for now.  It's not done, but it's a start...
#
#      Enjoy ---Ron
#       11/05/98

/*  VERSION NOTES
b23  - (MD) Fixed bug in next/prev stuff in listThreads();
b22  - (Ron) Fixed tiny little bugs.
b21  - (MD) fixed (tried to fix) back button
       add QUERY_LIMIT to load only displayed threads
       made (tried to) listNotes() working
b20  - (Ron)  Made the OpenDB() function compatable with mysql's.
        Updated GetPasswd() to make compatible
        other functions were changed to make compatible too w/b5.
        fixed up listthreads() so it'd show the # of replies.
        fixed bug in search()  (thanks marc!)
b19  - (MD) removed calls to getChild() and display, now the notes are displayed
        by the calling scripts
     - Added listThreads() (replacing listNotes() )
b18  - (MD) removed $bn_db references, now the tablename ($forum) is passed as
       an argument of all functions.
       removed initialization : new postgres_access is now done in init.php3
b17  - (MD) added msg[81) (date), removed commented lines.
b16  - (Marc) changed openDB() so that all variables are set in the config. file
	   Changed createForum() to take into account new $bn_var arrays format
b15  = (Ron) fixed bugs to the updatenotes() & updatethreads() functions... 
       did some more cleanup, & a minor fix to the search so it would strip the slashes
       & I also checked over the functions as a whole to make sure the passed variables
       match with marc's similarly named functions in mysql.php3, etc.  Hope I got them all.
b14  = (Ron)  Fixed minor bugs from Marc's b12 & b13-- 
       Also updated the search so that it would
       check any field of type "text" (as opposed
       to any non int4 field).  Also cleaned up
       some old stupidity from earlier ports.
       Fixed threadnote()... guess that's it.
b13  - (marc) fixed bug in deleteNote() : thread field was not updated in child notes
       if root note was deleted (added function updateThread() )
       added nextThread/ prev. thread returned in getNote()
       Column's Order should be (now) unimportant
       Changed order of some functions according to other modules for
       maintenance facility
b12  - (marc) added column 'newest' => maintain last note posted in a thread
      Sort notes ascending by date in a thread
      Store only required fields in listNotes()
      Added caseSensitive as parameter in search()
b11  - added in Tom deLombarde's <tomd@blackflute.com> collapsing threads    --Ron
      For this to work, the 'Line Contents' field of Notes List must include:
      $newestPrmpt $newestNote
      Using Marc's default Line Contents, this would be (color added to visually
      set off the newest date, this also includes the new code above):
      <li><i> $exp_ahref<img src='$exp_icon' border='0'>$exp_ehref
      $formated_date</i> &lt;$username&gt;
      <a href='view.php3?bn=$bn&key=$note'><b>$subject</b></a>
      <font color='#000080'><strong>$newestPrmpt</strong></font>
      <font color='#FF0000'>$newestNote</font>
b10  - fixed stripslashes problem  --Ron
b9   - FIXED SEARCH ENGINE!  --Ron
       New Feature:  Case sensitive searches (to toggle, go down to program and set
                     $casesensitive .  Hopefully marc will add an option for this in the
                     configuration.  --Ron
	   Fixed arrow weirdness.  Are they working now all the time?  --Ron
       Made default *NOT* use my pg_fetch_array (so it's ready for PHP 3.03 and up) --Ron
b1-8  (Marc & Ron go back and forth.. These are the early versions...)


*/


/*************************************************************************
 * pg_fetch_array()                                                      *
 *  NOTE:  UNCOMMENT THIS FUNCTION IF YOU ARE USING A PHP                *
 *  VERSION LESS THAN 3.03.  This mimics the function                    *
 *  pg_fetch_array() which doesn't exist in 3.0, 3.01 or 3.02.
 *      --Ron
 */

#function pg_fetch_array ($res, $z) {

#$rows = pg_numrows($res);
#$fields = pg_numfields($res);
#
#if ($z > ($rows-1)) return (FALSE);
#
#  for($y=0; $y < $fields; $y++){
#    $fname = pg_fieldname($res,$y);
#     $fvalue= pg_result($res,$z,$y);
#    $arr[$fname] = $fvalue;
#  }

#return($arr);

#}

class postgres_access extends DBaccess {

function OpenDB () {
	global $dbhost, $dbport, $dbuser, $dbpassword, $dbname;

	if (!empty($dbhost))
		$login_string = "host=$dbhost";
	if (!empty($dbport))
		$login_string .= " port=$dbport";
	if (!empty($dbuser))
		$login_string .= " user=$dbuser";
	if (!empty($dbpassword))
		$login_string .= " password=$dbpassword";
	if (!empty($dbname))
		$login_string .= " dbname=$dbname";

if ($this->debug) echo "login_string: $login_string<BR>";

	$this->dblink = pg_connect ($login_string);
 
	if (empty($this->dblink)) {
		return -3;
	}

	if (empty ($dbname)) {
		$dbname = "agora";
	}

    if (!pg_dbname($this->dblink)) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return -3;
    }
    
    $this->dbname = $dbname;
    return 0;
    
}

function createForum ($table, $password) {
	global $bn_var, $db_var;
	global $bn_var_size;

	/* Check if table exists */

	$result = pg_exec($this->dblink, "select relname from pg_class where relname not like 'pg_%'");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}
	$count = pg_NumRows ($result);
	$i=0; $found=0;
	while ($i < $count):
		if ($table == pg_result ($result, $i, 0)):
			$found=1; $i=$count;
		else:
			$i++;
		endif;
	endwhile;
	if ($found):
		return (-1); /*  table already exist */
	endif;

	/* Create Table */
	$desc = "cle INT NOT NULL PRIMARY KEY";
	$desc .= ", parent INT";
	$desc .= ", childs INT";
	$desc .= ", thread INT";
	$desc .= ", newest INT";
	$values = "0, 0, 0, 0, 0";
	$unixdate = time();
	$count = Count ($bn_var);
	$i=0;
	while ($i < $count):
		$col = $bn_var[$i];
		$val = $$col;
		$size = $bn_var_size[$col];
		if (ereg ("^[0-9+]+$", $size) ) {
			if ($size>255) {
				$desc .= ", $col TEXT";
			} else {
				$desc .= ", $col VARCHAR($size) NOT NULL DEFAULT ''";
			}
			$values .= ", '$val'";
		} else {
			$type = strtoupper($size);
			switch ($type) {
				case "INT":
				case "AUTO":
					$desc .= ", $col INT NOT NULL DEFAULT 0";
					$values .= ", " . IntVal($val);
					break;
				case "BLOB":
					$desc .= ", $col text";
					$values .= ", '$val'";
					break;
				default:
					$desc .= ", $col $type";
					$values .= ", '$val'";
					break;
			}
		}
		$i++;
	endwhile;

	$count = Count ($db_var);
	$i=0;
	while ($i < $count):
		$col = $db_var[$i];
		$val = $$col;
		$size = $bn_var_size[$col];
		if (ereg ("^[0-9+]+$", $size) ) {
			if ($size>255) {
				$desc .= ", $col TEXT";
			} else {
				$desc .= ", $col VARCHAR($size) NOT NULL DEFAULT ''";
			}
			$values .= ", '$val'";
		} else {
			$type = strtoupper($size);
			switch ($type) {
				case "INT":
				case "AUTO":
					$desc .= ", $col INT NOT NULL DEFAULT 0";
					$values .= ", " . IntVal($val);
					break;
				case "BLOB":
					$desc .= ", $col text";
					$values .= ", '$val'";
					break;
				default:
					$desc .= ", $col $type";
					$values .= ", '$val'";
					break;
			}
		}
		$i++;
	endwhile;

if ($this->debug) echo "create table $table ($desc)<br>";
	$result = pg_exec ($this->dblink, "CREATE TABLE $table ($desc)");
	if (!$result) {  /* access PB  */
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}


if ($this->debug) echo "insert into $table values ($values)<br>";

	$result = pg_exec ($this->dblink, "INSERT INTO $table VALUES($values)");
	if (!$result) {  /* access PB  */
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}
	return (0);
}

function deleteForum ($table, $password) {
	$forum_passwd = $this->GetPassword($table);
	if ($password != $forum_passwd) return (-2); /* invalid password */
	$query = "DROP TABLE $table";
	$result = pg_exec ($this->dblink, $query);
	if (!$result) return (-3); /* access problem */
	return (0);
}

function getPassword ($forum) {

	$query = "SELECT password FROM $forum WHERE cle=0";
	$result = pg_exec ($this->dblink, $query);
	if (!$result) {  /* access PB  */
		echo "PostgresL error:  ".pg_errormessage()."<BR>";
		return "";
	}
	
	$num = pg_NumRows($result);
	if ($num > 0) {
		$password = pg_result ($result, 0, 0);
		return ("$password");
	}
	return "";
}

function changePassword ($forum, $old_pass, $new_pass) {

	$forum_passwd = $this->GetPassword($forum);
	if ($old_pass != $forum_passwd) return (-2); /* invalid password */

	$query = "UPDATE $forum SET password='$new_pass' WHERE cle=0";
	$result = pg_exec ($this->dblink, $query);
	if (!$result) return (-3); /* access problem */
	return (0);
}

function listThreads ($forum, $first=0, $last=0) {
	global $bn_maxthreads, $list_var;

	$bn_maxthreads = (isSet($bn_maxthreads) ) ? $bn_maxthreads : 0;
	settype ($bn_maxthreads, "integer");
	settype ($first, "integer");
	settype ($last, "integer");

#	1) gets total count # of notes
#	------------------------------
	$result = @pg_exec ($this->dblink, "SELECT count(*) FROM $forum WHERE cle<>0");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	$ret["total"] = @pg_result ($result, 0, "count");
	if ($ret["total"] == 0) {
	    return $ret;
	}
	pg_FreeResult($result);

#	2) Find the first (and last) thread to be displayed in the page
#	and gets number of notes per thread
#	----------------------------------------------------------------
	if (!$last) {
		$order="DESC";
		$last=1;
	} else {
		$order="ASC";
	}
	
	$where = "newest>=$last"; // $last default to 1: don't display key 0
	if ($first>0) {
		$where .= " AND newest<=$first";
	}

	if (!empty($bn_maxthreads)) {
		$result = pg_exec ($this->dblink, "set QUERY_LIMIT TO '$bn_maxthreads'");
	}

	$query = "SELECT thread, newest, count(*) FROM $forum WHERE $where GROUP BY thread ORDER BY newest $order";
	$result = pg_exec ($this->dblink, "$query");		
	$tcount = pg_numrows ($result);

	if ($tcount > 0) {
		if (!empty($bn_maxthreads) && ($tcount > $bn_maxthreads) ) {
			$tcount=$bn_maxthreads;
		}
		if ($order=="DESC") {
			$tfirst  = @pg_result ($result, 0, "newest");
			$tlast = @pg_result ($result, $tcount-1, "newest");
		} else {
			$tlast  = @pg_result ($result, 0, "newest");
			$tfirst = @pg_result ($result, $tcount-1, "newest");
		}	

		for ($i=0; $i<$tcount; $i++) {
			$row = pg_fetch_row($result, $i);
			$t = $row[0];
			$replies[$t] = $row[2] - 1;
		}
	}

	pg_FreeResult($result);

	$ret["threads"]=$tcount;
	$ret["first"]=$tfirst;
	$ret["last"]=$tlast;

	if ($tcount < 1) {
		$ret["next"] = 0;
		$ret["prev"] = 0;
		return $ret;
	}

#	3) gets all threads
#	-------------------

	$where = "newest<=$tfirst AND thread>=$tlast";

	$cols = "cle,parent,childs,thread,newest";
	while (list($var,$val) = each($list_var)) {
		if ($val==1) $cols.=",$var";
	}
	
if ($this->debug) echo "SELECT $cols FROM $forum WHERE $where ORDER BY thread DESC,cle ASC<br>";
	$result = @pg_exec ($this->dblink, "SELECT $cols FROM $forum WHERE $where ORDER BY newest DESC,cle ASC");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	reset ($this->entries);
	reset ($this->children);
	$n=0;
	while ($row = @pg_fetch_array($result, $n)) {
		$key = $row["cle"];
		$parent = $row["parent"];
		if ($parent==0) {
			$row["replies"] = $replies[$key];
		}
		$this->entries[$key] = $row;
		$this->children[$parent][] = $key;
		$n++;
	}

	pg_freeresult($result); 

#	4) gets next/previous count
#	---------------------------
	$result = @pg_exec ($this->dblink, "SELECT count(*) FROM $forum WHERE thread>$tfirst");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}
	$ret["prev"] = @pg_result ($result, 0, "count");

	pg_freeresult($result); 

	$result = @pg_exec ($this->dblink, "SELECT count(*) FROM $forum WHERE cle<> 0 AND thread<$tlast");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}
	$ret["next"] = @pg_result ($result, 0, "count");

	pg_FreeResult($result);
		
	return $ret;
}

function listNotes ($forum, $first=0, $last=0, $sort="", $where="") {
	global $bn_maxthreads, $list_var;

	if (!isSet($bn_maxthreads)) {
		$bn_maxthreads = 0;
	}

#	1) gets total count # of notes
#	------------------------------
	$result = @pg_exec ($this->dblink, "SELECT count(*) FROM $forum WHERE cle<>0");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	$ret["total"] = @pg_result ($result, 0, "count");
	if ($ret["total"] == 0) {
	    return $ret;
	}
	pg_FreeResult($result);

#	2) gets all notes sorted by $sort
#	---------------------------------
	$whereClause = "WHERE cle>0"; // skip administrative record
	
	if (!empty($where)) {
		$whereClause .= "AND $where";
	}
	
	$orderClause = (empty ($sort)) ? "" : "ORDER BY $sort";
	
	$cols = "cle,parent,childs,thread,newest";
	while (list($var,$val) = each($list_var)) {
		if ($val==1) $cols.=",$var";
	}

	$query = "SELECT $cols FROM $forum $whereClause $orderClause";
	$result = @pg_exec ($this->dblink, "$query");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	$num = @pg_numrows ($result);
	
	if ($bn_maxthreads>0) {
		if ($last > 0) {
			$start = $last-$bn_maxthreads+1;
			if ($start<0) {
				$start=0;
			}
		} else {
			$start = $first;
		}
		$nmaxdisplay = $num - $start;
		$ndisplay = ($bn_maxthreads > $nmaxdisplay) ? $nmaxdisplay : $bn_maxthreads;
		$end = $start+$ndisplay-1;

	} else {
		$start = 0;
		$end = $num-1;
	}
	
	reset ($this->entries);
	reset ($this->children);
	
	for ($i = $start; $i <= $end; $i++) {
		$row = @pg_fetch_array($result, $i);
		$key = $row["cle"];
		$row["parent"]=0;
		$this->entries[$key] = $row;
		$this->children[0][] = $key;
	}

	pg_FreeResult($result);

#	3) gets next/previous (1 if TRUE)
#	---------------------------------
	$ret["threads"] = $end - $start + 1;
	$ret["first"] = $start;
	$ret["last"] = $end;
	$ret["next"] = ($num > $end) ? 1 : 0;
	$ret["prev"] = ($start > 0) ? 1 : 0;
	
	return $ret;
}

function getNote ($forum, $key, $where="") {

	$result = pg_exec($this->dblink, "SELECT * FROM $forum WHERE cle=$key");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}
	$num = pg_NumRows($result);
	if ($num < 1) return (-4);

	$note = @pg_fetch_array($result, 0);
    $cnt = count($note);
	for ($i=0; $i<=$cnt; $i++) {
		$note[$i]=stripslashes($note[$i]);
	}
	pg_FreeResult($result);

	$whereclause = "thread > " . $note["thread"];
	$result = @pg_exec ($this->dblink, "SELECT min(thread) FROM $forum WHERE $whereclause");
	if ($result) {
		$prev = pg_fetch_row($result, 0);
		$note["tprev"]= $prev[0];
		pg_FreeResult($result);
	}
	
	$whereclause = "thread < " . $note["thread"];
	$result = @pg_exec ($this->dblink, "SELECT max(thread) FROM $forum WHERE $whereclause");
	if ($result) {
		$next = pg_fetch_row($result, 0);
		$note["tnext"]= $next[0];
		pg_FreeResult($result);
	}
	return ($note);
}

function getThreadNewest ($forum, $thread) {
 
 	$where="thread=$thread AND cle<>0";
 	$result = @pg_exec ($this->dblink, "SELECT MAX(unixdate) FROM $forum WHERE $where");
 	if (!$result) {
 		echo "Postgres error: ".pg_errormessage()."<BR>";
 		return (-3);
 	}
 	$row = pg_fetch_row($result, 0);
 	$newest = $row[0];
	pg_FreeResult($result);
    return $newest;
}

function getThread ($forum, $key, $thread) {

	reset ($this->entries);
	reset ($this->children);

	$where="thread=$thread AND cle<>0";
	$result = pg_exec ($this->dblink, "SELECT * FROM $forum WHERE $where ORDER BY cle");
if ($this->debug) 	echo "SELECT * FROM $forum WHERE $where ORDER BY cle";
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	$n = 0;
	while ($row = @pg_fetch_array($result, $n)) {
		$key = $row["cle"];
		$parent = $row["parent"];
		$this->entries[$key] = $row;
		$this->children[$parent][] = $key;
		$n++;
	}

	pg_FreeResult($result);
	return 0;
}

function insertNote ($forum, $key, $fields) {

	$ret = $this->insert ($forum, $key, 0, $key, $fields);
	return $ret;
}

function threadNote ($forum, $key, $parent_key, $fields) {

	$result = pg_exec($this->dblink, "SELECT * FROM $forum WHERE cle=$parent_key");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	$num = pg_NumRows($result);
	if ($num  < 1)
		return -4;
	$thread = pg_result ($result, 0, "thread");
	$childs = pg_result ($result, 0, "childs");
	$childs++;
	$values = "childs=$childs, thread=$thread";

if ($this->debug) echo "UPDATE $forum SET $values WHERE cle=$parent_key";
	$result = pg_exec($this->dblink, "UPDATE $forum SET $values WHERE cle=$parent_key");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	$newest = $fields["unixdate"];
if ($this->debug) echo "UPDATE $forum SET newest=$newest WHERE thread=$thread";
	$result = pg_exec ($this->dblink, "UPDATE $forum SET newest=$newest WHERE thread=$thread");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}
	
	$ret = $this->insert ($forum, $key, $parent_key, $thread, $fields);
	return $ret;
}

function insert ($forum, $key, $parent, $thread, &$note) {

	// Get fields defined in table
    $result = pg_exec ($this->dblink,
     "select a.attname, t.typname from pg_class c, pg_attribute a, pg_type t where c.relname = '$forum' and a.attnum > 0 and a.attrelid = c.oid and a.atttypid = t.oid");

	if (!$result) { /* access problem */
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	$note["parent"] = $parent;
	$note["childs"] = 0;
	$note["thread"] = $thread;
	$note["newest"] = $note["unixdate"];
	$cols = "cle";
	$values = "$key";

	$i=pg_numrows($result);
	
if ($this->debug) echo "numfields:  ". pg_numrows($result)."<br>";

	// gets fields name and type
	while ($i >= 0) {
		$colname = @pg_result($result, $i, 0);
		$coltype = @pg_result($result, $i, 1);
		$val = addSlashes($note[$colname]);
		if (!empty ($val)) {
			$cols .= ", " . $colname;
			if ($coltype == "int4") {
				$values .= ", " . IntVal($val);
			} else {
				if (strlen($val) > 7000) {
					$val = substr ($val, 0, 7000);
				}
				$values .= ", '$val'";
			}
		}
		$i--;
if ($this->debug) echo "$i : name : $colname, note: $note,  value: $val, type: $coltype <br>";

 	}
if ($this->debug) echo "INSERT INTO $forum ($cols) VALUES($values)";

	$result = pg_exec($this->dblink, "INSERT INTO $forum ($cols) VALUES($values)");
	if (!$result) { /* insert problem */
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}
	return ($key);
}

function updateNote ($forum, $key, $passwd, &$fields) {

	$result = pg_exec($this->dblink, "SELECT * FROM $forum WHERE cle=$key");
	if ($result < 0) return (-3);  /* access error */
	
	$num = pg_NumRows($result);
	if ($num < 1) return (-4); /* no row selected */

	$admin_password = $this->GetPassword($forum);
	$password = pg_result ($result, 0, "password");
	if (($passwd != $password) && ($passwd != $admin_password)):
		return (-2); /* invalid password */
	endif;

	$fields["parent"] = pg_result ($result, 0, "parent");
	$fields["childs"] = pg_result ($result, 0, "childs");
	$fields["thread"] = pg_result ($result, 0, "thread");
	$fields["newest"] = pg_result ($result, 0, "newest");

	$values = "cle=$key";

	// Get fields defined in table
    $result = pg_exec ($this->dblink,
 "select a.attname, t.typname from pg_class c, pg_attribute a, pg_type t where c.relname = '$forum' and a.attnum > 0 and a.attrelid = c.oid and a.atttypid = t.oid;");
	if (!$result) { /* access problem */
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	$bob=pg_numrows($result);
if ($this->debug) echo "numfields:  ". pg_numrows($result)."<br>";

	// gets fields name and type
	for ($i=($bob-1); $i>=0; $i--) {
	
		$colname = pg_result($result, $i, 0);
		$coltype = pg_result($result, $i, 1);
		$val = addSlashes($fields[$colname]);

		if ((!empty($val)) && ($colname != "cle")) {
			if (ereg("int4", $coltype))
				$values .= ", $colname= " . intVal($val);
			else
				$values .= ", $colname= '$val'";
		}
 		
if ($this->debug) echo "$i - name : $colname, value: $val, type: $coltype <br>";
 	}

if ($this->debug) echo "UPDATE $forum SET $values WHERE cle =$key";

	$result = pg_exec($this->dblink, "UPDATE $forum SET $values WHERE cle =$key");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	return (0);
}

function updateThread($forum, $parent, $newthread) {

	$result = pg_exec ($this->dblink, "UPDATE $forum SET thread=$newthread WHERE parent=$parent");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3); 
	}

	$result = pg_exec ($this->dblink, "SELECT cle, childs FROM $forum WHERE parent=$parent");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3); 
	}

	$i=0;
	while ($row = pg_fetch_row($result, $i)) {
		$key=$row[0];
		$childs=$row[1];
		if ($childs > 0) {
			$this->updateThread ($forum, $key, $newthread);
		}
		$i++;
	}
	pg_FreeResult($result);
}

function deleteNote ($forum, $key, $passwd, $bn_dir_notes) {

	$result = pg_exec($this->dblink, "SELECT * FROM $forum WHERE cle=$key");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}
	
	$num = pg_NumRows($result);
	if ($num < 1):
		return (-4); /* no row selected */
	endif;

	$admin_password = $this->GetPassword($forum);
	$password = pg_result ($result, 0, "password");
	if (($passwd != $password) && ($passwd != $admin_password)):
		return (-2); /* invalid password */
	endif;

 	$filename = @pg_result ($result, 0, "filename");
 	$attachment = @pg_result ($result, 0, "attachment");
 	$parent = pg_result ($result, 0, "parent");
 	$childs = pg_result ($result, 0, "childs");
 	$thread = pg_result ($result, 0, "thread");

	// delete note
	$result = @pg_exec($this->dblink, "DELETE FROM $forum WHERE cle=$key");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	if ($parent > 0) {
		// decrement childs count in parent
		$result = @pg_exec($this->dblink, "UPDATE $forum SET childs=childs-1 WHERE cle=$parent");
		if (!$result) {
			echo "Postgres error: ".pg_errormessage()."<BR>";
			return (-3);
		}
	}
	else {
		// update thread value
		$result = @pg_exec($this->dblink, "SELECT cle, childs FROM $forum WHERE parent=$key");
		if (!$result) {
			echo "Postgres error: ".pg_errormessage()."<BR>";
			return (-3); 
		}
		$i=0;
		while ($row = @pg_fetch_row($result, $i)) {
			$childkey=$row[0];
			$upd = @pg_exec($this->dblink, "UPDATE $forum SET thread=$childkey WHERE cle=$childkey");
			if (!$upd) {
				echo "Postgres error: ".pg_errormessage()."<BR>";
				return (-3); 
			}
			if ($row[1] > 0) {
				$this->updateThread ($forum, $childkey, $childkey);
			}
			$i++;
		}
	}
	
	// Link children to parent
	if ($childs > 0) {
		$result = @pg_exec($this->dblink, "UPDATE $forum SET parent=$parent WHERE parent=$key");
		if (!$result) {
			echo "Postgres error: ".pg_errormessage()."<BR>";
			return (-3);
		}
	}

	// update newest in thread
	if ($key != $thread) {
		$newest = $this->getThreadNewest ($forum, $thread);
		$result = @pg_exec ($this->dblink, "UPDATE $forum SET newest=$newest WHERE thread=$thread");
		if (!$result) {
			echo "Postgres error: ".pg_errormessage()."<BR>";
			return (-3);
		}
	}

	if (!empty($filename) && ($filename != "none") && is_file("$bn_dir_notes/$filename")) {
		@unlink ("$bn_dir_notes/$filename");
	}

	if (!empty($attachment) && ($attachment != "none") && is_file ("$bn_dir_notes/$key/$attachment") ) {
		@unlink ("$bn_dir_notes/$key/$attachment");
		@rmdir ("$bn_dir_notes/$key");
	}
	return (0);
}

function mDeleteDate ($forum, $from, $to, $passwd, $bn_dir_notes) {

if ($this->debug) echo "mdeletedate ($forum, $from, $to, $passwd)";

	$admin_password	= $this->getPassword($forum);
	if ($passwd != $admin_password):
		return	(-2); /* invalid password */
	endif;
	
	$result = @pg_exec($this->dblink, "SELECT cle FROM $forum WHERE cle>=$from AND cle <= $to");
	if (!$result) return 0;
	$num = @pg_NumRows($result);
	$i=0;
	while ($i < $num):
		$note = @pg_result ($result, $i, "cle");
		$ret = $this->deleteNote($forum, $note, $passwd, $bn_dir_notes);
		if ($ret < 0):
			return ($ret);
		else:
			$i++;
		endif;
	endwhile;

	pg_FreeResult($result);
	return (0);
}


function search ($forum, $pattern, $casesensitive) {
	global $list_var;


/*
	if ($casesensitive) {
		$searcher= "HAVING";
		$expr="REGEXP '.*$pattern.*'";
		$query = "SELECT DISTINCT * FROM $forum ORDER by thread DESC, cle ASC $searcher body $expr";
	}
	else {
		$searcher= "WHERE";
		$expr="LIKE '%$pattern%'";
		// set selected columns
		$cols = "cle,parent,childs,thread,newest";
		while (list($var,$val) = each($list_var)) {
			if ($val==1) $cols.=",$var";
		}
		$query = "SELECT DISTINCT $cols FROM $forum $searcher body $expr";
	}
*/





	// Get fields defined in table
    $result = @pg_exec ($this->dblink,
     "select a.attname, t.typname from pg_class c, pg_attribute a, pg_type t where c.relname = '$forum' and a.attnum > 0 and a.attrelid = c.oid and a.atttypid = t.oid");
	if (!$result) { /* access problem */
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	// $pattern = ereg_replace ("\*", "%", $pattern);

	$searcher= "~*";
	if ($casesensitive) {
		$pattern = "%$pattern%";
		$searcher= "LIKE";
	}

	$where .= "body $searcher '$pattern'";
	// gets fields name and type

	$i=@pg_numrows($result);
	
	while ($i >= 0) {
		$colname = @pg_result($result, $i, 0);
		$coltype = @pg_result($result, $i, 1);
		$val = addSlashes($note[$colname]);
#		if (($coltype != "int4") && ($colname != "body"))
        if (($coltype =="text") && ($colname != "body"))
			$where .= " OR $colname $searcher '$pattern'";
		$i--;
	}

	$result = @pg_exec($this->dblink, "SELECT * FROM $forum WHERE $where ");
if ($this->debug) echo "SELECT * FROM $forum WHERE $where ";
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	$num = @pg_NumRows($result);
	if ($num < 1) {
		return 0;
	}

	reset ($this->entries);
	reset ($this->children);

	for ($i=0; $i<$num; $i++) {
	    $row = @pg_fetch_array($result, $i);
		$key = $row["cle"];
		$row["parent"]=0;
		$this->entries[$key] = $row;
		$this->children[0][] = $key;
	}

	return $num;
}

}; // end class

?>
