<?

/*
 *	W-AGORA 3.0
 *	-----------
 *	$Id: postgres65.php3,v 1.3 2001/01/26 17:20:54 mdruilhe Exp $
 *	Usage:		include file - Database access functions (Postgres version 6.5 and higher)
 *	Author:		Marc Druilhe <mdruilhe@w-agora.com>
 */

require ("$inc_dir/postgres.$ext");

class postgres65_access extends postgres_access {

function listThreads ($forum, $first=0, $last=0) {
	global $bn_maxthreads, $list_var;

#	1) gets total count # of notes
#	------------------------------
	$result = @pg_exec ($this->dblink, "SELECT count(*) FROM $forum WHERE cle<>0");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	$ret["total"] = @pg_result ($result, 0, "count");
	if ($ret["total"] == 0) {
	    return $ret;
	}
	pg_FreeResult($result);

#	2) Find the first (and last) thread to be displayed in the page
#	and gets number of notes per thread
#	----------------------------------------------------------------
	if (!$last) {
		$order="DESC";
		$last=1;
	} else {
		$order="ASC";
	}
	
	$where = "thread>=$last"; // $last default to 1: don't display key 0
	if ($first>0) {
		$where .= " AND thread<=$first";
	}

	$limit = (empty($bn_maxthreads)) ? "" : "LIMIT $bn_maxthreads";

	$query = "SELECT thread, count(*) FROM $forum WHERE $where GROUP BY thread ORDER BY thread $order $limit";
	$result = pg_exec ($this->dblink, "$query");		
	$tcount = pg_numrows ($result);

	if ($tcount > 0) {
		if (!empty($bn_maxthreads) && ($tcount > $bn_maxthreads) ) {
			$tcount=$bn_maxthreads;
		}
		if ($order=="DESC") {
			$tfirst  = @pg_result ($result, 0, "thread");
			$tlast = @pg_result ($result, $tcount-1, "thread");
		} else {
			$tlast  = @pg_result ($result, 0, "thread");
			$tfirst = @pg_result ($result, $tcount-1, "thread");
		}	

		for ($i=0; $i<$tcount; $i++) {
			$row = pg_fetch_row($result, $i);
			$t = $row[0];
			$replies[$t] = $row[1] - 1;
		}
	}

	pg_FreeResult($result);

	$ret["threads"]=$tcount;
	$ret["first"]=$tfirst;
	$ret["last"]=$tlast;

	if ($tcount < 1) {
		$ret["next"] = 0;
		$ret["prev"] = 0;
		return $ret;
	}

#	3) gets all threads
#	-------------------

	$where = "thread<=$tfirst AND thread>=$tlast";

	$cols = "cle,parent,childs,thread,newest";
	while (list($var,$val) = each($list_var)) {
		if ($val==1) $cols.=",$var";
	}
	
if ($this->debug) echo "SELECT $cols FROM $forum WHERE $where ORDER BY thread DESC,cle ASC<br>";
	$result = @pg_exec ($this->dblink, "SELECT $cols FROM $forum WHERE $where ORDER BY thread DESC,cle ASC");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}

	$n=0;
	while ($row = @pg_fetch_array($result, $n)) {
		$key = $row["cle"];
		$parent = $row["parent"];
		if ($parent==0) {
			$row["replies"] = $replies[$key];
		}
		$this->entries[$key] = $row;
		$this->children[$parent][] = $key;
		$n++;
	}

	pg_freeresult($result); 

#	4) gets next/previous count
#	---------------------------
	$result = @pg_exec ($this->dblink, "SELECT count(*) FROM $forum WHERE thread>$tfirst");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}
	$ret["prev"] = @pg_result ($result, 0, "count");

	pg_freeresult($result); 

	$result = @pg_exec ($this->dblink, "SELECT count(*) FROM $forum WHERE cle<> 0 AND thread<$tlast");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}
	$ret["next"] = @pg_result ($result, 0, "count");

	pg_FreeResult($result);
		
	return $ret;
}

function getNote ($forum, $key, $where="") {

	$result = pg_exec($this->dblink, "SELECT * FROM $forum WHERE cle=$key");
	if (!$result) {
		echo "Postgres error: ".pg_errormessage()."<BR>";
		return (-3);
	}
	$num = pg_NumRows($result);
	if ($num < 1) return (-4);

	$note = @pg_fetch_array($result, 0);
    $cnt = count($note);
	for ($i=0; $i<=$cnt; $i++) {
		$note[$i]=stripslashes($note[$i]);
	}
	pg_FreeResult($result);

# get key of previous thread
# --------------------------
	$whereclause = "newest > " . $note["newest"];
	if (!empty($where)) {
		$whereClause .= " AND $where";
	}
	$result = @pg_exec ($this->dblink, "SELECT thread FROM $forum WHERE $whereclause ORDER BY newest LIMIT 1");
	if ($result) {
		if ($prev = @pg_fetch_row($result, 0)) {
			$note["tprev"]= $prev[0];
		}		
		pg_FreeResult($result);
	}

# get key of next thread
# --------------------------
	$whereclause = "newest < " . $note["newest"];
	if (!empty($where)) {
		$whereClause .= " AND $where";
	}
	$result = @pg_exec ($this->dblink, "SELECT thread FROM $forum WHERE $whereclause ORDER BY newest DESC LIMIT 1");
	if ($result) {
		if ($next = @pg_fetch_row($result, 0)) {
			$note["tnext"]= $next[0];
		}
		pg_FreeResult($result);
	}
	return ($note);
}

}; // end class

?>
