<?php

/* 
 *	W-AGORA 3.0
 *	-----------
 *	$Id: init.inc,v 1.4 2001/01/12 11:57:52 mdruilhe Exp $
 *	Usage:		Initialization file 
 *	Author:		Marc Druilhe <mdruilhe@w-agora.com>
 *
 */

# initialize some values
# ----------------------
	$winbox      = (ereg ('\\\\', $PATH_TRANSLATED));
	$bn_action	 = isSet($bn_action)? $bn_action : "";
	$lynx		 = isset($lynx) ? $lynx : 0;
	$bn_base_url = sprintf ("http://%s%s%s", $SERVER_NAME,
				($SERVER_PORT==80) ? "" : ":$SERVER_PORT",
				dirname($PHP_SELF) );

# set extension for PHP scripts, main entry point and SELF_PAGE
# -------------------------------------------------------------
	$ext		= isSet($ext) ? $ext : "php3";
	$main_page	= isSet($main_page) ? $main_page : "./index.$ext";
	$WA_SELF	= basename($PHP_SELF);

# Set general directives for PHP engine behaviour
# -----------------------------------------------
	error_reporting(7);
	php_track_vars;

# set modes for creating directories and files
# --------------------------------------------
	define("_DIRMODE", 0777);
	umask (0);

# initialize variables for 4.0 compatibility
# ------------------------------------------
	$is_authenticated=false;
	$bn_send_user_address=1;
	$bn_tz_offset=0;

# initialize w-agora directories
# ------------------------------
	$bin_dir = ".";
	$inc_dir = "./include";
	$cfg_dir = "./conf";
	$tmpl_dir = "./templates";
	$bn_dir_default = "$tmpl_dir/default";
	
# include general purpose functions
# ---------------------------------
	require "$inc_dir/misc_func.$ext";

# --------------------------------------
# Initialize configuration file and site
# --------------------------------------
	if (empty($bn)) {
# No forum selected -> default to 'site' configuration
		if (empty($site)) {
			Header("Location: $main_page");
			exit;
		} else {
			$cfg_file = "${cfg_dir}/site_${site}.${ext}";
			$expnd = "all";
		}
	} else {
		$bn=basename($bn);
		$cfg_file = "${cfg_dir}/${bn}.${ext}";
	}

# read configuration for this forum
# ---------------------------------
	require "$cfg_file";

# set the current date & formatted date 
# -------------------------------------
	$now = time();
	$formated_date = date ("$bn_date_format", "$now");

	if ($lynx==1) {
		$bn_frames = 0;
		$bn_popup = 0;
	}

# ------------------------------------------
# Include forum specific configuration files
# ------------------------------------------

# messages
# --------
	if (empty($bn_msgs) ) {
		include ("$bn_dir_default/msgs.$ext");
	} else {
		include "$bn_dir/$bn_msgs";
	}

# fields definition
# -----------------
	if (empty($bn_fields) ) {
		include ("$bn_dir_default/fields.$ext");
	} else {
		include "$bn_dir/$bn_fields";
	}

# listing outline
# ---------------
	if (empty($bn_list_vars) ) {
		include ("$bn_dir_default/list.$ext");
	} else {
		include "$bn_dir/$bn_list_vars";
	}

# Note template
# -------------
	if (!empty($bn_template) ) {
		include "$bn_dir/$bn_template";
	} elseif (file_exists ("$bn_dir_default/template.$ext")) {
		include ("$bn_dir_default/template.$ext");
	}

# Include Database access then connect
# ------------------------------------
	require ("$inc_dir/$bn_access.$ext");
	$db_class = "${bn_access}_access";
	$db = new $db_class;
	$ret = $db->openDB();
	if ($ret < 0) {
		msgForm (msg(6), "$main_page", "");
		exit;
	}

# initialize and send cookies if cookies option is set
# ----------------------------------------------------
	if (($bn_cookies==1) && !isset($no_cookie)) {
		include ("$inc_dir/cookies.$ext");
	}

# force browser, proxies to refresh the page if required
# ------------------------------------------------------
	if (isset($force_refresh)) {
		// send headers to force expiration
		header("Expires: Mon, 2 Aug 1999 05:00:00 GMT"); // Date in the past
		header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
		header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
		header("Pragma: no-cache"); // HTTP/1.0
	}

# display the header and include the header file if required
# ----------------------------------------------------------
function display_header ($title="", $include_header) {
	global $site, $bn, $bn_dir, $bn_dir_default, $bn_header, $bn_body, $frameset;
	global $bn_title, $bn_style, $bn_frames, $bn_popup, $lynx;
	global $bn_search, $ext, $main_page;

	if (!isset($frameset)) {

		echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n";
		printf ("<HTML><HEAD><TITLE>%s - %s</TITLE>\n", $bn_title, $title);
		printf ("<META NAME=\"GENERATOR\" Content=\"%s\">\n", wa_version() );

		if ($bn_popup == 1):
?>
<SCRIPT type="text/javascript" language="JavaScript">
<!-- // Hide for old browsers
  var newWindow = null;
 function OpenWindow (Url,Title, Width, Height) {
  var win_opt= "toolbar=0,location=0,directories=0,status=0,menubar=0,";
  win_opt += "scrollbars=1,resizable=1,copyhistory=0,";
  win_opt += "width=" + Width + ",height=" + Height;
  newWindow = window.open('',Title,win_opt);
  if (newWindow != null) {
    if (newWindow.opener == null)
      newWindow.opener = self;
    newWindow.location.href = Url;
    if (newWindow.focus) newWindow.focus();
  }
 }
 // End of script -->
</SCRIPT>
<?
		endif;

		if (!empty($bn_style) && file_exists ("$bn_dir/$bn_style")) {
			echo "<!-- STYLE -->\n";
			include "$bn_dir/$bn_style";
		} elseif (file_exists ("$bn_dir_default/style.$ext")) {
			echo "<!-- STYLE -->\n";
			include ("$bn_dir_default/style.$ext");
		}
	
		printf ("</HEAD>\n<BODY %s>\n", $bn_body);
	}
	
	if ($include_header) {
		echo "<!-- HEADER -->\n";
		if (!empty($bn_header) && file_exists ("$bn_dir/$bn_header") ) {
			include "$bn_dir/$bn_header";
		} elseif (file_exists ("$bn_dir_default/header.$ext")) {
			include ("$bn_dir_default/header.$ext");
		}
	}
}

function display_footer($include_footer) {
	global $site, $bn, $bn_dir, $bn_dir_default, $bn_footer, $bn_body, $frameset;
	global $bn_title, $bn_style, $bn_frames, $bn_popup, $lynx;
	global $bn_search, $ext, $main_page;
	
	if ($include_footer) {
		echo "<!-- FOOTER -->\n";
		if (!empty($bn_footer) && file_exists("$bn_dir/$bn_footer") ) {
			include "$bn_dir/$bn_footer";
		} elseif (file_exists ("$bn_dir_default/footer.$ext")) {
			include ("$bn_dir_default/footer.$ext");
		}
	}

	if (!isset($frameset)) {
		echo "</BODY>\n</HTML>\n";
		exit;
	}
}
?>
