<?php

/* 
 *	W-AGORA 3.0
 *	-----------
 *	$Id: insert.php3,v 1.3 2001/01/15 12:28:54 mdruilhe Exp $
 *	Usage:		Insert a note in the database
 *	Author:		Marc Druilhe <mdruilhe@w-agora.com>
 *
 */

# If not coming from post form then exit
# --------------------------------------
	if (!$do_post) {
		exit;
	}

# initialization stuff
# --------------------
	$bn_action="insert";
	$bn_action_mode="W";
	require ("./init.inc");

	$header_footer = ( ($bn_popup==0) && ($bn_frames==0) ) ? true : false;

# Set the script name to return to in case of error
# --------------------------------------------------
	$back_form = (isset($back_form)) ? "$back_form" : "post";
	$back = "$back_form.$ext";
	if (!empty($key) ) {
		$back.= "?key=$key";
	}

# Check that the user email address is valid if set
# --------------------------------------------------
	$useraddress=ereg_replace (" ", "", $useraddress);
	if (!empty($useraddress) ) {
		if (validate_email ($useraddress)) {
			$valid_address = 1;
			if ($bn_send_user_address==1) {
				$mailfrom = (empty($username)) ? $useraddress : '"' . stripSlashes($username)."\" <$useraddress>";
			} else {
				$mailfrom = $bn_mail_from;
			}
		} else {
			display_header ("insert note", $header_footer);
			msgForm (msg(47), "$back", "back", "", "post");
			display_footer ($header_footer);
		}
	} else {
		$valid_address = 0;
	}
	
	if ($mail_reply) {
		if (!$valid_address) {
			display_header ("insert note", $header_footer);
			msgForm (msg(47), "$back", "back", "", "post");
			display_footer ($header_footer);
		}
	} else {
		$mail_reply = 0;
	}

# Check that all required fields are set
# ---------------------------------------
	while (list($field, $required) = each($bn_bind_var)) {
		if ($required && ($$field=="") ) {
			display_header ("insert note", $header_footer);
			$mess = "$field : " . msg(5);
			msgForm ("$mess", "$back", "back", "", "post");
			display_footer ($header_footer);
		}
	}

# save body (for email it later without formatting) 
# -------------------------------------------------
	if (!empty($body)) {
		$mailbody = stripslashes($body);
	}
	
# set the subject which will be sent in the mail
# ----------------------------------------------
	if (isset($subject)) {
		if (eregi ("^re: *(.*)", $subject, $split) ) {
			$mailsubject = "Re: [$bn] " . $split[1];
		} else {
			$mailsubject = "[$bn] $subject";
		}
		$mailsubject = stripSlashes($mailsubject);
	} else {
		$mailsubject = "[$bn] NO SUBJECT";
	}

# populate note array with all global variables as defined in bn_var
# ------------------------------------------------------------------
	/* variables handled by w-agora */
	for (reset ($bn_var); $field=current($bn_var); next($bn_var)) {
		$$field=kill_html(chop(stripSlashes($$field)));
		$fields[$field]=$$field;
	}

	/* user's defined variables */
	for (reset ($db_var); $field=current($db_var); next($db_var)) {
		$$field=ereg_replace ("\\\\", "\\\\", chop(stripSlashes($$field)));
		if ($bn_allow_html && $bn_html_var[$field] && $html_tags) {
			$$field = strip_banned_tags($$field);
		} else {
			$$field = kill_html($$field);
		}
		if ($bn_auto_url && $bn_html_var[$field]) {
			$$field = checkURL ($$field);
		}
		if ($bn_use_smileys && $bn_html_var[$field]) {
			$$field = add_smileys($$field);
		}
		$fields[$field]=$$field;
	}

	$unixdate = $now;	

# Handle attachment either uploaded from the browser or choosen on the server
# ---------------------------------------------------------------------------
	if (isSet($preview)) {
		$attachment = "none";
		$att_size = 0;
		$att_type = "unknown";
		if ($pcfile_size > 0) {
			@unlink ($pcfile);
		}

	} elseif ($pcfile_size > 0) {
		if ($bn_file_upload && ($pcfile_size <= $MAX_FILE_SIZE) ) {
			$pcfile = ereg_replace ("\\\\\\\\", "/", $pcfile);
			$att_size = filesize ($pcfile);
			if ($att_size == $pcfile_size) {
				$attachment = ereg_replace (" ", "_", $pcfile_name);
				$att_type = (empty($pcfile_type)) ? "application/octet-stream" : $pcfile_type;
				mkdir ("$bn_dir_notes/$now", _DIRMODE);
				copy ($pcfile, "$bn_dir_notes/$now/$attachment");
				dspMsg(37, "<center><b>file $pcfile_name uploaded ($pcfile_size bytes transfered)</b></center>");
			} else {
				$attachment = "none";
				$att_size = 0;
				$att_type = "unknown";
			}
		} else {
			msgForm ("Please, stop trying hacking this system!", $back, $back, "", "post");
		}
		@unlink ($pcfile);

	} elseif ($bn_browse_server && !empty($server_file) ) {
		$file=eregi_replace ("^.:", "", $server_file);
		if (!ereg ("$bn_browse_dir", "$file")) {
			msgForm (msg (48), "$back", "back", "", "post");
			display_footer ($header_footer);
		}
		$att_size = filesize ($file);
		if ($att_size <= 0) {
			msgForm (msg (8), "$back", "back", "", "post");
			display_footer ($header_footer);
		}
		$attachment = basename($server_file);
		mkdir ("$bn_dir_notes/$now", _DIRMODE);
		if (copy ("$server_file", "$bn_dir_notes/$now/$attachment")) {
			include "$inc_dir/mimetypes.$ext";
			$suffix = strtoLower(substr(strrchr( $attachment, "." ), 1 ));
			$att_type = (empty($mimetype[$suffix])) ? "application/octet-stream" : $mimetype[$suffix];
			dspmsg(38, "<center><b>file $attachment has been copied </b></center>");
		} else {
			$attachment ="none";
			$att_size = 0;
			$att_type = "unknown";
		}

	} else {
		$attachment = "none";
		$att_size = 0;
		$att_type = "unknown";
	}

# set $filename before calling before_access & building note[]
# (in a next version $filename should be equal to the key value returned by insert() )
	$filename = ($bn_doc_type == "static") ? "$now.html" : "none";

# Execute before_access program
# -----------------------------
	if (!empty($bn_before_access) ) {
		include "$bn_dir/$bn_before_access";
	}

# (3.x) Force password to the forum password 
# ------------------------------------------
	if (empty($password) && !isSet ($preview) ) {
		$password = $db->GetPassword($bn_db);
	}

# reload note fields array with possibly modified values (from before_access)
# ---------------------------------------------------------------------------
	for (reset ($fields); $field=key($fields); next($fields)) {
		$fields[$field]=$$field;
	}

# If preview mode then display the note ... 
# ------------------------------------------
	if (isSet ($preview)) {
		display_header ("insert note", $header_footer);
		$formated_date = date ($bn_date_format, $unixdate+($bn_tz_offset*3600));
		if (isSet($body)) {
			$body = format_text($body);
		}
		$bn_doc_var=addSlashes(stripSlashes($bn_doc_var));
		eval ("echo stripSlashes(\"$bn_doc_var\");");

#		... then display the form
#		-------------------------
		hr();
		reset ($fields);
		while ( list( $var, $val ) = each( $fields)) {
			if (is_string ($var)) {
				$$var = stripSlashes(my_br2nl($val));
				if ($bn_use_smileys && $bn_html_var[$var]) {
					$$var = strip_smileys($$var);
				}
				if ($bn_auto_url && $bn_html_var[$var]) {
					$$var = strip_url($$var);
				}
				$$var = kill_quotes($$var);
			}
		}
		$quoted_text = kill_quotes($quoted_text);
		$setUserField = false;		// don't reset username and password
		$form_action = "./insert.$ext";
		$bn_action = (empty($key)) ? "post" : "reply";
		if (!isset($html_tags)) $html_tags=0;
		include "$inc_dir/form.$ext";
		display_footer ($header_footer);
	}
	
# ... Else: Insert into database
# ------------------------------

	if (empty($key) ) {
 		$newkey = $db->insertNote ($bn_db, $now, &$fields);
	} else {
		$newkey = $db->threadNote ($bn_db, $now, $key, &$fields);
	}

	display_header ("insert note", $header_footer);

	if ($newkey < 0) {
		msgForm (msg(9), "$back", "back", "", "post");
		display_footer ($header_footer);
	} else {
		$thread = $fields["thread"];
	}

# write note to the HTML document
# -------------------------------
	if ($filename != "none") {
		$fd = @fopen ("$bn_dir_notes/$filename", "w+");
		if (!$fd) {
			$file="$bn_dir_notes/$filename";
			msgForm (msg(7, "could not open file '$file'"), "$back", "back", "", "post");
			/* we could remove note, but it still can be built from the	database */
			display_footer ($header_footer);
		}

		if (isSet($body)) {
			$body = format_text($body);
		}
		$doc=addSlashes(stripSlashes($bn_doc_var));
		eval ("\$tmp=stripSlashes(\"$doc\");");
		fputs ($fd, "$tmp");
		fclose ($fd);
	}
	
# start search indexation
# -----------------------
	if ($bn_search && ($bn_doc_type == "static") && ($bn_search_engine != "none") ) {
		include "$inc_dir/$bn_search_engine.$ext";
		$search->indexNotes();
	}

# Send email to initiator and original poster (user mail option)
# --------------------------------------------------------------
	$reply_address = "";
	$initiator_address = "";
	if ( $bn_user_mail && !empty($key) ) {
		$parent_note = $db->getNote ($bn_db, $key);
		if (is_array ($parent_note) ) {
			// send mail to original sender
			// ----------------------------
			$reply_address = $parent_note["useraddress"];
			$send_user_reply = $parent_note["mail_reply"];
			if ($send_user_reply && ($reply_address != "")) {
				$rc = @mail ($reply_address, $mailsubject, $mailbody,
				      "From: $mailfrom\nX-Mailer: PHP " . phpversion() . " " . wa_version() . "\n");	
			}

			// send mail to thread initiator
			// -----------------------------
			if (isset ($parent_note["thread"]) ) {
				$note = $db->getNote ($bn_db, $parent_note["thread"]);
				if (is_array ($note) ) {
					$initiator_address = $note["useraddress"];
					$initiator_reply = $note["mail_reply"];
				} 
				if ($initiator_reply && ($initiator_address != "") && ($reply_address != $initiator_address) ) {
					$rc= @mail ($initiator_address, $mailsubject, $mailbody,
		      		      "From: $mailfrom\nX-Mailer: PHP " . phpversion() . " " . wa_version() . "\n");
				}
			}
		}
	}

# send mail to administrator
# --------------------------
	if ($bn_mail && ($reply_address != $bn_admin_address) && ($initiator_address != $bn_admin_address) ) {
		$body = "Note $newkey created\n" . $bn_mail_text . "\n-------------------------\n" . $mailbody;
		$rc = @mail ($bn_admin_address, $mailsubject, $body, "From: $mailfrom\nX-Mailer: PHP " . phpversion() . " " . wa_version() . "\n" );
	}

	msgForm (Msg(39), "view.$ext?bn=$bn&key=$newkey", "close");
	display_footer ($header_footer);
?>
