<?php

/* 
 *	W-AGORA 3.0
 *	-----------
 *	$Id: setup.php3,v 1.5 2001/01/26 17:45:28 mdruilhe Exp $
 *	Usage:		Installation program
 *	Author:		Marc Druilhe <mdruilhe@w-agora.com>
 */
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD><TITLE>Setup w-Agora</TITLE></HEAD>
<BODY TEXT="black" BGCOLOR="WHITE">

<P ALIGN="CENTER">
<A HREF="http://www.w-agora.net/"><IMG SRC="images/logo1.jpg" ALIGN="BOTTOM" BORDER="0"></A>
<H2 ALIGN="CENTER">Setup</H2>
</P>
<?

$ext = "php3";
$WA_SELF=basename($PHP_SELF);

# Set general directives for PHP engine behaviour
# -----------------------------------------------
error_reporting(7);
php_track_vars;

# set modes for creating directories and files
# --------------------------------------------
define("_DIRMODE", 0777);
umask (0);

# initialize w-agora directories
# ------------------------------
$bin_dir=".";
$inc_dir="./include";
$cfg_dir="./conf";
$tmpl_dir="./templates";

if (empty ($bn_dir_forums)) {
	$bn_dir_forums = "./forums";
}

$lynx=0;

require "$inc_dir/misc_func.$ext";
require "$inc_dir/config.$ext";

if (isSet($do_setup)) {
	if (empty($site)) {
		MsgForm ("You must give the site name", "$WA_SELF", "back");
		echo "</BODY>\n</HTML>";
		exit;
	} elseif (empty($bn_owner)) {
		MsgForm ("You must give your name", "$WA_SELF", "back");
		echo "</BODY>\n</HTML>";
		exit;
	} elseif (empty($bn_admin_address)) {
		MsgForm ("You must give your mail address", "$WA_SELF", "back");
		echo "</BODY>\n</HTML>";
		exit;
	} elseif (empty($bn_access)){
		MsgForm ("You must specify an access mode", "$WA_SELF", "back");
		echo "</BODY>\n</HTML>";
		exit;
	} elseif (empty ($passwd1) || ($passwd1 != $passwd2)) {
		MsgForm ("password must be set and must be entered twice, please verify", "$WA_SELF", "back");
		echo "</BODY>\n</HTML>";
		exit;
	} elseif (empty($dbname)){
		MsgForm ("You must give a database name", "$WA_SELF", "back");
		echo "</BODY>\n</HTML>";
		exit;
	}

	$maxsitelen = 10;
	
	$site = ereg_replace ("[^[:alnum:]]+", "", stripSlashes(strtolower($site)));

	// Check max size
	if (strlen ($site) > $maxsitelen) {
		MsgForm ("site name is is limited to $maxsitelen characters, please choose a shorter one", "$WA_SELF", "back");
		exit;
	}

	$site_cfgfile = "${cfg_dir}/site_${site}.${ext}";
	$admin_cfgfile = "${cfg_dir}/admin_${site}.${ext}";

	/* Check if w-agora was already setup for this site */
	if (file_exists ("$site_cfgfile")) {
		MsgForm ("Configuration file (<tt>$site_cfgfile</tt>) already exists, you must either delete it manually or choose another site's name", "$WA_SELF", "back");
		echo "</BODY>\n</HTML>";
		exit;
	}
	
	if (file_exists ("$admin_cfgfile")) {
		MsgForm ("Configuration file (<tt>$admin_cfgfile</tt>) already exists, you must either delete it manually or choose another site's name", "$WA_SELF", "back");
		echo "</BODY>\n</HTML>";
		exit;
	}

	/* Create site configuration's directory */
	if (!empty($cfg_dir) && !is_dir ("$cfg_dir")) {
		$ret = mkDir ("$cfg_dir", _DIRMODE);
		if (!$ret) {
			MsgForm ("could not create directory: $cfg_dir", "$WA_SELF", "back");
			exit;
		}
	}

	/* Create forum's directory */
	if (!empty($bn_dir_forums) && !is_dir ("$bn_dir_forums")) {
		$ret = mkDir ("$bn_dir_forums", _DIRMODE);
		if (!$ret) {
			MsgForm ("could not create directory: $bn_dir_forums", "$WA_SELF", "back");
			exit;
		}
	}
		
	if (!is_dir ("$bn_dir_forums/$site")) {
		$ret = mkDir ("$bn_dir_forums/$site", _DIRMODE);
		if (!$ret) {
			MsgForm ("could not create directory: $bn_dir_forums/$site", "$WA_SELF", "back");
			exit;
		}
	}

	// Create admin Configuration File
	// -------------------------------
	$bn_dir="$bn_dir_forums/$site";
	$bn_dir_notes="$bn_dir_forums/$site";
	$bn_db=$site;

	$bn_search=0;
	switch ($bn_search_engine) {
	  case "swish":
		$bn_search_path="/usr/local/bin/swish";
	  break;
	  case "namazu":
		$bn_search_path="include/bn_namazu";
	  break;
	  default:
		$bn_search_path="";
	  break;
	}

	include ("$tmpl_dir/admin/admin.conf");
	
	$adm_conf = new Config;
	$ret=$adm_conf->open("$admin_cfgfile");
	if (!$ret) {
		MsgForm ("Cannot create configuration file ($admin_cfgfile), check permissions", "$WA_SELF", "back"); /* access problem */
		echo "</BODY>\n</HTML>";
		exit;
	}
	$adm_conf->writeConfig(&$GLOBALS);
	$adm_conf->close ();

	// Create w-agora Configuration File
	// ---------------------------------
	include ("$tmpl_dir/admin/w-agora.conf");
	$bn_title = $title;
	$conf = new Config;
	$ret=$conf->open("$site_cfgfile");
	if (!$ret) {
		MsgForm ("Cannot create configuration file ($site_cfgfile), check permissions", "$WA_SELF", "back"); /* access problem */
		unlink ("$admin_cfgfile");
		echo "</BODY>\n</HTML>";
		exit;
	}
	$conf->writeConfig(&$GLOBALS);
	$conf->close ();

	// Copy all customization files
	// ---------------------------

	$file="header";
	$ret = Copy ("$tmpl_dir/admin/$file.php3", "$bn_dir_forums/$site/$file.$ext");
	if (!$ret) {
		unlink ("$site_cfgfile");
		unlink ("$admin_cfgfile");
		/* Unable to copy files */
		MsgForm (Msg(7), "$WA_SELF", "back");
		exit;
	}

	$file="header_admin";
	$ret = Copy ("$tmpl_dir/admin/$file.php3", "$bn_dir_forums/$site/$file.$ext");
	if (!$ret) {
		unlink ("$site_cfgfile");
		unlink ("$admin_cfgfile");
		/* Unable to copy files */
		MsgForm (Msg(7), "$WA_SELF", "back");
		exit;
	}
	
	$file="list";
	$ret = Copy ("$tmpl_dir/admin/$file.php3", "$bn_dir_forums/$site/$file.$ext");
	if (!$ret) {
		unlink ("$site_cfgfile");
		unlink ("$admin_cfgfile");
		/* Unable to copy files */
		MsgForm (Msg(7), "$WA_SELF", "back");
		exit;
	}
	
	$file="list_admin";
	$ret = Copy ("$tmpl_dir/admin/$file.php3", "$bn_dir_forums/$site/$file.$ext");
	if (!$ret) {
		unlink ("$site_cfgfile");
		unlink ("$admin_cfgfile");
		/* Unable to copy files */
		MsgForm (Msg(7), "$WA_SELF", "back");
		exit;
	}
	
	$file="msgs";
	$ret = Copy ("$tmpl_dir/admin/$file.php3", "$bn_dir_forums/$site/$file.$ext");
	if (!$ret) {
		unlink ("$site_cfgfile");
		unlink ("$admin_cfgfile");
		/* Unable to copy files */
		MsgForm (Msg(7), "$WA_SELF", "back");
		exit;
	}
	
	$file="fields";
	$ret = Copy ("$tmpl_dir/admin/$file.php3", "$bn_dir_forums/$site/$file.$ext");
	if (!$ret) {
		unlink ("$site_cfgfile");
		unlink ("$admin_cfgfile");
		/* Unable to copy files */
		MsgForm (Msg(7), "$WA_SELF", "back");
		exit;
	}
	
	$file="template";
	$ret = Copy ("$tmpl_dir/admin/$file.php3", "$bn_dir_forums/$site/$file.$ext");
	if (!$ret) {
		unlink ("$site_cfgfile");
		unlink ("$admin_cfgfile");
		/* Unable to copy files */
		MsgForm (Msg(7), "$WA_SELF", "back");
		exit;
	}
	
	// Create table / DBM file
	// -----------------------
	include "$inc_dir/$bn_access.$ext";
	include "$bn_dir/$bn_fields";
	include "$bn_dir/$bn_list_vars";
	$db_class = "${bn_access}_access";
	$db = new $db_class;
	$ret = $db->openDB();
	if ($ret == 0) {
		if ($bn_access =="dbm") {
			$rc = @mkdir ("./dbm", _DIRMODE);
			$rc = @mkdir ("./dbm/$site", _DIRMODE);
		}
		$ret = $db->CreateForum ("$site", "$passwd1");
	}
	
	if ($ret == -1) {
		if ($bn_access == "dbm")
			MsgForm ("Forum's database ($site) already exists,<br> you must delete the DBM file: <em>$bn_dir/$bn_db</em><br> [and the lockfile .lck] manually", "$WA_SELF", "back");
		else
			MsgForm ("The forum's table ($site) already exists in this database ($dbname), you must first drop this table manually", "$WA_SELF", "back");
		unlink ("$site_cfgfile");
		unlink ("$admin_cfgfile");
	}
	elseif ($ret == -3) {
		if ($bn_access == "dbm") {
			MsgForm ("Access problem, check space and permissions in the file system", "$WA_SELF", "back");
		}
		else
			MsgForm ("Access problem, make sure you have created a database named '$dbname' and check access rights", "$WA_SELF", "back");
		unlink ("$site_cfgfile");
		unlink ("$admin_cfgfile");
	}
	else {
		
		MsgForm ("W-agora has been successfully installed", "./create_forum.$ext?site=$site&login=1&formpasswd=$passwd1", "", "", "post");
	}
	echo "</BODY>\n</HTML>";
	exit;
} // End do_setup

	/* Initialiaze defaults then display form */
	if (!isset($site)) {
		$site=strtok($SERVER_NAME,".");
		if ($site=="www") $site=strtok(".");
	}
	if (!isset($dbname))	$dbname=$site;
	if (!isset($dbhost))	$dbhost="";
	if (!isset($dbport))	$dbport="";
	if (!isset($dbuser))	$dbuser="";
	if (!isset($bn_search_engine)) $bn_search_engine="none";
	if (!isset ($bn_owner))	$bn_owner = "Admin";
	if (!isset ($bn_admin_address)) {
		$bn_admin_address = isset($SERVER_ADMIN) ? $SERVER_ADMIN : "";
	}
?>

<FORM ACTION="<?echo $WA_SELF?>" METHOD="POST" ENCTYPE="application/x-www-form-urlencoded">
 <INPUT TYPE="HIDDEN" NAME="do_setup" SIZE="-1" VALUE="1">
 <P>
<em>(*) = required fields </em>

 <TABLE BORDER="0" CELLPADDING="2" WIDTH="100%">
  <TR>
   <TD ALIGN="RIGHT"><B>Enter Site (user | group | domain) for which to setup w-agora (*) :</B></TD>
   <TD><INPUT TYPE="TEXT" NAME="site" SIZE="20" VALUE="<?echo $site; ?>"></TD>
  </TR>
  <TR>
   <TD ALIGN="RIGHT"><B>site description :</B></TD>
   <TD><INPUT TYPE="TEXT" NAME="title" SIZE="20" VALUE="<?echo $title; ?>"></TD>
  </TR>
 </TABLE>
<P>
 <TABLE BORDER="2" WIDTH="100%" BGCOLOR="#00CCCC">
 <TR><TD>
 <TABLE BORDER="0" WIDTH="95%">
  <CAPTION><B>Database parameters (for forum's table)</B></CAPTION>
  <TR>
   <TD ALIGN="RIGHT" VALIGN="MIDDLE"><strong>access type for the main database (*)</strong> :</TD>
   <TD>
    <SELECT NAME="bn_access">
     <OPTION VALUE="dbm" SELECTED>DBM</OPTION>
     <OPTION VALUE="mysql">mySQL</OPTION>
     <OPTION VALUE="msql1">mSQL version 1</OPTION>
     <OPTION VALUE="msql2">mSQL version 2</OPTION>
     <OPTION VALUE="oci8">Oracle 8 (OCI)</OPTION>
     <OPTION VALUE="postgres">PostgreSQL version 6.4 or older</OPTION>
     <OPTION VALUE="postgres65">PostgreSQL version 6.5 or higher</OPTION>
     <OPTION VALUE="mssql7">MS SQL7 (beta)</OPTION>
    </SELECT>
   </TD>
   <TD WIDTH="120" ALIGN="RIGHT"><strong>Database name</strong><br><font size="1">(not needed for Oracle)</font></TD>
   <TD><INPUT TYPE="TEXT" NAME="dbname" SIZE="20" VALUE="<?echo $dbname?>"></TD>
  </TR>
  <TR>
   <TD ALIGN="RIGHT" VALIGN="MIDDLE">DB User</TD>
   <TD><INPUT TYPE="TEXT" NAME="dbuser" VALUE="<?echo $dbuser?>" SIZE="20"></TD>
   <TD WIDTH="120" ALIGN="RIGHT">DB Password</TD>
   <TD><INPUT TYPE="password" NAME="dbpassword" SIZE="20"></TD>
  </TR>
  <TR>
   <TD ALIGN="RIGHT" VALIGN="MIDDLE">Server name <br><font size="1">(TNS name for Oracle)</font>: </TD>
   <TD><INPUT TYPE="TEXT" NAME="dbhost" VALUE="<?echo $dbhost?>" SIZE="20"></TD>
   <TD WIDTH="120" ALIGN="RIGHT">Server port <BR><font size="1">(Not used for Oracle, msql AND DBM)</font>: </TD>
   <TD><INPUT TYPE="TEXT" NAME="dbport" VALUE="<?echo $dbport?>" SIZE="20"></TD>
  </TR>
 </TABLE>
 </TR></TD></TABLE>
 <P>
 <TABLE BORDER="0" CELLPADDING="2" WIDTH="100%">
  <TR>
   <TD WIDTH="50%" ALIGN="RIGHT"><B>Directory where to install forums :</B></TD>
   <TD><INPUT TYPE="TEXT" NAME="bn_dir_forums" SIZE="30" VALUE="<?echo $bn_dir_forums?>"></TD>
  </TR>
  <TR>
   <TD WIDTH="50%" ALIGN="RIGHT"><B>Default Search Engine :</B></TD>
   <TD><SELECT NAME="bn_search_engine">
        <OPTION VALUE="none" <?if ($bn_search_engine=="none"){?>selected<?}?>> None
        <OPTION VALUE="swish" <?if ($bn_search_engine=="swish"){?>selected<?}?>> Swish
        <OPTION VALUE="namazu" <?if ($bn_search_engine=="namazu"){?>selected<?}?>> Namazu
       </SELECT>
   </TD>
  </TR>
 </TABLE>
 <P>
 <TABLE BORDER="0" CELLPADDING="2" WIDTH="100%">
  <CAPTION><B>Administrator's Informations</B></CAPTION>
  <TR>
   <TD WIDTH="50%" ALIGN="RIGHT"><strong>Your name (*)</strong> :</TD>
   <TD WIDTH="50%"><INPUT TYPE="TEXT" NAME="bn_owner" SIZE="30" VALUE="<?echo $bn_owner?>"></TD>
  </TR>
  <TR>
   <TD WIDTH="50%" ALIGN="RIGHT"><strong>your Mail address (*)</strong>:</TD>
   <TD WIDTH="50%"><INPUT TYPE="TEXT" NAME="bn_admin_address" VALUE="<?echo $bn_admin_address ?>" SIZE="30"></TD>
  </TR>
  <TR>
   <TD WIDTH="50%" ALIGN="RIGHT"><strong>Give a password (for admin access) (*)</strong> :</TD>
   <TD><INPUT TYPE="PASSWORD" NAME="passwd1" SIZE="30"></TD>
  </TR>
  <TR>
   <TD WIDTH="50%" ALIGN="RIGHT"><strong>Please, reenter the password (*) </strong>:</TD>
   <TD><INPUT TYPE="PASSWORD" NAME="passwd2" SIZE="30"></TD>
  </TR>
 </TABLE>
 <CENTER><INPUT TYPE="SUBMIT" VALUE="Install"></CENTER>
</FORM>
</BODY>
</HTML>
