<?php

/* 
 *	W-AGORA 3.0
 *	-----------
 *	$Id: update.php3,v 1.3 2001/01/15 12:28:54 mdruilhe Exp $
 *	Usage:		Update a note in the forum
 *	Author:		Marc Druilhe <mdruilhe@w-agora.com>
 *
 */
	
# If not coming from post form then exit
# --------------------------------------
	if (!$do_post) {
		exit;
	}

# initialization stuff
# --------------------
	$bn_action="update";
	$bn_action_mode="W";
	require ("./init.inc");

	$header_footer = ( ($bn_popup==0) && ($bn_frames==0) ) ? true : false;

# Set the page to return to (in case of error)
# --------------------------------------------
	$back_form = (isset($back_form)) ? "$back_form" : "edit";
	$back = $back_form . ".$ext?key=$key";

# if note to update is not defined then return to the list
# --------------------------------------------------------
	if (!$key) {
		display_header ("Update note", $header_footer);
		msgForm (msg(3), "list.$ext", "close");
		display_footer ($header_footer);
	}

# Check that the "allow modify" option is set on this forum
# -------------------------------------------------------------------
	if (!$bn_modify) {
		display_header ("Update note", $header_footer);
		msgForm (msg(48), "list.$ext", "close");
		display_footer ($header_footer);
	}

# read note in order to insure that this note exists
# --------------------------------------------------
	$old_note = $db->getNote ($bn_db, $key);
	if (!is_array($old_note) ) {
		display_header ("Update note", $header_footer);
		msgForm (msg(10), "list.$ext", "close");
		display_footer ($header_footer);
	}

# validate user mail address if mail reply has been checked
# ---------------------------------------------------------
	$mail_reply = (empty($mail_reply) ) ? 0 : 1;

	$useraddress=ereg_replace (" ", "", $useraddress);
	if ($useraddress) {
		if (validate_email ($useraddress)) {
			$valid_address = 1;
			$mailfrom = (empty($username)) ? $useraddress : '"' . stripSlashes($username)."\" <$useraddress>";
		} else {
			display_header ("Update note", $header_footer);
			msgForm (msg(47), "$back", "back");
			display_footer ($header_footer);
		}
	} else {
		$valid_address = 0;
	}

	if ($mail_reply) {
		if (!$valid_address) {
			display_header ("Update note", $header_footer);
			msgForm (msg(47), "$back", "back");
			display_footer ($header_footer);
		}
	} else {
		$mail_reply = 0;
	}
	
# Check for required fields
# -------------------------
	while (list($field, $required) = each($bn_bind_var)) {
		if ($required && ($$field=="")) {
			display_header ("Update note", $header_footer);
			$mess = "$field : " . msg(5);
			msgForm ("$mess", "$back", "back");
			display_footer ($header_footer);
		}
	}

# save body (for later sending it without formatting) 
# ---------------------------------------------------
	if (!empty($body)) {
		$mailbody = stripslashes($body);
	}

# Handle attachment either uploaded from the browser or choosen on the server
# ---------------------------------------------------------------------------
	if (isSet($preview)) {
		$attachment = "none";
		$att_size = 0;
		$att_type = "unknown";

	} elseif ($bn_file_upload && ($pcfile_size > 0) && ($pcfile_size <= $MAX_FILE_SIZE) ) {
		$pcfile = ereg_replace ("\\\\\\\\", "/", $pcfile);
		$att_size = filesize ($pcfile);
		if ($att_size == $pcfile_size) {
			$attachment = ereg_replace (" ", "_", $pcfile_name);
			$att_type = (empty($pcfile_type)) ? "application/octet-stream" : $pcfile_type;
			@mkdir ("$bn_dir_notes/$key", _DIRMODE);
			copy ($pcfile, "$bn_dir_notes/$key/$attachment");
			dspMsg(37, "<center><b>file $pcfile_name uploaded ($pcfile_size bytes transfered)</b></center>");
		} else {
			$attachment = "none";
			$att_size = 0;
			$att_type = "unknown";
		}
		$rc = @unlink ($pcfile);

	} elseif ($bn_browse_server && !empty($server_file) ) {
		$file=eregi_replace ("^.:", "", $server_file);
		if (!ereg ("$bn_browse_dir", "$file")) {
			msgForm (msg (48), "$back", "back");
			display_footer ($header_footer);
		}
		$att_size = FileSize ($file);
		if (!$att_size) {
			msgForm (msg (8), "$back", "back");
			display_footer ($header_footer);
		}
		$attachment = basename($server_file);
		$rc=@mkdir ("$bn_dir_notes/$key", _DIRMODE);
		if (copy ("$server_file", "$bn_dir_notes/$key/$attachment")) {
			include "$inc_dir/mimetypes.$ext";
			$suffix = strtoLower(substr(strrchr( $attachment, "." ), 1 ));
			$att_type = (empty($mimetype[$suffix])) ? "application/octet-stream" : $mimetype[$suffix];
			dspMsg (38, "<center><b>file $attachment has been copied </b></center>");
		} else {
			$attachment ="none";
			$att_size = 0;
			$att_type = "unknown";
		}
	}

# Execute before_access program
# -----------------------------
	if ($bn_before_access)
		include "$bn_dir/$bn_before_access";

# populate the note array with all defined variables
# --------------------------------------------------

# update time stamp
	$unixdate = $now;

# variables handled by w-agora
	for (reset ($bn_var); $field=current($bn_var); next($bn_var)) {
		if (isset ($$field) ) {
			$$field=kill_html(chop(stripSlashes($$field)));
			$fields[$field]=$$field;
		}
	}

# user's defined variables
	for (reset ($db_var); $field=current($db_var); next($db_var)) {
		$$field=ereg_replace ("\\\\", "\\\\", chop(stripSlashes($$field)));
		if ($bn_allow_html && $bn_html_var[$field] && $html_tags) {
			$$field = strip_banned_tags($$field);
		} else {
			$$field = kill_html($$field);
		}
		if ($bn_auto_url && $bn_html_var[$field]) {
			$$field = checkURL ($$field);
		}
		if ($bn_use_smileys && $bn_html_var[$field]) {
			$$field = add_smileys($$field);
		}
		$fields[$field]=$$field;
	}

	display_header ("Update note", $header_footer);

# if Preview mode has been choosen then send the updated note to the browser
# --------------------------------------------------------------------------
	if (isSet ($preview)) {
		$formated_date = date ($bn_date_format, $unixdate);
		if (isSet($body)) {
			$body = format_text($body);
		}
		$doc=addSlashes(stripSlashes($bn_doc_var));
		eval ("echo stripSlashes(\"$doc\");");
# ... then display the form
# -------------------------
		echo "<hr>";
		reset ($fields);
		while ( list( $var, $val ) = each( $fields)) {
			if (is_string ($var)) {
				$$var = stripSlashes(my_br2nl($val));
				if ($bn_use_smileys && $bn_html_var[$var]) {
					$$var = strip_smileys($$var);
				}
				if ($bn_auto_url && $bn_html_var[$var]) {
					$$var = strip_url($$var);
				}
				$$var = kill_quotes($$var);
			}
		}
		$setUserField = false;		// don't reset username and password
		$form_action = "./update.$ext";
		$bn_action="edit";
		if (!isset($html_tags)) $html_tags=0;
		include "$inc_dir/form.$ext";
		display_footer ($header_footer);
	}
	
# ... else Update note in database
# --------------------------------
	$ret = $db->updateNote ($bn_db, $key, $password, $fields);
	if ($ret == -2) {
		msgForm (msg (12), "$back", "back");
		display_footer ($header_footer);
	} elseif ($ret < 0) {
		msgForm (msg (6), "$back", "back");
		display_footer ($header_footer);
	}

# update HTML document if static mode is set
# ------------------------------------------
	if ($bn_doc_type == "static") {
		$formated_date = date ($bn_date_format, $unixdate);
		if (!is_file("$bn_dir_notes/$filename")) {
			$filename = $unixdate. ".html";
			$fields["filename"]=$filename;
		}

		$fd = @fopen ("$bn_dir_notes/$filename", "w+");
		if (!$fd) {
			msgForm (msg (7), "$back", "back");
			display_footer ($header_footer);
		}
		$body = format_text($body);
		$doc=addSlashes(stripSlashes($bn_doc_var));
		eval ("\$tmp=stripSlashes(\"$doc\");");
		fputs ($fd, "$tmp");
		fclose ($fd);
	}

# Start search indexation if a search engine is configured
# --------------------------------------------------------
	if ($bn_search && ($bn_doc_type == "static") && ($bn_search_engine != "none") ) {
		include "$inc_dir/$bn_search_engine.$ext";
		$search->indexNotes();
	}

# send mail to the moderator
# --------------------------
	if ($bn_mail) {
		if (isset($subject)) {
			if (eregi ("^re: *(.*)", $subject, $split) ) {
				$mailsubject = "Re: [$bn] " . $split[1];
			} else {
				$mailsubject = "[$bn] $subject";
			}
			$mailsubject = stripSlashes($mailsubject);
		} else {
			$mailsubject = "[$bn] NO SUBJECT";
		}
		$body = "Note $key updated\n" . $bn_mail_text . "\n-------------------------\n" . $mailbody;
		$rc = @mail ($bn_admin_address, $mailsubject, $mailbody,
		      "From: $mailfrom\nX-Mailer: PHP " . phpversion() . " " . wa_version() . "\n" );
	}

# Displays success message then exit
# ----------------------------------
	$note=$key;
	msgForm (msg(59), "view.$ext?bn=$bn&key=$key", "close");
	display_footer ($header_footer);
?>
